import { useMergeRefs, FloatingPortal, FloatingFocusManager, useId, useFloating, autoUpdate, flip, offset, size, useRole, useDismiss, useListNavigation, useInteractions, shift, useClick } from '@floating-ui/react';
import Keyboard from 'keyboard-key';
import React6, { createContext, forwardRef, useMemo, useLayoutEffect, memo, useContext, useState, useRef, useEffect, Children, isValidElement, cloneElement, Fragment as Fragment$1, useCallback, createElement } from 'react';
import { cva } from 'class-variance-authority';
import clsx13 from 'clsx';
import { jsx, jsxs, Fragment } from 'react/jsx-runtime';
import { twMerge } from 'tailwind-merge';
import * as Headless11 from '@headlessui/react';
import { Transition, Dialog, Label as Label$1, DialogBackdrop, DialogPanel, DialogTitle, RadioGroup } from '@headlessui/react';
import { useSpring, animated } from 'react-spring';
import ResizeObserver from 'resize-observer-polyfill';

var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __commonJS = (cb, mod) => function __require() {
  return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));

// ../../node_modules/lodash/lodash.js
var require_lodash = __commonJS({
  "../../node_modules/lodash/lodash.js"(exports, module) {
    (function() {
      var undefined2;
      var VERSION = "4.17.21";
      var LARGE_ARRAY_SIZE = 200;
      var CORE_ERROR_TEXT = "Unsupported core-js use. Try https://npms.io/search?q=ponyfill.", FUNC_ERROR_TEXT = "Expected a function", INVALID_TEMPL_VAR_ERROR_TEXT = "Invalid `variable` option passed into `_.template`";
      var HASH_UNDEFINED = "__lodash_hash_undefined__";
      var MAX_MEMOIZE_SIZE = 500;
      var PLACEHOLDER = "__lodash_placeholder__";
      var CLONE_DEEP_FLAG = 1, CLONE_FLAT_FLAG = 2, CLONE_SYMBOLS_FLAG = 4;
      var COMPARE_PARTIAL_FLAG = 1, COMPARE_UNORDERED_FLAG = 2;
      var WRAP_BIND_FLAG = 1, WRAP_BIND_KEY_FLAG = 2, WRAP_CURRY_BOUND_FLAG = 4, WRAP_CURRY_FLAG = 8, WRAP_CURRY_RIGHT_FLAG = 16, WRAP_PARTIAL_FLAG = 32, WRAP_PARTIAL_RIGHT_FLAG = 64, WRAP_ARY_FLAG = 128, WRAP_REARG_FLAG = 256, WRAP_FLIP_FLAG = 512;
      var DEFAULT_TRUNC_LENGTH = 30, DEFAULT_TRUNC_OMISSION = "...";
      var HOT_COUNT = 800, HOT_SPAN = 16;
      var LAZY_FILTER_FLAG = 1, LAZY_MAP_FLAG = 2, LAZY_WHILE_FLAG = 3;
      var INFINITY = 1 / 0, MAX_SAFE_INTEGER = 9007199254740991, MAX_INTEGER = 17976931348623157e292, NAN = 0 / 0;
      var MAX_ARRAY_LENGTH = 4294967295, MAX_ARRAY_INDEX = MAX_ARRAY_LENGTH - 1, HALF_MAX_ARRAY_LENGTH = MAX_ARRAY_LENGTH >>> 1;
      var wrapFlags = [
        ["ary", WRAP_ARY_FLAG],
        ["bind", WRAP_BIND_FLAG],
        ["bindKey", WRAP_BIND_KEY_FLAG],
        ["curry", WRAP_CURRY_FLAG],
        ["curryRight", WRAP_CURRY_RIGHT_FLAG],
        ["flip", WRAP_FLIP_FLAG],
        ["partial", WRAP_PARTIAL_FLAG],
        ["partialRight", WRAP_PARTIAL_RIGHT_FLAG],
        ["rearg", WRAP_REARG_FLAG]
      ];
      var argsTag = "[object Arguments]", arrayTag = "[object Array]", asyncTag = "[object AsyncFunction]", boolTag = "[object Boolean]", dateTag = "[object Date]", domExcTag = "[object DOMException]", errorTag = "[object Error]", funcTag = "[object Function]", genTag = "[object GeneratorFunction]", mapTag = "[object Map]", numberTag = "[object Number]", nullTag = "[object Null]", objectTag = "[object Object]", promiseTag = "[object Promise]", proxyTag = "[object Proxy]", regexpTag = "[object RegExp]", setTag = "[object Set]", stringTag = "[object String]", symbolTag = "[object Symbol]", undefinedTag = "[object Undefined]", weakMapTag = "[object WeakMap]", weakSetTag = "[object WeakSet]";
      var arrayBufferTag = "[object ArrayBuffer]", dataViewTag = "[object DataView]", float32Tag = "[object Float32Array]", float64Tag = "[object Float64Array]", int8Tag = "[object Int8Array]", int16Tag = "[object Int16Array]", int32Tag = "[object Int32Array]", uint8Tag = "[object Uint8Array]", uint8ClampedTag = "[object Uint8ClampedArray]", uint16Tag = "[object Uint16Array]", uint32Tag = "[object Uint32Array]";
      var reEmptyStringLeading = /\b__p \+= '';/g, reEmptyStringMiddle = /\b(__p \+=) '' \+/g, reEmptyStringTrailing = /(__e\(.*?\)|\b__t\)) \+\n'';/g;
      var reEscapedHtml = /&(?:amp|lt|gt|quot|#39);/g, reUnescapedHtml = /[&<>"']/g, reHasEscapedHtml = RegExp(reEscapedHtml.source), reHasUnescapedHtml = RegExp(reUnescapedHtml.source);
      var reEscape = /<%-([\s\S]+?)%>/g, reEvaluate = /<%([\s\S]+?)%>/g, reInterpolate = /<%=([\s\S]+?)%>/g;
      var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, reIsPlainProp = /^\w*$/, rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;
      var reRegExpChar = /[\\^$.*+?()[\]{}|]/g, reHasRegExpChar = RegExp(reRegExpChar.source);
      var reTrimStart = /^\s+/;
      var reWhitespace = /\s/;
      var reWrapComment = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, reWrapDetails = /\{\n\/\* \[wrapped with (.+)\] \*/, reSplitDetails = /,? & /;
      var reAsciiWord = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g;
      var reForbiddenIdentifierChars = /[()=,{}\[\]\/\s]/;
      var reEscapeChar = /\\(\\)?/g;
      var reEsTemplate = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g;
      var reFlags = /\w*$/;
      var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;
      var reIsBinary = /^0b[01]+$/i;
      var reIsHostCtor = /^\[object .+?Constructor\]$/;
      var reIsOctal = /^0o[0-7]+$/i;
      var reIsUint = /^(?:0|[1-9]\d*)$/;
      var reLatin = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g;
      var reNoMatch = /($^)/;
      var reUnescapedString = /['\n\r\u2028\u2029\\]/g;
      var rsAstralRange = "\\ud800-\\udfff", rsComboMarksRange = "\\u0300-\\u036f", reComboHalfMarksRange = "\\ufe20-\\ufe2f", rsComboSymbolsRange = "\\u20d0-\\u20ff", rsComboRange = rsComboMarksRange + reComboHalfMarksRange + rsComboSymbolsRange, rsDingbatRange = "\\u2700-\\u27bf", rsLowerRange = "a-z\\xdf-\\xf6\\xf8-\\xff", rsMathOpRange = "\\xac\\xb1\\xd7\\xf7", rsNonCharRange = "\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf", rsPunctuationRange = "\\u2000-\\u206f", rsSpaceRange = " \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000", rsUpperRange = "A-Z\\xc0-\\xd6\\xd8-\\xde", rsVarRange = "\\ufe0e\\ufe0f", rsBreakRange = rsMathOpRange + rsNonCharRange + rsPunctuationRange + rsSpaceRange;
      var rsApos = "['\u2019]", rsAstral = "[" + rsAstralRange + "]", rsBreak = "[" + rsBreakRange + "]", rsCombo = "[" + rsComboRange + "]", rsDigits = "\\d+", rsDingbat = "[" + rsDingbatRange + "]", rsLower = "[" + rsLowerRange + "]", rsMisc = "[^" + rsAstralRange + rsBreakRange + rsDigits + rsDingbatRange + rsLowerRange + rsUpperRange + "]", rsFitz = "\\ud83c[\\udffb-\\udfff]", rsModifier = "(?:" + rsCombo + "|" + rsFitz + ")", rsNonAstral = "[^" + rsAstralRange + "]", rsRegional = "(?:\\ud83c[\\udde6-\\uddff]){2}", rsSurrPair = "[\\ud800-\\udbff][\\udc00-\\udfff]", rsUpper = "[" + rsUpperRange + "]", rsZWJ = "\\u200d";
      var rsMiscLower = "(?:" + rsLower + "|" + rsMisc + ")", rsMiscUpper = "(?:" + rsUpper + "|" + rsMisc + ")", rsOptContrLower = "(?:" + rsApos + "(?:d|ll|m|re|s|t|ve))?", rsOptContrUpper = "(?:" + rsApos + "(?:D|LL|M|RE|S|T|VE))?", reOptMod = rsModifier + "?", rsOptVar = "[" + rsVarRange + "]?", rsOptJoin = "(?:" + rsZWJ + "(?:" + [rsNonAstral, rsRegional, rsSurrPair].join("|") + ")" + rsOptVar + reOptMod + ")*", rsOrdLower = "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])", rsOrdUpper = "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])", rsSeq = rsOptVar + reOptMod + rsOptJoin, rsEmoji = "(?:" + [rsDingbat, rsRegional, rsSurrPair].join("|") + ")" + rsSeq, rsSymbol = "(?:" + [rsNonAstral + rsCombo + "?", rsCombo, rsRegional, rsSurrPair, rsAstral].join("|") + ")";
      var reApos = RegExp(rsApos, "g");
      var reComboMark = RegExp(rsCombo, "g");
      var reUnicode = RegExp(rsFitz + "(?=" + rsFitz + ")|" + rsSymbol + rsSeq, "g");
      var reUnicodeWord = RegExp([
        rsUpper + "?" + rsLower + "+" + rsOptContrLower + "(?=" + [rsBreak, rsUpper, "$"].join("|") + ")",
        rsMiscUpper + "+" + rsOptContrUpper + "(?=" + [rsBreak, rsUpper + rsMiscLower, "$"].join("|") + ")",
        rsUpper + "?" + rsMiscLower + "+" + rsOptContrLower,
        rsUpper + "+" + rsOptContrUpper,
        rsOrdUpper,
        rsOrdLower,
        rsDigits,
        rsEmoji
      ].join("|"), "g");
      var reHasUnicode = RegExp("[" + rsZWJ + rsAstralRange + rsComboRange + rsVarRange + "]");
      var reHasUnicodeWord = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/;
      var contextProps = [
        "Array",
        "Buffer",
        "DataView",
        "Date",
        "Error",
        "Float32Array",
        "Float64Array",
        "Function",
        "Int8Array",
        "Int16Array",
        "Int32Array",
        "Map",
        "Math",
        "Object",
        "Promise",
        "RegExp",
        "Set",
        "String",
        "Symbol",
        "TypeError",
        "Uint8Array",
        "Uint8ClampedArray",
        "Uint16Array",
        "Uint32Array",
        "WeakMap",
        "_",
        "clearTimeout",
        "isFinite",
        "parseInt",
        "setTimeout"
      ];
      var templateCounter = -1;
      var typedArrayTags = {};
      typedArrayTags[float32Tag] = typedArrayTags[float64Tag] = typedArrayTags[int8Tag] = typedArrayTags[int16Tag] = typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] = typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] = typedArrayTags[uint32Tag] = true;
      typedArrayTags[argsTag] = typedArrayTags[arrayTag] = typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] = typedArrayTags[dataViewTag] = typedArrayTags[dateTag] = typedArrayTags[errorTag] = typedArrayTags[funcTag] = typedArrayTags[mapTag] = typedArrayTags[numberTag] = typedArrayTags[objectTag] = typedArrayTags[regexpTag] = typedArrayTags[setTag] = typedArrayTags[stringTag] = typedArrayTags[weakMapTag] = false;
      var cloneableTags = {};
      cloneableTags[argsTag] = cloneableTags[arrayTag] = cloneableTags[arrayBufferTag] = cloneableTags[dataViewTag] = cloneableTags[boolTag] = cloneableTags[dateTag] = cloneableTags[float32Tag] = cloneableTags[float64Tag] = cloneableTags[int8Tag] = cloneableTags[int16Tag] = cloneableTags[int32Tag] = cloneableTags[mapTag] = cloneableTags[numberTag] = cloneableTags[objectTag] = cloneableTags[regexpTag] = cloneableTags[setTag] = cloneableTags[stringTag] = cloneableTags[symbolTag] = cloneableTags[uint8Tag] = cloneableTags[uint8ClampedTag] = cloneableTags[uint16Tag] = cloneableTags[uint32Tag] = true;
      cloneableTags[errorTag] = cloneableTags[funcTag] = cloneableTags[weakMapTag] = false;
      var deburredLetters = {
        // Latin-1 Supplement block.
        "\xC0": "A",
        "\xC1": "A",
        "\xC2": "A",
        "\xC3": "A",
        "\xC4": "A",
        "\xC5": "A",
        "\xE0": "a",
        "\xE1": "a",
        "\xE2": "a",
        "\xE3": "a",
        "\xE4": "a",
        "\xE5": "a",
        "\xC7": "C",
        "\xE7": "c",
        "\xD0": "D",
        "\xF0": "d",
        "\xC8": "E",
        "\xC9": "E",
        "\xCA": "E",
        "\xCB": "E",
        "\xE8": "e",
        "\xE9": "e",
        "\xEA": "e",
        "\xEB": "e",
        "\xCC": "I",
        "\xCD": "I",
        "\xCE": "I",
        "\xCF": "I",
        "\xEC": "i",
        "\xED": "i",
        "\xEE": "i",
        "\xEF": "i",
        "\xD1": "N",
        "\xF1": "n",
        "\xD2": "O",
        "\xD3": "O",
        "\xD4": "O",
        "\xD5": "O",
        "\xD6": "O",
        "\xD8": "O",
        "\xF2": "o",
        "\xF3": "o",
        "\xF4": "o",
        "\xF5": "o",
        "\xF6": "o",
        "\xF8": "o",
        "\xD9": "U",
        "\xDA": "U",
        "\xDB": "U",
        "\xDC": "U",
        "\xF9": "u",
        "\xFA": "u",
        "\xFB": "u",
        "\xFC": "u",
        "\xDD": "Y",
        "\xFD": "y",
        "\xFF": "y",
        "\xC6": "Ae",
        "\xE6": "ae",
        "\xDE": "Th",
        "\xFE": "th",
        "\xDF": "ss",
        // Latin Extended-A block.
        "\u0100": "A",
        "\u0102": "A",
        "\u0104": "A",
        "\u0101": "a",
        "\u0103": "a",
        "\u0105": "a",
        "\u0106": "C",
        "\u0108": "C",
        "\u010A": "C",
        "\u010C": "C",
        "\u0107": "c",
        "\u0109": "c",
        "\u010B": "c",
        "\u010D": "c",
        "\u010E": "D",
        "\u0110": "D",
        "\u010F": "d",
        "\u0111": "d",
        "\u0112": "E",
        "\u0114": "E",
        "\u0116": "E",
        "\u0118": "E",
        "\u011A": "E",
        "\u0113": "e",
        "\u0115": "e",
        "\u0117": "e",
        "\u0119": "e",
        "\u011B": "e",
        "\u011C": "G",
        "\u011E": "G",
        "\u0120": "G",
        "\u0122": "G",
        "\u011D": "g",
        "\u011F": "g",
        "\u0121": "g",
        "\u0123": "g",
        "\u0124": "H",
        "\u0126": "H",
        "\u0125": "h",
        "\u0127": "h",
        "\u0128": "I",
        "\u012A": "I",
        "\u012C": "I",
        "\u012E": "I",
        "\u0130": "I",
        "\u0129": "i",
        "\u012B": "i",
        "\u012D": "i",
        "\u012F": "i",
        "\u0131": "i",
        "\u0134": "J",
        "\u0135": "j",
        "\u0136": "K",
        "\u0137": "k",
        "\u0138": "k",
        "\u0139": "L",
        "\u013B": "L",
        "\u013D": "L",
        "\u013F": "L",
        "\u0141": "L",
        "\u013A": "l",
        "\u013C": "l",
        "\u013E": "l",
        "\u0140": "l",
        "\u0142": "l",
        "\u0143": "N",
        "\u0145": "N",
        "\u0147": "N",
        "\u014A": "N",
        "\u0144": "n",
        "\u0146": "n",
        "\u0148": "n",
        "\u014B": "n",
        "\u014C": "O",
        "\u014E": "O",
        "\u0150": "O",
        "\u014D": "o",
        "\u014F": "o",
        "\u0151": "o",
        "\u0154": "R",
        "\u0156": "R",
        "\u0158": "R",
        "\u0155": "r",
        "\u0157": "r",
        "\u0159": "r",
        "\u015A": "S",
        "\u015C": "S",
        "\u015E": "S",
        "\u0160": "S",
        "\u015B": "s",
        "\u015D": "s",
        "\u015F": "s",
        "\u0161": "s",
        "\u0162": "T",
        "\u0164": "T",
        "\u0166": "T",
        "\u0163": "t",
        "\u0165": "t",
        "\u0167": "t",
        "\u0168": "U",
        "\u016A": "U",
        "\u016C": "U",
        "\u016E": "U",
        "\u0170": "U",
        "\u0172": "U",
        "\u0169": "u",
        "\u016B": "u",
        "\u016D": "u",
        "\u016F": "u",
        "\u0171": "u",
        "\u0173": "u",
        "\u0174": "W",
        "\u0175": "w",
        "\u0176": "Y",
        "\u0177": "y",
        "\u0178": "Y",
        "\u0179": "Z",
        "\u017B": "Z",
        "\u017D": "Z",
        "\u017A": "z",
        "\u017C": "z",
        "\u017E": "z",
        "\u0132": "IJ",
        "\u0133": "ij",
        "\u0152": "Oe",
        "\u0153": "oe",
        "\u0149": "'n",
        "\u017F": "s"
      };
      var htmlEscapes = {
        "&": "&amp;",
        "<": "&lt;",
        ">": "&gt;",
        '"': "&quot;",
        "'": "&#39;"
      };
      var htmlUnescapes = {
        "&amp;": "&",
        "&lt;": "<",
        "&gt;": ">",
        "&quot;": '"',
        "&#39;": "'"
      };
      var stringEscapes = {
        "\\": "\\",
        "'": "'",
        "\n": "n",
        "\r": "r",
        "\u2028": "u2028",
        "\u2029": "u2029"
      };
      var freeParseFloat = parseFloat, freeParseInt = parseInt;
      var freeGlobal = typeof global == "object" && global && global.Object === Object && global;
      var freeSelf = typeof self == "object" && self && self.Object === Object && self;
      var root = freeGlobal || freeSelf || Function("return this")();
      var freeExports = typeof exports == "object" && exports && !exports.nodeType && exports;
      var freeModule = freeExports && typeof module == "object" && module && !module.nodeType && module;
      var moduleExports = freeModule && freeModule.exports === freeExports;
      var freeProcess = moduleExports && freeGlobal.process;
      var nodeUtil = function() {
        try {
          var types = freeModule && freeModule.require && freeModule.require("util").types;
          if (types) {
            return types;
          }
          return freeProcess && freeProcess.binding && freeProcess.binding("util");
        } catch (e) {
        }
      }();
      var nodeIsArrayBuffer = nodeUtil && nodeUtil.isArrayBuffer, nodeIsDate = nodeUtil && nodeUtil.isDate, nodeIsMap = nodeUtil && nodeUtil.isMap, nodeIsRegExp = nodeUtil && nodeUtil.isRegExp, nodeIsSet = nodeUtil && nodeUtil.isSet, nodeIsTypedArray = nodeUtil && nodeUtil.isTypedArray;
      function apply(func, thisArg, args) {
        switch (args.length) {
          case 0:
            return func.call(thisArg);
          case 1:
            return func.call(thisArg, args[0]);
          case 2:
            return func.call(thisArg, args[0], args[1]);
          case 3:
            return func.call(thisArg, args[0], args[1], args[2]);
        }
        return func.apply(thisArg, args);
      }
      function arrayAggregator(array, setter, iteratee, accumulator) {
        var index = -1, length = array == null ? 0 : array.length;
        while (++index < length) {
          var value = array[index];
          setter(accumulator, value, iteratee(value), array);
        }
        return accumulator;
      }
      function arrayEach(array, iteratee) {
        var index = -1, length = array == null ? 0 : array.length;
        while (++index < length) {
          if (iteratee(array[index], index, array) === false) {
            break;
          }
        }
        return array;
      }
      function arrayEachRight(array, iteratee) {
        var length = array == null ? 0 : array.length;
        while (length--) {
          if (iteratee(array[length], length, array) === false) {
            break;
          }
        }
        return array;
      }
      function arrayEvery(array, predicate) {
        var index = -1, length = array == null ? 0 : array.length;
        while (++index < length) {
          if (!predicate(array[index], index, array)) {
            return false;
          }
        }
        return true;
      }
      function arrayFilter(array, predicate) {
        var index = -1, length = array == null ? 0 : array.length, resIndex = 0, result = [];
        while (++index < length) {
          var value = array[index];
          if (predicate(value, index, array)) {
            result[resIndex++] = value;
          }
        }
        return result;
      }
      function arrayIncludes(array, value) {
        var length = array == null ? 0 : array.length;
        return !!length && baseIndexOf(array, value, 0) > -1;
      }
      function arrayIncludesWith(array, value, comparator) {
        var index = -1, length = array == null ? 0 : array.length;
        while (++index < length) {
          if (comparator(value, array[index])) {
            return true;
          }
        }
        return false;
      }
      function arrayMap(array, iteratee) {
        var index = -1, length = array == null ? 0 : array.length, result = Array(length);
        while (++index < length) {
          result[index] = iteratee(array[index], index, array);
        }
        return result;
      }
      function arrayPush(array, values) {
        var index = -1, length = values.length, offset3 = array.length;
        while (++index < length) {
          array[offset3 + index] = values[index];
        }
        return array;
      }
      function arrayReduce(array, iteratee, accumulator, initAccum) {
        var index = -1, length = array == null ? 0 : array.length;
        if (initAccum && length) {
          accumulator = array[++index];
        }
        while (++index < length) {
          accumulator = iteratee(accumulator, array[index], index, array);
        }
        return accumulator;
      }
      function arrayReduceRight(array, iteratee, accumulator, initAccum) {
        var length = array == null ? 0 : array.length;
        if (initAccum && length) {
          accumulator = array[--length];
        }
        while (length--) {
          accumulator = iteratee(accumulator, array[length], length, array);
        }
        return accumulator;
      }
      function arraySome(array, predicate) {
        var index = -1, length = array == null ? 0 : array.length;
        while (++index < length) {
          if (predicate(array[index], index, array)) {
            return true;
          }
        }
        return false;
      }
      var asciiSize = baseProperty("length");
      function asciiToArray(string) {
        return string.split("");
      }
      function asciiWords(string) {
        return string.match(reAsciiWord) || [];
      }
      function baseFindKey(collection, predicate, eachFunc) {
        var result;
        eachFunc(collection, function(value, key, collection2) {
          if (predicate(value, key, collection2)) {
            result = key;
            return false;
          }
        });
        return result;
      }
      function baseFindIndex(array, predicate, fromIndex, fromRight) {
        var length = array.length, index = fromIndex + (fromRight ? 1 : -1);
        while (fromRight ? index-- : ++index < length) {
          if (predicate(array[index], index, array)) {
            return index;
          }
        }
        return -1;
      }
      function baseIndexOf(array, value, fromIndex) {
        return value === value ? strictIndexOf(array, value, fromIndex) : baseFindIndex(array, baseIsNaN, fromIndex);
      }
      function baseIndexOfWith(array, value, fromIndex, comparator) {
        var index = fromIndex - 1, length = array.length;
        while (++index < length) {
          if (comparator(array[index], value)) {
            return index;
          }
        }
        return -1;
      }
      function baseIsNaN(value) {
        return value !== value;
      }
      function baseMean(array, iteratee) {
        var length = array == null ? 0 : array.length;
        return length ? baseSum(array, iteratee) / length : NAN;
      }
      function baseProperty(key) {
        return function(object) {
          return object == null ? undefined2 : object[key];
        };
      }
      function basePropertyOf(object) {
        return function(key) {
          return object == null ? undefined2 : object[key];
        };
      }
      function baseReduce(collection, iteratee, accumulator, initAccum, eachFunc) {
        eachFunc(collection, function(value, index, collection2) {
          accumulator = initAccum ? (initAccum = false, value) : iteratee(accumulator, value, index, collection2);
        });
        return accumulator;
      }
      function baseSortBy(array, comparer) {
        var length = array.length;
        array.sort(comparer);
        while (length--) {
          array[length] = array[length].value;
        }
        return array;
      }
      function baseSum(array, iteratee) {
        var result, index = -1, length = array.length;
        while (++index < length) {
          var current = iteratee(array[index]);
          if (current !== undefined2) {
            result = result === undefined2 ? current : result + current;
          }
        }
        return result;
      }
      function baseTimes(n, iteratee) {
        var index = -1, result = Array(n);
        while (++index < n) {
          result[index] = iteratee(index);
        }
        return result;
      }
      function baseToPairs(object, props) {
        return arrayMap(props, function(key) {
          return [key, object[key]];
        });
      }
      function baseTrim(string) {
        return string ? string.slice(0, trimmedEndIndex(string) + 1).replace(reTrimStart, "") : string;
      }
      function baseUnary(func) {
        return function(value) {
          return func(value);
        };
      }
      function baseValues(object, props) {
        return arrayMap(props, function(key) {
          return object[key];
        });
      }
      function cacheHas(cache, key) {
        return cache.has(key);
      }
      function charsStartIndex(strSymbols, chrSymbols) {
        var index = -1, length = strSymbols.length;
        while (++index < length && baseIndexOf(chrSymbols, strSymbols[index], 0) > -1) {
        }
        return index;
      }
      function charsEndIndex(strSymbols, chrSymbols) {
        var index = strSymbols.length;
        while (index-- && baseIndexOf(chrSymbols, strSymbols[index], 0) > -1) {
        }
        return index;
      }
      function countHolders(array, placeholder) {
        var length = array.length, result = 0;
        while (length--) {
          if (array[length] === placeholder) {
            ++result;
          }
        }
        return result;
      }
      var deburrLetter = basePropertyOf(deburredLetters);
      var escapeHtmlChar = basePropertyOf(htmlEscapes);
      function escapeStringChar(chr) {
        return "\\" + stringEscapes[chr];
      }
      function getValue(object, key) {
        return object == null ? undefined2 : object[key];
      }
      function hasUnicode(string) {
        return reHasUnicode.test(string);
      }
      function hasUnicodeWord(string) {
        return reHasUnicodeWord.test(string);
      }
      function iteratorToArray(iterator) {
        var data, result = [];
        while (!(data = iterator.next()).done) {
          result.push(data.value);
        }
        return result;
      }
      function mapToArray(map) {
        var index = -1, result = Array(map.size);
        map.forEach(function(value, key) {
          result[++index] = [key, value];
        });
        return result;
      }
      function overArg(func, transform) {
        return function(arg) {
          return func(transform(arg));
        };
      }
      function replaceHolders(array, placeholder) {
        var index = -1, length = array.length, resIndex = 0, result = [];
        while (++index < length) {
          var value = array[index];
          if (value === placeholder || value === PLACEHOLDER) {
            array[index] = PLACEHOLDER;
            result[resIndex++] = index;
          }
        }
        return result;
      }
      function setToArray(set) {
        var index = -1, result = Array(set.size);
        set.forEach(function(value) {
          result[++index] = value;
        });
        return result;
      }
      function setToPairs(set) {
        var index = -1, result = Array(set.size);
        set.forEach(function(value) {
          result[++index] = [value, value];
        });
        return result;
      }
      function strictIndexOf(array, value, fromIndex) {
        var index = fromIndex - 1, length = array.length;
        while (++index < length) {
          if (array[index] === value) {
            return index;
          }
        }
        return -1;
      }
      function strictLastIndexOf(array, value, fromIndex) {
        var index = fromIndex + 1;
        while (index--) {
          if (array[index] === value) {
            return index;
          }
        }
        return index;
      }
      function stringSize(string) {
        return hasUnicode(string) ? unicodeSize(string) : asciiSize(string);
      }
      function stringToArray(string) {
        return hasUnicode(string) ? unicodeToArray(string) : asciiToArray(string);
      }
      function trimmedEndIndex(string) {
        var index = string.length;
        while (index-- && reWhitespace.test(string.charAt(index))) {
        }
        return index;
      }
      var unescapeHtmlChar = basePropertyOf(htmlUnescapes);
      function unicodeSize(string) {
        var result = reUnicode.lastIndex = 0;
        while (reUnicode.test(string)) {
          ++result;
        }
        return result;
      }
      function unicodeToArray(string) {
        return string.match(reUnicode) || [];
      }
      function unicodeWords(string) {
        return string.match(reUnicodeWord) || [];
      }
      var runInContext = function runInContext2(context) {
        context = context == null ? root : _.defaults(root.Object(), context, _.pick(root, contextProps));
        var Array2 = context.Array, Date2 = context.Date, Error3 = context.Error, Function2 = context.Function, Math2 = context.Math, Object2 = context.Object, RegExp2 = context.RegExp, String2 = context.String, TypeError2 = context.TypeError;
        var arrayProto = Array2.prototype, funcProto = Function2.prototype, objectProto = Object2.prototype;
        var coreJsData = context["__core-js_shared__"];
        var funcToString = funcProto.toString;
        var hasOwnProperty = objectProto.hasOwnProperty;
        var idCounter = 0;
        var maskSrcKey = function() {
          var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || "");
          return uid ? "Symbol(src)_1." + uid : "";
        }();
        var nativeObjectToString = objectProto.toString;
        var objectCtorString = funcToString.call(Object2);
        var oldDash = root._;
        var reIsNative = RegExp2(
          "^" + funcToString.call(hasOwnProperty).replace(reRegExpChar, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"
        );
        var Buffer2 = moduleExports ? context.Buffer : undefined2, Symbol2 = context.Symbol, Uint8Array2 = context.Uint8Array, allocUnsafe = Buffer2 ? Buffer2.allocUnsafe : undefined2, getPrototype = overArg(Object2.getPrototypeOf, Object2), objectCreate = Object2.create, propertyIsEnumerable = objectProto.propertyIsEnumerable, splice = arrayProto.splice, spreadableSymbol = Symbol2 ? Symbol2.isConcatSpreadable : undefined2, symIterator = Symbol2 ? Symbol2.iterator : undefined2, symToStringTag = Symbol2 ? Symbol2.toStringTag : undefined2;
        var defineProperty = function() {
          try {
            var func = getNative(Object2, "defineProperty");
            func({}, "", {});
            return func;
          } catch (e) {
          }
        }();
        var ctxClearTimeout = context.clearTimeout !== root.clearTimeout && context.clearTimeout, ctxNow = Date2 && Date2.now !== root.Date.now && Date2.now, ctxSetTimeout = context.setTimeout !== root.setTimeout && context.setTimeout;
        var nativeCeil = Math2.ceil, nativeFloor = Math2.floor, nativeGetSymbols = Object2.getOwnPropertySymbols, nativeIsBuffer = Buffer2 ? Buffer2.isBuffer : undefined2, nativeIsFinite = context.isFinite, nativeJoin = arrayProto.join, nativeKeys = overArg(Object2.keys, Object2), nativeMax = Math2.max, nativeMin = Math2.min, nativeNow = Date2.now, nativeParseInt = context.parseInt, nativeRandom = Math2.random, nativeReverse = arrayProto.reverse;
        var DataView = getNative(context, "DataView"), Map2 = getNative(context, "Map"), Promise2 = getNative(context, "Promise"), Set = getNative(context, "Set"), WeakMap = getNative(context, "WeakMap"), nativeCreate = getNative(Object2, "create");
        var metaMap = WeakMap && new WeakMap();
        var realNames = {};
        var dataViewCtorString = toSource(DataView), mapCtorString = toSource(Map2), promiseCtorString = toSource(Promise2), setCtorString = toSource(Set), weakMapCtorString = toSource(WeakMap);
        var symbolProto = Symbol2 ? Symbol2.prototype : undefined2, symbolValueOf = symbolProto ? symbolProto.valueOf : undefined2, symbolToString = symbolProto ? symbolProto.toString : undefined2;
        function lodash(value) {
          if (isObjectLike(value) && !isArray(value) && !(value instanceof LazyWrapper)) {
            if (value instanceof LodashWrapper) {
              return value;
            }
            if (hasOwnProperty.call(value, "__wrapped__")) {
              return wrapperClone(value);
            }
          }
          return new LodashWrapper(value);
        }
        var baseCreate = /* @__PURE__ */ function() {
          function object() {
          }
          return function(proto) {
            if (!isObject(proto)) {
              return {};
            }
            if (objectCreate) {
              return objectCreate(proto);
            }
            object.prototype = proto;
            var result2 = new object();
            object.prototype = undefined2;
            return result2;
          };
        }();
        function baseLodash() {
        }
        function LodashWrapper(value, chainAll) {
          this.__wrapped__ = value;
          this.__actions__ = [];
          this.__chain__ = !!chainAll;
          this.__index__ = 0;
          this.__values__ = undefined2;
        }
        lodash.templateSettings = {
          /**
           * Used to detect `data` property values to be HTML-escaped.
           *
           * @memberOf _.templateSettings
           * @type {RegExp}
           */
          "escape": reEscape,
          /**
           * Used to detect code to be evaluated.
           *
           * @memberOf _.templateSettings
           * @type {RegExp}
           */
          "evaluate": reEvaluate,
          /**
           * Used to detect `data` property values to inject.
           *
           * @memberOf _.templateSettings
           * @type {RegExp}
           */
          "interpolate": reInterpolate,
          /**
           * Used to reference the data object in the template text.
           *
           * @memberOf _.templateSettings
           * @type {string}
           */
          "variable": "",
          /**
           * Used to import variables into the compiled template.
           *
           * @memberOf _.templateSettings
           * @type {Object}
           */
          "imports": {
            /**
             * A reference to the `lodash` function.
             *
             * @memberOf _.templateSettings.imports
             * @type {Function}
             */
            "_": lodash
          }
        };
        lodash.prototype = baseLodash.prototype;
        lodash.prototype.constructor = lodash;
        LodashWrapper.prototype = baseCreate(baseLodash.prototype);
        LodashWrapper.prototype.constructor = LodashWrapper;
        function LazyWrapper(value) {
          this.__wrapped__ = value;
          this.__actions__ = [];
          this.__dir__ = 1;
          this.__filtered__ = false;
          this.__iteratees__ = [];
          this.__takeCount__ = MAX_ARRAY_LENGTH;
          this.__views__ = [];
        }
        function lazyClone() {
          var result2 = new LazyWrapper(this.__wrapped__);
          result2.__actions__ = copyArray(this.__actions__);
          result2.__dir__ = this.__dir__;
          result2.__filtered__ = this.__filtered__;
          result2.__iteratees__ = copyArray(this.__iteratees__);
          result2.__takeCount__ = this.__takeCount__;
          result2.__views__ = copyArray(this.__views__);
          return result2;
        }
        function lazyReverse() {
          if (this.__filtered__) {
            var result2 = new LazyWrapper(this);
            result2.__dir__ = -1;
            result2.__filtered__ = true;
          } else {
            result2 = this.clone();
            result2.__dir__ *= -1;
          }
          return result2;
        }
        function lazyValue() {
          var array = this.__wrapped__.value(), dir = this.__dir__, isArr = isArray(array), isRight = dir < 0, arrLength = isArr ? array.length : 0, view = getView(0, arrLength, this.__views__), start = view.start, end = view.end, length = end - start, index = isRight ? end : start - 1, iteratees = this.__iteratees__, iterLength = iteratees.length, resIndex = 0, takeCount = nativeMin(length, this.__takeCount__);
          if (!isArr || !isRight && arrLength == length && takeCount == length) {
            return baseWrapperValue(array, this.__actions__);
          }
          var result2 = [];
          outer:
            while (length-- && resIndex < takeCount) {
              index += dir;
              var iterIndex = -1, value = array[index];
              while (++iterIndex < iterLength) {
                var data = iteratees[iterIndex], iteratee2 = data.iteratee, type = data.type, computed = iteratee2(value);
                if (type == LAZY_MAP_FLAG) {
                  value = computed;
                } else if (!computed) {
                  if (type == LAZY_FILTER_FLAG) {
                    continue outer;
                  } else {
                    break outer;
                  }
                }
              }
              result2[resIndex++] = value;
            }
          return result2;
        }
        LazyWrapper.prototype = baseCreate(baseLodash.prototype);
        LazyWrapper.prototype.constructor = LazyWrapper;
        function Hash(entries) {
          var index = -1, length = entries == null ? 0 : entries.length;
          this.clear();
          while (++index < length) {
            var entry = entries[index];
            this.set(entry[0], entry[1]);
          }
        }
        function hashClear() {
          this.__data__ = nativeCreate ? nativeCreate(null) : {};
          this.size = 0;
        }
        function hashDelete(key) {
          var result2 = this.has(key) && delete this.__data__[key];
          this.size -= result2 ? 1 : 0;
          return result2;
        }
        function hashGet(key) {
          var data = this.__data__;
          if (nativeCreate) {
            var result2 = data[key];
            return result2 === HASH_UNDEFINED ? undefined2 : result2;
          }
          return hasOwnProperty.call(data, key) ? data[key] : undefined2;
        }
        function hashHas(key) {
          var data = this.__data__;
          return nativeCreate ? data[key] !== undefined2 : hasOwnProperty.call(data, key);
        }
        function hashSet(key, value) {
          var data = this.__data__;
          this.size += this.has(key) ? 0 : 1;
          data[key] = nativeCreate && value === undefined2 ? HASH_UNDEFINED : value;
          return this;
        }
        Hash.prototype.clear = hashClear;
        Hash.prototype["delete"] = hashDelete;
        Hash.prototype.get = hashGet;
        Hash.prototype.has = hashHas;
        Hash.prototype.set = hashSet;
        function ListCache(entries) {
          var index = -1, length = entries == null ? 0 : entries.length;
          this.clear();
          while (++index < length) {
            var entry = entries[index];
            this.set(entry[0], entry[1]);
          }
        }
        function listCacheClear() {
          this.__data__ = [];
          this.size = 0;
        }
        function listCacheDelete(key) {
          var data = this.__data__, index = assocIndexOf(data, key);
          if (index < 0) {
            return false;
          }
          var lastIndex = data.length - 1;
          if (index == lastIndex) {
            data.pop();
          } else {
            splice.call(data, index, 1);
          }
          --this.size;
          return true;
        }
        function listCacheGet(key) {
          var data = this.__data__, index = assocIndexOf(data, key);
          return index < 0 ? undefined2 : data[index][1];
        }
        function listCacheHas(key) {
          return assocIndexOf(this.__data__, key) > -1;
        }
        function listCacheSet(key, value) {
          var data = this.__data__, index = assocIndexOf(data, key);
          if (index < 0) {
            ++this.size;
            data.push([key, value]);
          } else {
            data[index][1] = value;
          }
          return this;
        }
        ListCache.prototype.clear = listCacheClear;
        ListCache.prototype["delete"] = listCacheDelete;
        ListCache.prototype.get = listCacheGet;
        ListCache.prototype.has = listCacheHas;
        ListCache.prototype.set = listCacheSet;
        function MapCache(entries) {
          var index = -1, length = entries == null ? 0 : entries.length;
          this.clear();
          while (++index < length) {
            var entry = entries[index];
            this.set(entry[0], entry[1]);
          }
        }
        function mapCacheClear() {
          this.size = 0;
          this.__data__ = {
            "hash": new Hash(),
            "map": new (Map2 || ListCache)(),
            "string": new Hash()
          };
        }
        function mapCacheDelete(key) {
          var result2 = getMapData(this, key)["delete"](key);
          this.size -= result2 ? 1 : 0;
          return result2;
        }
        function mapCacheGet(key) {
          return getMapData(this, key).get(key);
        }
        function mapCacheHas(key) {
          return getMapData(this, key).has(key);
        }
        function mapCacheSet(key, value) {
          var data = getMapData(this, key), size2 = data.size;
          data.set(key, value);
          this.size += data.size == size2 ? 0 : 1;
          return this;
        }
        MapCache.prototype.clear = mapCacheClear;
        MapCache.prototype["delete"] = mapCacheDelete;
        MapCache.prototype.get = mapCacheGet;
        MapCache.prototype.has = mapCacheHas;
        MapCache.prototype.set = mapCacheSet;
        function SetCache(values2) {
          var index = -1, length = values2 == null ? 0 : values2.length;
          this.__data__ = new MapCache();
          while (++index < length) {
            this.add(values2[index]);
          }
        }
        function setCacheAdd(value) {
          this.__data__.set(value, HASH_UNDEFINED);
          return this;
        }
        function setCacheHas(value) {
          return this.__data__.has(value);
        }
        SetCache.prototype.add = SetCache.prototype.push = setCacheAdd;
        SetCache.prototype.has = setCacheHas;
        function Stack(entries) {
          var data = this.__data__ = new ListCache(entries);
          this.size = data.size;
        }
        function stackClear() {
          this.__data__ = new ListCache();
          this.size = 0;
        }
        function stackDelete(key) {
          var data = this.__data__, result2 = data["delete"](key);
          this.size = data.size;
          return result2;
        }
        function stackGet(key) {
          return this.__data__.get(key);
        }
        function stackHas(key) {
          return this.__data__.has(key);
        }
        function stackSet(key, value) {
          var data = this.__data__;
          if (data instanceof ListCache) {
            var pairs = data.__data__;
            if (!Map2 || pairs.length < LARGE_ARRAY_SIZE - 1) {
              pairs.push([key, value]);
              this.size = ++data.size;
              return this;
            }
            data = this.__data__ = new MapCache(pairs);
          }
          data.set(key, value);
          this.size = data.size;
          return this;
        }
        Stack.prototype.clear = stackClear;
        Stack.prototype["delete"] = stackDelete;
        Stack.prototype.get = stackGet;
        Stack.prototype.has = stackHas;
        Stack.prototype.set = stackSet;
        function arrayLikeKeys(value, inherited) {
          var isArr = isArray(value), isArg = !isArr && isArguments(value), isBuff = !isArr && !isArg && isBuffer(value), isType = !isArr && !isArg && !isBuff && isTypedArray(value), skipIndexes = isArr || isArg || isBuff || isType, result2 = skipIndexes ? baseTimes(value.length, String2) : [], length = result2.length;
          for (var key in value) {
            if ((inherited || hasOwnProperty.call(value, key)) && !(skipIndexes && // Safari 9 has enumerable `arguments.length` in strict mode.
            (key == "length" || // Node.js 0.10 has enumerable non-index properties on buffers.
            isBuff && (key == "offset" || key == "parent") || // PhantomJS 2 has enumerable non-index properties on typed arrays.
            isType && (key == "buffer" || key == "byteLength" || key == "byteOffset") || // Skip index properties.
            isIndex(key, length)))) {
              result2.push(key);
            }
          }
          return result2;
        }
        function arraySample(array) {
          var length = array.length;
          return length ? array[baseRandom(0, length - 1)] : undefined2;
        }
        function arraySampleSize(array, n) {
          return shuffleSelf(copyArray(array), baseClamp(n, 0, array.length));
        }
        function arrayShuffle(array) {
          return shuffleSelf(copyArray(array));
        }
        function assignMergeValue(object, key, value) {
          if (value !== undefined2 && !eq(object[key], value) || value === undefined2 && !(key in object)) {
            baseAssignValue(object, key, value);
          }
        }
        function assignValue(object, key, value) {
          var objValue = object[key];
          if (!(hasOwnProperty.call(object, key) && eq(objValue, value)) || value === undefined2 && !(key in object)) {
            baseAssignValue(object, key, value);
          }
        }
        function assocIndexOf(array, key) {
          var length = array.length;
          while (length--) {
            if (eq(array[length][0], key)) {
              return length;
            }
          }
          return -1;
        }
        function baseAggregator(collection, setter, iteratee2, accumulator) {
          baseEach(collection, function(value, key, collection2) {
            setter(accumulator, value, iteratee2(value), collection2);
          });
          return accumulator;
        }
        function baseAssign(object, source) {
          return object && copyObject(source, keys(source), object);
        }
        function baseAssignIn(object, source) {
          return object && copyObject(source, keysIn(source), object);
        }
        function baseAssignValue(object, key, value) {
          if (key == "__proto__" && defineProperty) {
            defineProperty(object, key, {
              "configurable": true,
              "enumerable": true,
              "value": value,
              "writable": true
            });
          } else {
            object[key] = value;
          }
        }
        function baseAt(object, paths) {
          var index = -1, length = paths.length, result2 = Array2(length), skip = object == null;
          while (++index < length) {
            result2[index] = skip ? undefined2 : get(object, paths[index]);
          }
          return result2;
        }
        function baseClamp(number, lower, upper) {
          if (number === number) {
            if (upper !== undefined2) {
              number = number <= upper ? number : upper;
            }
            if (lower !== undefined2) {
              number = number >= lower ? number : lower;
            }
          }
          return number;
        }
        function baseClone(value, bitmask, customizer, key, object, stack) {
          var result2, isDeep = bitmask & CLONE_DEEP_FLAG, isFlat = bitmask & CLONE_FLAT_FLAG, isFull = bitmask & CLONE_SYMBOLS_FLAG;
          if (customizer) {
            result2 = object ? customizer(value, key, object, stack) : customizer(value);
          }
          if (result2 !== undefined2) {
            return result2;
          }
          if (!isObject(value)) {
            return value;
          }
          var isArr = isArray(value);
          if (isArr) {
            result2 = initCloneArray(value);
            if (!isDeep) {
              return copyArray(value, result2);
            }
          } else {
            var tag = getTag(value), isFunc = tag == funcTag || tag == genTag;
            if (isBuffer(value)) {
              return cloneBuffer(value, isDeep);
            }
            if (tag == objectTag || tag == argsTag || isFunc && !object) {
              result2 = isFlat || isFunc ? {} : initCloneObject(value);
              if (!isDeep) {
                return isFlat ? copySymbolsIn(value, baseAssignIn(result2, value)) : copySymbols(value, baseAssign(result2, value));
              }
            } else {
              if (!cloneableTags[tag]) {
                return object ? value : {};
              }
              result2 = initCloneByTag(value, tag, isDeep);
            }
          }
          stack || (stack = new Stack());
          var stacked = stack.get(value);
          if (stacked) {
            return stacked;
          }
          stack.set(value, result2);
          if (isSet(value)) {
            value.forEach(function(subValue) {
              result2.add(baseClone(subValue, bitmask, customizer, subValue, value, stack));
            });
          } else if (isMap(value)) {
            value.forEach(function(subValue, key2) {
              result2.set(key2, baseClone(subValue, bitmask, customizer, key2, value, stack));
            });
          }
          var keysFunc = isFull ? isFlat ? getAllKeysIn : getAllKeys : isFlat ? keysIn : keys;
          var props = isArr ? undefined2 : keysFunc(value);
          arrayEach(props || value, function(subValue, key2) {
            if (props) {
              key2 = subValue;
              subValue = value[key2];
            }
            assignValue(result2, key2, baseClone(subValue, bitmask, customizer, key2, value, stack));
          });
          return result2;
        }
        function baseConforms(source) {
          var props = keys(source);
          return function(object) {
            return baseConformsTo(object, source, props);
          };
        }
        function baseConformsTo(object, source, props) {
          var length = props.length;
          if (object == null) {
            return !length;
          }
          object = Object2(object);
          while (length--) {
            var key = props[length], predicate = source[key], value = object[key];
            if (value === undefined2 && !(key in object) || !predicate(value)) {
              return false;
            }
          }
          return true;
        }
        function baseDelay(func, wait, args) {
          if (typeof func != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          return setTimeout(function() {
            func.apply(undefined2, args);
          }, wait);
        }
        function baseDifference(array, values2, iteratee2, comparator) {
          var index = -1, includes2 = arrayIncludes, isCommon = true, length = array.length, result2 = [], valuesLength = values2.length;
          if (!length) {
            return result2;
          }
          if (iteratee2) {
            values2 = arrayMap(values2, baseUnary(iteratee2));
          }
          if (comparator) {
            includes2 = arrayIncludesWith;
            isCommon = false;
          } else if (values2.length >= LARGE_ARRAY_SIZE) {
            includes2 = cacheHas;
            isCommon = false;
            values2 = new SetCache(values2);
          }
          outer:
            while (++index < length) {
              var value = array[index], computed = iteratee2 == null ? value : iteratee2(value);
              value = comparator || value !== 0 ? value : 0;
              if (isCommon && computed === computed) {
                var valuesIndex = valuesLength;
                while (valuesIndex--) {
                  if (values2[valuesIndex] === computed) {
                    continue outer;
                  }
                }
                result2.push(value);
              } else if (!includes2(values2, computed, comparator)) {
                result2.push(value);
              }
            }
          return result2;
        }
        var baseEach = createBaseEach(baseForOwn);
        var baseEachRight = createBaseEach(baseForOwnRight, true);
        function baseEvery(collection, predicate) {
          var result2 = true;
          baseEach(collection, function(value, index, collection2) {
            result2 = !!predicate(value, index, collection2);
            return result2;
          });
          return result2;
        }
        function baseExtremum(array, iteratee2, comparator) {
          var index = -1, length = array.length;
          while (++index < length) {
            var value = array[index], current = iteratee2(value);
            if (current != null && (computed === undefined2 ? current === current && !isSymbol(current) : comparator(current, computed))) {
              var computed = current, result2 = value;
            }
          }
          return result2;
        }
        function baseFill(array, value, start, end) {
          var length = array.length;
          start = toInteger(start);
          if (start < 0) {
            start = -start > length ? 0 : length + start;
          }
          end = end === undefined2 || end > length ? length : toInteger(end);
          if (end < 0) {
            end += length;
          }
          end = start > end ? 0 : toLength(end);
          while (start < end) {
            array[start++] = value;
          }
          return array;
        }
        function baseFilter(collection, predicate) {
          var result2 = [];
          baseEach(collection, function(value, index, collection2) {
            if (predicate(value, index, collection2)) {
              result2.push(value);
            }
          });
          return result2;
        }
        function baseFlatten(array, depth, predicate, isStrict, result2) {
          var index = -1, length = array.length;
          predicate || (predicate = isFlattenable);
          result2 || (result2 = []);
          while (++index < length) {
            var value = array[index];
            if (depth > 0 && predicate(value)) {
              if (depth > 1) {
                baseFlatten(value, depth - 1, predicate, isStrict, result2);
              } else {
                arrayPush(result2, value);
              }
            } else if (!isStrict) {
              result2[result2.length] = value;
            }
          }
          return result2;
        }
        var baseFor = createBaseFor();
        var baseForRight = createBaseFor(true);
        function baseForOwn(object, iteratee2) {
          return object && baseFor(object, iteratee2, keys);
        }
        function baseForOwnRight(object, iteratee2) {
          return object && baseForRight(object, iteratee2, keys);
        }
        function baseFunctions(object, props) {
          return arrayFilter(props, function(key) {
            return isFunction(object[key]);
          });
        }
        function baseGet(object, path) {
          path = castPath(path, object);
          var index = 0, length = path.length;
          while (object != null && index < length) {
            object = object[toKey(path[index++])];
          }
          return index && index == length ? object : undefined2;
        }
        function baseGetAllKeys(object, keysFunc, symbolsFunc) {
          var result2 = keysFunc(object);
          return isArray(object) ? result2 : arrayPush(result2, symbolsFunc(object));
        }
        function baseGetTag(value) {
          if (value == null) {
            return value === undefined2 ? undefinedTag : nullTag;
          }
          return symToStringTag && symToStringTag in Object2(value) ? getRawTag(value) : objectToString(value);
        }
        function baseGt(value, other) {
          return value > other;
        }
        function baseHas(object, key) {
          return object != null && hasOwnProperty.call(object, key);
        }
        function baseHasIn(object, key) {
          return object != null && key in Object2(object);
        }
        function baseInRange(number, start, end) {
          return number >= nativeMin(start, end) && number < nativeMax(start, end);
        }
        function baseIntersection(arrays, iteratee2, comparator) {
          var includes2 = comparator ? arrayIncludesWith : arrayIncludes, length = arrays[0].length, othLength = arrays.length, othIndex = othLength, caches = Array2(othLength), maxLength = Infinity, result2 = [];
          while (othIndex--) {
            var array = arrays[othIndex];
            if (othIndex && iteratee2) {
              array = arrayMap(array, baseUnary(iteratee2));
            }
            maxLength = nativeMin(array.length, maxLength);
            caches[othIndex] = !comparator && (iteratee2 || length >= 120 && array.length >= 120) ? new SetCache(othIndex && array) : undefined2;
          }
          array = arrays[0];
          var index = -1, seen = caches[0];
          outer:
            while (++index < length && result2.length < maxLength) {
              var value = array[index], computed = iteratee2 ? iteratee2(value) : value;
              value = comparator || value !== 0 ? value : 0;
              if (!(seen ? cacheHas(seen, computed) : includes2(result2, computed, comparator))) {
                othIndex = othLength;
                while (--othIndex) {
                  var cache = caches[othIndex];
                  if (!(cache ? cacheHas(cache, computed) : includes2(arrays[othIndex], computed, comparator))) {
                    continue outer;
                  }
                }
                if (seen) {
                  seen.push(computed);
                }
                result2.push(value);
              }
            }
          return result2;
        }
        function baseInverter(object, setter, iteratee2, accumulator) {
          baseForOwn(object, function(value, key, object2) {
            setter(accumulator, iteratee2(value), key, object2);
          });
          return accumulator;
        }
        function baseInvoke(object, path, args) {
          path = castPath(path, object);
          object = parent(object, path);
          var func = object == null ? object : object[toKey(last(path))];
          return func == null ? undefined2 : apply(func, object, args);
        }
        function baseIsArguments(value) {
          return isObjectLike(value) && baseGetTag(value) == argsTag;
        }
        function baseIsArrayBuffer(value) {
          return isObjectLike(value) && baseGetTag(value) == arrayBufferTag;
        }
        function baseIsDate(value) {
          return isObjectLike(value) && baseGetTag(value) == dateTag;
        }
        function baseIsEqual(value, other, bitmask, customizer, stack) {
          if (value === other) {
            return true;
          }
          if (value == null || other == null || !isObjectLike(value) && !isObjectLike(other)) {
            return value !== value && other !== other;
          }
          return baseIsEqualDeep(value, other, bitmask, customizer, baseIsEqual, stack);
        }
        function baseIsEqualDeep(object, other, bitmask, customizer, equalFunc, stack) {
          var objIsArr = isArray(object), othIsArr = isArray(other), objTag = objIsArr ? arrayTag : getTag(object), othTag = othIsArr ? arrayTag : getTag(other);
          objTag = objTag == argsTag ? objectTag : objTag;
          othTag = othTag == argsTag ? objectTag : othTag;
          var objIsObj = objTag == objectTag, othIsObj = othTag == objectTag, isSameTag = objTag == othTag;
          if (isSameTag && isBuffer(object)) {
            if (!isBuffer(other)) {
              return false;
            }
            objIsArr = true;
            objIsObj = false;
          }
          if (isSameTag && !objIsObj) {
            stack || (stack = new Stack());
            return objIsArr || isTypedArray(object) ? equalArrays(object, other, bitmask, customizer, equalFunc, stack) : equalByTag(object, other, objTag, bitmask, customizer, equalFunc, stack);
          }
          if (!(bitmask & COMPARE_PARTIAL_FLAG)) {
            var objIsWrapped = objIsObj && hasOwnProperty.call(object, "__wrapped__"), othIsWrapped = othIsObj && hasOwnProperty.call(other, "__wrapped__");
            if (objIsWrapped || othIsWrapped) {
              var objUnwrapped = objIsWrapped ? object.value() : object, othUnwrapped = othIsWrapped ? other.value() : other;
              stack || (stack = new Stack());
              return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
            }
          }
          if (!isSameTag) {
            return false;
          }
          stack || (stack = new Stack());
          return equalObjects(object, other, bitmask, customizer, equalFunc, stack);
        }
        function baseIsMap(value) {
          return isObjectLike(value) && getTag(value) == mapTag;
        }
        function baseIsMatch(object, source, matchData, customizer) {
          var index = matchData.length, length = index, noCustomizer = !customizer;
          if (object == null) {
            return !length;
          }
          object = Object2(object);
          while (index--) {
            var data = matchData[index];
            if (noCustomizer && data[2] ? data[1] !== object[data[0]] : !(data[0] in object)) {
              return false;
            }
          }
          while (++index < length) {
            data = matchData[index];
            var key = data[0], objValue = object[key], srcValue = data[1];
            if (noCustomizer && data[2]) {
              if (objValue === undefined2 && !(key in object)) {
                return false;
              }
            } else {
              var stack = new Stack();
              if (customizer) {
                var result2 = customizer(objValue, srcValue, key, object, source, stack);
              }
              if (!(result2 === undefined2 ? baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG, customizer, stack) : result2)) {
                return false;
              }
            }
          }
          return true;
        }
        function baseIsNative(value) {
          if (!isObject(value) || isMasked(value)) {
            return false;
          }
          var pattern = isFunction(value) ? reIsNative : reIsHostCtor;
          return pattern.test(toSource(value));
        }
        function baseIsRegExp(value) {
          return isObjectLike(value) && baseGetTag(value) == regexpTag;
        }
        function baseIsSet(value) {
          return isObjectLike(value) && getTag(value) == setTag;
        }
        function baseIsTypedArray(value) {
          return isObjectLike(value) && isLength(value.length) && !!typedArrayTags[baseGetTag(value)];
        }
        function baseIteratee(value) {
          if (typeof value == "function") {
            return value;
          }
          if (value == null) {
            return identity;
          }
          if (typeof value == "object") {
            return isArray(value) ? baseMatchesProperty(value[0], value[1]) : baseMatches(value);
          }
          return property(value);
        }
        function baseKeys(object) {
          if (!isPrototype(object)) {
            return nativeKeys(object);
          }
          var result2 = [];
          for (var key in Object2(object)) {
            if (hasOwnProperty.call(object, key) && key != "constructor") {
              result2.push(key);
            }
          }
          return result2;
        }
        function baseKeysIn(object) {
          if (!isObject(object)) {
            return nativeKeysIn(object);
          }
          var isProto = isPrototype(object), result2 = [];
          for (var key in object) {
            if (!(key == "constructor" && (isProto || !hasOwnProperty.call(object, key)))) {
              result2.push(key);
            }
          }
          return result2;
        }
        function baseLt(value, other) {
          return value < other;
        }
        function baseMap(collection, iteratee2) {
          var index = -1, result2 = isArrayLike(collection) ? Array2(collection.length) : [];
          baseEach(collection, function(value, key, collection2) {
            result2[++index] = iteratee2(value, key, collection2);
          });
          return result2;
        }
        function baseMatches(source) {
          var matchData = getMatchData(source);
          if (matchData.length == 1 && matchData[0][2]) {
            return matchesStrictComparable(matchData[0][0], matchData[0][1]);
          }
          return function(object) {
            return object === source || baseIsMatch(object, source, matchData);
          };
        }
        function baseMatchesProperty(path, srcValue) {
          if (isKey(path) && isStrictComparable(srcValue)) {
            return matchesStrictComparable(toKey(path), srcValue);
          }
          return function(object) {
            var objValue = get(object, path);
            return objValue === undefined2 && objValue === srcValue ? hasIn(object, path) : baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG);
          };
        }
        function baseMerge(object, source, srcIndex, customizer, stack) {
          if (object === source) {
            return;
          }
          baseFor(source, function(srcValue, key) {
            stack || (stack = new Stack());
            if (isObject(srcValue)) {
              baseMergeDeep(object, source, key, srcIndex, baseMerge, customizer, stack);
            } else {
              var newValue = customizer ? customizer(safeGet(object, key), srcValue, key + "", object, source, stack) : undefined2;
              if (newValue === undefined2) {
                newValue = srcValue;
              }
              assignMergeValue(object, key, newValue);
            }
          }, keysIn);
        }
        function baseMergeDeep(object, source, key, srcIndex, mergeFunc, customizer, stack) {
          var objValue = safeGet(object, key), srcValue = safeGet(source, key), stacked = stack.get(srcValue);
          if (stacked) {
            assignMergeValue(object, key, stacked);
            return;
          }
          var newValue = customizer ? customizer(objValue, srcValue, key + "", object, source, stack) : undefined2;
          var isCommon = newValue === undefined2;
          if (isCommon) {
            var isArr = isArray(srcValue), isBuff = !isArr && isBuffer(srcValue), isTyped = !isArr && !isBuff && isTypedArray(srcValue);
            newValue = srcValue;
            if (isArr || isBuff || isTyped) {
              if (isArray(objValue)) {
                newValue = objValue;
              } else if (isArrayLikeObject(objValue)) {
                newValue = copyArray(objValue);
              } else if (isBuff) {
                isCommon = false;
                newValue = cloneBuffer(srcValue, true);
              } else if (isTyped) {
                isCommon = false;
                newValue = cloneTypedArray(srcValue, true);
              } else {
                newValue = [];
              }
            } else if (isPlainObject(srcValue) || isArguments(srcValue)) {
              newValue = objValue;
              if (isArguments(objValue)) {
                newValue = toPlainObject(objValue);
              } else if (!isObject(objValue) || isFunction(objValue)) {
                newValue = initCloneObject(srcValue);
              }
            } else {
              isCommon = false;
            }
          }
          if (isCommon) {
            stack.set(srcValue, newValue);
            mergeFunc(newValue, srcValue, srcIndex, customizer, stack);
            stack["delete"](srcValue);
          }
          assignMergeValue(object, key, newValue);
        }
        function baseNth(array, n) {
          var length = array.length;
          if (!length) {
            return;
          }
          n += n < 0 ? length : 0;
          return isIndex(n, length) ? array[n] : undefined2;
        }
        function baseOrderBy(collection, iteratees, orders) {
          if (iteratees.length) {
            iteratees = arrayMap(iteratees, function(iteratee2) {
              if (isArray(iteratee2)) {
                return function(value) {
                  return baseGet(value, iteratee2.length === 1 ? iteratee2[0] : iteratee2);
                };
              }
              return iteratee2;
            });
          } else {
            iteratees = [identity];
          }
          var index = -1;
          iteratees = arrayMap(iteratees, baseUnary(getIteratee()));
          var result2 = baseMap(collection, function(value, key, collection2) {
            var criteria = arrayMap(iteratees, function(iteratee2) {
              return iteratee2(value);
            });
            return { "criteria": criteria, "index": ++index, "value": value };
          });
          return baseSortBy(result2, function(object, other) {
            return compareMultiple(object, other, orders);
          });
        }
        function basePick(object, paths) {
          return basePickBy(object, paths, function(value, path) {
            return hasIn(object, path);
          });
        }
        function basePickBy(object, paths, predicate) {
          var index = -1, length = paths.length, result2 = {};
          while (++index < length) {
            var path = paths[index], value = baseGet(object, path);
            if (predicate(value, path)) {
              baseSet(result2, castPath(path, object), value);
            }
          }
          return result2;
        }
        function basePropertyDeep(path) {
          return function(object) {
            return baseGet(object, path);
          };
        }
        function basePullAll(array, values2, iteratee2, comparator) {
          var indexOf2 = comparator ? baseIndexOfWith : baseIndexOf, index = -1, length = values2.length, seen = array;
          if (array === values2) {
            values2 = copyArray(values2);
          }
          if (iteratee2) {
            seen = arrayMap(array, baseUnary(iteratee2));
          }
          while (++index < length) {
            var fromIndex = 0, value = values2[index], computed = iteratee2 ? iteratee2(value) : value;
            while ((fromIndex = indexOf2(seen, computed, fromIndex, comparator)) > -1) {
              if (seen !== array) {
                splice.call(seen, fromIndex, 1);
              }
              splice.call(array, fromIndex, 1);
            }
          }
          return array;
        }
        function basePullAt(array, indexes) {
          var length = array ? indexes.length : 0, lastIndex = length - 1;
          while (length--) {
            var index = indexes[length];
            if (length == lastIndex || index !== previous) {
              var previous = index;
              if (isIndex(index)) {
                splice.call(array, index, 1);
              } else {
                baseUnset(array, index);
              }
            }
          }
          return array;
        }
        function baseRandom(lower, upper) {
          return lower + nativeFloor(nativeRandom() * (upper - lower + 1));
        }
        function baseRange(start, end, step, fromRight) {
          var index = -1, length = nativeMax(nativeCeil((end - start) / (step || 1)), 0), result2 = Array2(length);
          while (length--) {
            result2[fromRight ? length : ++index] = start;
            start += step;
          }
          return result2;
        }
        function baseRepeat(string, n) {
          var result2 = "";
          if (!string || n < 1 || n > MAX_SAFE_INTEGER) {
            return result2;
          }
          do {
            if (n % 2) {
              result2 += string;
            }
            n = nativeFloor(n / 2);
            if (n) {
              string += string;
            }
          } while (n);
          return result2;
        }
        function baseRest(func, start) {
          return setToString(overRest(func, start, identity), func + "");
        }
        function baseSample(collection) {
          return arraySample(values(collection));
        }
        function baseSampleSize(collection, n) {
          var array = values(collection);
          return shuffleSelf(array, baseClamp(n, 0, array.length));
        }
        function baseSet(object, path, value, customizer) {
          if (!isObject(object)) {
            return object;
          }
          path = castPath(path, object);
          var index = -1, length = path.length, lastIndex = length - 1, nested = object;
          while (nested != null && ++index < length) {
            var key = toKey(path[index]), newValue = value;
            if (key === "__proto__" || key === "constructor" || key === "prototype") {
              return object;
            }
            if (index != lastIndex) {
              var objValue = nested[key];
              newValue = customizer ? customizer(objValue, key, nested) : undefined2;
              if (newValue === undefined2) {
                newValue = isObject(objValue) ? objValue : isIndex(path[index + 1]) ? [] : {};
              }
            }
            assignValue(nested, key, newValue);
            nested = nested[key];
          }
          return object;
        }
        var baseSetData = !metaMap ? identity : function(func, data) {
          metaMap.set(func, data);
          return func;
        };
        var baseSetToString = !defineProperty ? identity : function(func, string) {
          return defineProperty(func, "toString", {
            "configurable": true,
            "enumerable": false,
            "value": constant(string),
            "writable": true
          });
        };
        function baseShuffle(collection) {
          return shuffleSelf(values(collection));
        }
        function baseSlice(array, start, end) {
          var index = -1, length = array.length;
          if (start < 0) {
            start = -start > length ? 0 : length + start;
          }
          end = end > length ? length : end;
          if (end < 0) {
            end += length;
          }
          length = start > end ? 0 : end - start >>> 0;
          start >>>= 0;
          var result2 = Array2(length);
          while (++index < length) {
            result2[index] = array[index + start];
          }
          return result2;
        }
        function baseSome(collection, predicate) {
          var result2;
          baseEach(collection, function(value, index, collection2) {
            result2 = predicate(value, index, collection2);
            return !result2;
          });
          return !!result2;
        }
        function baseSortedIndex(array, value, retHighest) {
          var low = 0, high = array == null ? low : array.length;
          if (typeof value == "number" && value === value && high <= HALF_MAX_ARRAY_LENGTH) {
            while (low < high) {
              var mid = low + high >>> 1, computed = array[mid];
              if (computed !== null && !isSymbol(computed) && (retHighest ? computed <= value : computed < value)) {
                low = mid + 1;
              } else {
                high = mid;
              }
            }
            return high;
          }
          return baseSortedIndexBy(array, value, identity, retHighest);
        }
        function baseSortedIndexBy(array, value, iteratee2, retHighest) {
          var low = 0, high = array == null ? 0 : array.length;
          if (high === 0) {
            return 0;
          }
          value = iteratee2(value);
          var valIsNaN = value !== value, valIsNull = value === null, valIsSymbol = isSymbol(value), valIsUndefined = value === undefined2;
          while (low < high) {
            var mid = nativeFloor((low + high) / 2), computed = iteratee2(array[mid]), othIsDefined = computed !== undefined2, othIsNull = computed === null, othIsReflexive = computed === computed, othIsSymbol = isSymbol(computed);
            if (valIsNaN) {
              var setLow = retHighest || othIsReflexive;
            } else if (valIsUndefined) {
              setLow = othIsReflexive && (retHighest || othIsDefined);
            } else if (valIsNull) {
              setLow = othIsReflexive && othIsDefined && (retHighest || !othIsNull);
            } else if (valIsSymbol) {
              setLow = othIsReflexive && othIsDefined && !othIsNull && (retHighest || !othIsSymbol);
            } else if (othIsNull || othIsSymbol) {
              setLow = false;
            } else {
              setLow = retHighest ? computed <= value : computed < value;
            }
            if (setLow) {
              low = mid + 1;
            } else {
              high = mid;
            }
          }
          return nativeMin(high, MAX_ARRAY_INDEX);
        }
        function baseSortedUniq(array, iteratee2) {
          var index = -1, length = array.length, resIndex = 0, result2 = [];
          while (++index < length) {
            var value = array[index], computed = iteratee2 ? iteratee2(value) : value;
            if (!index || !eq(computed, seen)) {
              var seen = computed;
              result2[resIndex++] = value === 0 ? 0 : value;
            }
          }
          return result2;
        }
        function baseToNumber(value) {
          if (typeof value == "number") {
            return value;
          }
          if (isSymbol(value)) {
            return NAN;
          }
          return +value;
        }
        function baseToString(value) {
          if (typeof value == "string") {
            return value;
          }
          if (isArray(value)) {
            return arrayMap(value, baseToString) + "";
          }
          if (isSymbol(value)) {
            return symbolToString ? symbolToString.call(value) : "";
          }
          var result2 = value + "";
          return result2 == "0" && 1 / value == -Infinity ? "-0" : result2;
        }
        function baseUniq(array, iteratee2, comparator) {
          var index = -1, includes2 = arrayIncludes, length = array.length, isCommon = true, result2 = [], seen = result2;
          if (comparator) {
            isCommon = false;
            includes2 = arrayIncludesWith;
          } else if (length >= LARGE_ARRAY_SIZE) {
            var set2 = iteratee2 ? null : createSet(array);
            if (set2) {
              return setToArray(set2);
            }
            isCommon = false;
            includes2 = cacheHas;
            seen = new SetCache();
          } else {
            seen = iteratee2 ? [] : result2;
          }
          outer:
            while (++index < length) {
              var value = array[index], computed = iteratee2 ? iteratee2(value) : value;
              value = comparator || value !== 0 ? value : 0;
              if (isCommon && computed === computed) {
                var seenIndex = seen.length;
                while (seenIndex--) {
                  if (seen[seenIndex] === computed) {
                    continue outer;
                  }
                }
                if (iteratee2) {
                  seen.push(computed);
                }
                result2.push(value);
              } else if (!includes2(seen, computed, comparator)) {
                if (seen !== result2) {
                  seen.push(computed);
                }
                result2.push(value);
              }
            }
          return result2;
        }
        function baseUnset(object, path) {
          path = castPath(path, object);
          object = parent(object, path);
          return object == null || delete object[toKey(last(path))];
        }
        function baseUpdate(object, path, updater, customizer) {
          return baseSet(object, path, updater(baseGet(object, path)), customizer);
        }
        function baseWhile(array, predicate, isDrop, fromRight) {
          var length = array.length, index = fromRight ? length : -1;
          while ((fromRight ? index-- : ++index < length) && predicate(array[index], index, array)) {
          }
          return isDrop ? baseSlice(array, fromRight ? 0 : index, fromRight ? index + 1 : length) : baseSlice(array, fromRight ? index + 1 : 0, fromRight ? length : index);
        }
        function baseWrapperValue(value, actions) {
          var result2 = value;
          if (result2 instanceof LazyWrapper) {
            result2 = result2.value();
          }
          return arrayReduce(actions, function(result3, action) {
            return action.func.apply(action.thisArg, arrayPush([result3], action.args));
          }, result2);
        }
        function baseXor(arrays, iteratee2, comparator) {
          var length = arrays.length;
          if (length < 2) {
            return length ? baseUniq(arrays[0]) : [];
          }
          var index = -1, result2 = Array2(length);
          while (++index < length) {
            var array = arrays[index], othIndex = -1;
            while (++othIndex < length) {
              if (othIndex != index) {
                result2[index] = baseDifference(result2[index] || array, arrays[othIndex], iteratee2, comparator);
              }
            }
          }
          return baseUniq(baseFlatten(result2, 1), iteratee2, comparator);
        }
        function baseZipObject(props, values2, assignFunc) {
          var index = -1, length = props.length, valsLength = values2.length, result2 = {};
          while (++index < length) {
            var value = index < valsLength ? values2[index] : undefined2;
            assignFunc(result2, props[index], value);
          }
          return result2;
        }
        function castArrayLikeObject(value) {
          return isArrayLikeObject(value) ? value : [];
        }
        function castFunction(value) {
          return typeof value == "function" ? value : identity;
        }
        function castPath(value, object) {
          if (isArray(value)) {
            return value;
          }
          return isKey(value, object) ? [value] : stringToPath(toString(value));
        }
        var castRest = baseRest;
        function castSlice(array, start, end) {
          var length = array.length;
          end = end === undefined2 ? length : end;
          return !start && end >= length ? array : baseSlice(array, start, end);
        }
        var clearTimeout = ctxClearTimeout || function(id) {
          return root.clearTimeout(id);
        };
        function cloneBuffer(buffer, isDeep) {
          if (isDeep) {
            return buffer.slice();
          }
          var length = buffer.length, result2 = allocUnsafe ? allocUnsafe(length) : new buffer.constructor(length);
          buffer.copy(result2);
          return result2;
        }
        function cloneArrayBuffer(arrayBuffer) {
          var result2 = new arrayBuffer.constructor(arrayBuffer.byteLength);
          new Uint8Array2(result2).set(new Uint8Array2(arrayBuffer));
          return result2;
        }
        function cloneDataView(dataView, isDeep) {
          var buffer = isDeep ? cloneArrayBuffer(dataView.buffer) : dataView.buffer;
          return new dataView.constructor(buffer, dataView.byteOffset, dataView.byteLength);
        }
        function cloneRegExp(regexp) {
          var result2 = new regexp.constructor(regexp.source, reFlags.exec(regexp));
          result2.lastIndex = regexp.lastIndex;
          return result2;
        }
        function cloneSymbol(symbol) {
          return symbolValueOf ? Object2(symbolValueOf.call(symbol)) : {};
        }
        function cloneTypedArray(typedArray, isDeep) {
          var buffer = isDeep ? cloneArrayBuffer(typedArray.buffer) : typedArray.buffer;
          return new typedArray.constructor(buffer, typedArray.byteOffset, typedArray.length);
        }
        function compareAscending(value, other) {
          if (value !== other) {
            var valIsDefined = value !== undefined2, valIsNull = value === null, valIsReflexive = value === value, valIsSymbol = isSymbol(value);
            var othIsDefined = other !== undefined2, othIsNull = other === null, othIsReflexive = other === other, othIsSymbol = isSymbol(other);
            if (!othIsNull && !othIsSymbol && !valIsSymbol && value > other || valIsSymbol && othIsDefined && othIsReflexive && !othIsNull && !othIsSymbol || valIsNull && othIsDefined && othIsReflexive || !valIsDefined && othIsReflexive || !valIsReflexive) {
              return 1;
            }
            if (!valIsNull && !valIsSymbol && !othIsSymbol && value < other || othIsSymbol && valIsDefined && valIsReflexive && !valIsNull && !valIsSymbol || othIsNull && valIsDefined && valIsReflexive || !othIsDefined && valIsReflexive || !othIsReflexive) {
              return -1;
            }
          }
          return 0;
        }
        function compareMultiple(object, other, orders) {
          var index = -1, objCriteria = object.criteria, othCriteria = other.criteria, length = objCriteria.length, ordersLength = orders.length;
          while (++index < length) {
            var result2 = compareAscending(objCriteria[index], othCriteria[index]);
            if (result2) {
              if (index >= ordersLength) {
                return result2;
              }
              var order = orders[index];
              return result2 * (order == "desc" ? -1 : 1);
            }
          }
          return object.index - other.index;
        }
        function composeArgs(args, partials, holders, isCurried) {
          var argsIndex = -1, argsLength = args.length, holdersLength = holders.length, leftIndex = -1, leftLength = partials.length, rangeLength = nativeMax(argsLength - holdersLength, 0), result2 = Array2(leftLength + rangeLength), isUncurried = !isCurried;
          while (++leftIndex < leftLength) {
            result2[leftIndex] = partials[leftIndex];
          }
          while (++argsIndex < holdersLength) {
            if (isUncurried || argsIndex < argsLength) {
              result2[holders[argsIndex]] = args[argsIndex];
            }
          }
          while (rangeLength--) {
            result2[leftIndex++] = args[argsIndex++];
          }
          return result2;
        }
        function composeArgsRight(args, partials, holders, isCurried) {
          var argsIndex = -1, argsLength = args.length, holdersIndex = -1, holdersLength = holders.length, rightIndex = -1, rightLength = partials.length, rangeLength = nativeMax(argsLength - holdersLength, 0), result2 = Array2(rangeLength + rightLength), isUncurried = !isCurried;
          while (++argsIndex < rangeLength) {
            result2[argsIndex] = args[argsIndex];
          }
          var offset3 = argsIndex;
          while (++rightIndex < rightLength) {
            result2[offset3 + rightIndex] = partials[rightIndex];
          }
          while (++holdersIndex < holdersLength) {
            if (isUncurried || argsIndex < argsLength) {
              result2[offset3 + holders[holdersIndex]] = args[argsIndex++];
            }
          }
          return result2;
        }
        function copyArray(source, array) {
          var index = -1, length = source.length;
          array || (array = Array2(length));
          while (++index < length) {
            array[index] = source[index];
          }
          return array;
        }
        function copyObject(source, props, object, customizer) {
          var isNew = !object;
          object || (object = {});
          var index = -1, length = props.length;
          while (++index < length) {
            var key = props[index];
            var newValue = customizer ? customizer(object[key], source[key], key, object, source) : undefined2;
            if (newValue === undefined2) {
              newValue = source[key];
            }
            if (isNew) {
              baseAssignValue(object, key, newValue);
            } else {
              assignValue(object, key, newValue);
            }
          }
          return object;
        }
        function copySymbols(source, object) {
          return copyObject(source, getSymbols(source), object);
        }
        function copySymbolsIn(source, object) {
          return copyObject(source, getSymbolsIn(source), object);
        }
        function createAggregator(setter, initializer) {
          return function(collection, iteratee2) {
            var func = isArray(collection) ? arrayAggregator : baseAggregator, accumulator = initializer ? initializer() : {};
            return func(collection, setter, getIteratee(iteratee2, 2), accumulator);
          };
        }
        function createAssigner(assigner) {
          return baseRest(function(object, sources) {
            var index = -1, length = sources.length, customizer = length > 1 ? sources[length - 1] : undefined2, guard = length > 2 ? sources[2] : undefined2;
            customizer = assigner.length > 3 && typeof customizer == "function" ? (length--, customizer) : undefined2;
            if (guard && isIterateeCall(sources[0], sources[1], guard)) {
              customizer = length < 3 ? undefined2 : customizer;
              length = 1;
            }
            object = Object2(object);
            while (++index < length) {
              var source = sources[index];
              if (source) {
                assigner(object, source, index, customizer);
              }
            }
            return object;
          });
        }
        function createBaseEach(eachFunc, fromRight) {
          return function(collection, iteratee2) {
            if (collection == null) {
              return collection;
            }
            if (!isArrayLike(collection)) {
              return eachFunc(collection, iteratee2);
            }
            var length = collection.length, index = fromRight ? length : -1, iterable = Object2(collection);
            while (fromRight ? index-- : ++index < length) {
              if (iteratee2(iterable[index], index, iterable) === false) {
                break;
              }
            }
            return collection;
          };
        }
        function createBaseFor(fromRight) {
          return function(object, iteratee2, keysFunc) {
            var index = -1, iterable = Object2(object), props = keysFunc(object), length = props.length;
            while (length--) {
              var key = props[fromRight ? length : ++index];
              if (iteratee2(iterable[key], key, iterable) === false) {
                break;
              }
            }
            return object;
          };
        }
        function createBind(func, bitmask, thisArg) {
          var isBind = bitmask & WRAP_BIND_FLAG, Ctor = createCtor(func);
          function wrapper() {
            var fn = this && this !== root && this instanceof wrapper ? Ctor : func;
            return fn.apply(isBind ? thisArg : this, arguments);
          }
          return wrapper;
        }
        function createCaseFirst(methodName) {
          return function(string) {
            string = toString(string);
            var strSymbols = hasUnicode(string) ? stringToArray(string) : undefined2;
            var chr = strSymbols ? strSymbols[0] : string.charAt(0);
            var trailing = strSymbols ? castSlice(strSymbols, 1).join("") : string.slice(1);
            return chr[methodName]() + trailing;
          };
        }
        function createCompounder(callback) {
          return function(string) {
            return arrayReduce(words(deburr(string).replace(reApos, "")), callback, "");
          };
        }
        function createCtor(Ctor) {
          return function() {
            var args = arguments;
            switch (args.length) {
              case 0:
                return new Ctor();
              case 1:
                return new Ctor(args[0]);
              case 2:
                return new Ctor(args[0], args[1]);
              case 3:
                return new Ctor(args[0], args[1], args[2]);
              case 4:
                return new Ctor(args[0], args[1], args[2], args[3]);
              case 5:
                return new Ctor(args[0], args[1], args[2], args[3], args[4]);
              case 6:
                return new Ctor(args[0], args[1], args[2], args[3], args[4], args[5]);
              case 7:
                return new Ctor(args[0], args[1], args[2], args[3], args[4], args[5], args[6]);
            }
            var thisBinding = baseCreate(Ctor.prototype), result2 = Ctor.apply(thisBinding, args);
            return isObject(result2) ? result2 : thisBinding;
          };
        }
        function createCurry(func, bitmask, arity) {
          var Ctor = createCtor(func);
          function wrapper() {
            var length = arguments.length, args = Array2(length), index = length, placeholder = getHolder(wrapper);
            while (index--) {
              args[index] = arguments[index];
            }
            var holders = length < 3 && args[0] !== placeholder && args[length - 1] !== placeholder ? [] : replaceHolders(args, placeholder);
            length -= holders.length;
            if (length < arity) {
              return createRecurry(
                func,
                bitmask,
                createHybrid,
                wrapper.placeholder,
                undefined2,
                args,
                holders,
                undefined2,
                undefined2,
                arity - length
              );
            }
            var fn = this && this !== root && this instanceof wrapper ? Ctor : func;
            return apply(fn, this, args);
          }
          return wrapper;
        }
        function createFind(findIndexFunc) {
          return function(collection, predicate, fromIndex) {
            var iterable = Object2(collection);
            if (!isArrayLike(collection)) {
              var iteratee2 = getIteratee(predicate, 3);
              collection = keys(collection);
              predicate = function(key) {
                return iteratee2(iterable[key], key, iterable);
              };
            }
            var index = findIndexFunc(collection, predicate, fromIndex);
            return index > -1 ? iterable[iteratee2 ? collection[index] : index] : undefined2;
          };
        }
        function createFlow(fromRight) {
          return flatRest(function(funcs) {
            var length = funcs.length, index = length, prereq = LodashWrapper.prototype.thru;
            if (fromRight) {
              funcs.reverse();
            }
            while (index--) {
              var func = funcs[index];
              if (typeof func != "function") {
                throw new TypeError2(FUNC_ERROR_TEXT);
              }
              if (prereq && !wrapper && getFuncName(func) == "wrapper") {
                var wrapper = new LodashWrapper([], true);
              }
            }
            index = wrapper ? index : length;
            while (++index < length) {
              func = funcs[index];
              var funcName = getFuncName(func), data = funcName == "wrapper" ? getData(func) : undefined2;
              if (data && isLaziable(data[0]) && data[1] == (WRAP_ARY_FLAG | WRAP_CURRY_FLAG | WRAP_PARTIAL_FLAG | WRAP_REARG_FLAG) && !data[4].length && data[9] == 1) {
                wrapper = wrapper[getFuncName(data[0])].apply(wrapper, data[3]);
              } else {
                wrapper = func.length == 1 && isLaziable(func) ? wrapper[funcName]() : wrapper.thru(func);
              }
            }
            return function() {
              var args = arguments, value = args[0];
              if (wrapper && args.length == 1 && isArray(value)) {
                return wrapper.plant(value).value();
              }
              var index2 = 0, result2 = length ? funcs[index2].apply(this, args) : value;
              while (++index2 < length) {
                result2 = funcs[index2].call(this, result2);
              }
              return result2;
            };
          });
        }
        function createHybrid(func, bitmask, thisArg, partials, holders, partialsRight, holdersRight, argPos, ary2, arity) {
          var isAry = bitmask & WRAP_ARY_FLAG, isBind = bitmask & WRAP_BIND_FLAG, isBindKey = bitmask & WRAP_BIND_KEY_FLAG, isCurried = bitmask & (WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG), isFlip = bitmask & WRAP_FLIP_FLAG, Ctor = isBindKey ? undefined2 : createCtor(func);
          function wrapper() {
            var length = arguments.length, args = Array2(length), index = length;
            while (index--) {
              args[index] = arguments[index];
            }
            if (isCurried) {
              var placeholder = getHolder(wrapper), holdersCount = countHolders(args, placeholder);
            }
            if (partials) {
              args = composeArgs(args, partials, holders, isCurried);
            }
            if (partialsRight) {
              args = composeArgsRight(args, partialsRight, holdersRight, isCurried);
            }
            length -= holdersCount;
            if (isCurried && length < arity) {
              var newHolders = replaceHolders(args, placeholder);
              return createRecurry(
                func,
                bitmask,
                createHybrid,
                wrapper.placeholder,
                thisArg,
                args,
                newHolders,
                argPos,
                ary2,
                arity - length
              );
            }
            var thisBinding = isBind ? thisArg : this, fn = isBindKey ? thisBinding[func] : func;
            length = args.length;
            if (argPos) {
              args = reorder(args, argPos);
            } else if (isFlip && length > 1) {
              args.reverse();
            }
            if (isAry && ary2 < length) {
              args.length = ary2;
            }
            if (this && this !== root && this instanceof wrapper) {
              fn = Ctor || createCtor(fn);
            }
            return fn.apply(thisBinding, args);
          }
          return wrapper;
        }
        function createInverter(setter, toIteratee) {
          return function(object, iteratee2) {
            return baseInverter(object, setter, toIteratee(iteratee2), {});
          };
        }
        function createMathOperation(operator, defaultValue) {
          return function(value, other) {
            var result2;
            if (value === undefined2 && other === undefined2) {
              return defaultValue;
            }
            if (value !== undefined2) {
              result2 = value;
            }
            if (other !== undefined2) {
              if (result2 === undefined2) {
                return other;
              }
              if (typeof value == "string" || typeof other == "string") {
                value = baseToString(value);
                other = baseToString(other);
              } else {
                value = baseToNumber(value);
                other = baseToNumber(other);
              }
              result2 = operator(value, other);
            }
            return result2;
          };
        }
        function createOver(arrayFunc) {
          return flatRest(function(iteratees) {
            iteratees = arrayMap(iteratees, baseUnary(getIteratee()));
            return baseRest(function(args) {
              var thisArg = this;
              return arrayFunc(iteratees, function(iteratee2) {
                return apply(iteratee2, thisArg, args);
              });
            });
          });
        }
        function createPadding(length, chars) {
          chars = chars === undefined2 ? " " : baseToString(chars);
          var charsLength = chars.length;
          if (charsLength < 2) {
            return charsLength ? baseRepeat(chars, length) : chars;
          }
          var result2 = baseRepeat(chars, nativeCeil(length / stringSize(chars)));
          return hasUnicode(chars) ? castSlice(stringToArray(result2), 0, length).join("") : result2.slice(0, length);
        }
        function createPartial(func, bitmask, thisArg, partials) {
          var isBind = bitmask & WRAP_BIND_FLAG, Ctor = createCtor(func);
          function wrapper() {
            var argsIndex = -1, argsLength = arguments.length, leftIndex = -1, leftLength = partials.length, args = Array2(leftLength + argsLength), fn = this && this !== root && this instanceof wrapper ? Ctor : func;
            while (++leftIndex < leftLength) {
              args[leftIndex] = partials[leftIndex];
            }
            while (argsLength--) {
              args[leftIndex++] = arguments[++argsIndex];
            }
            return apply(fn, isBind ? thisArg : this, args);
          }
          return wrapper;
        }
        function createRange(fromRight) {
          return function(start, end, step) {
            if (step && typeof step != "number" && isIterateeCall(start, end, step)) {
              end = step = undefined2;
            }
            start = toFinite(start);
            if (end === undefined2) {
              end = start;
              start = 0;
            } else {
              end = toFinite(end);
            }
            step = step === undefined2 ? start < end ? 1 : -1 : toFinite(step);
            return baseRange(start, end, step, fromRight);
          };
        }
        function createRelationalOperation(operator) {
          return function(value, other) {
            if (!(typeof value == "string" && typeof other == "string")) {
              value = toNumber(value);
              other = toNumber(other);
            }
            return operator(value, other);
          };
        }
        function createRecurry(func, bitmask, wrapFunc, placeholder, thisArg, partials, holders, argPos, ary2, arity) {
          var isCurry = bitmask & WRAP_CURRY_FLAG, newHolders = isCurry ? holders : undefined2, newHoldersRight = isCurry ? undefined2 : holders, newPartials = isCurry ? partials : undefined2, newPartialsRight = isCurry ? undefined2 : partials;
          bitmask |= isCurry ? WRAP_PARTIAL_FLAG : WRAP_PARTIAL_RIGHT_FLAG;
          bitmask &= ~(isCurry ? WRAP_PARTIAL_RIGHT_FLAG : WRAP_PARTIAL_FLAG);
          if (!(bitmask & WRAP_CURRY_BOUND_FLAG)) {
            bitmask &= -4;
          }
          var newData = [
            func,
            bitmask,
            thisArg,
            newPartials,
            newHolders,
            newPartialsRight,
            newHoldersRight,
            argPos,
            ary2,
            arity
          ];
          var result2 = wrapFunc.apply(undefined2, newData);
          if (isLaziable(func)) {
            setData(result2, newData);
          }
          result2.placeholder = placeholder;
          return setWrapToString(result2, func, bitmask);
        }
        function createRound(methodName) {
          var func = Math2[methodName];
          return function(number, precision) {
            number = toNumber(number);
            precision = precision == null ? 0 : nativeMin(toInteger(precision), 292);
            if (precision && nativeIsFinite(number)) {
              var pair = (toString(number) + "e").split("e"), value = func(pair[0] + "e" + (+pair[1] + precision));
              pair = (toString(value) + "e").split("e");
              return +(pair[0] + "e" + (+pair[1] - precision));
            }
            return func(number);
          };
        }
        var createSet = !(Set && 1 / setToArray(new Set([, -0]))[1] == INFINITY) ? noop2 : function(values2) {
          return new Set(values2);
        };
        function createToPairs(keysFunc) {
          return function(object) {
            var tag = getTag(object);
            if (tag == mapTag) {
              return mapToArray(object);
            }
            if (tag == setTag) {
              return setToPairs(object);
            }
            return baseToPairs(object, keysFunc(object));
          };
        }
        function createWrap(func, bitmask, thisArg, partials, holders, argPos, ary2, arity) {
          var isBindKey = bitmask & WRAP_BIND_KEY_FLAG;
          if (!isBindKey && typeof func != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          var length = partials ? partials.length : 0;
          if (!length) {
            bitmask &= -97;
            partials = holders = undefined2;
          }
          ary2 = ary2 === undefined2 ? ary2 : nativeMax(toInteger(ary2), 0);
          arity = arity === undefined2 ? arity : toInteger(arity);
          length -= holders ? holders.length : 0;
          if (bitmask & WRAP_PARTIAL_RIGHT_FLAG) {
            var partialsRight = partials, holdersRight = holders;
            partials = holders = undefined2;
          }
          var data = isBindKey ? undefined2 : getData(func);
          var newData = [
            func,
            bitmask,
            thisArg,
            partials,
            holders,
            partialsRight,
            holdersRight,
            argPos,
            ary2,
            arity
          ];
          if (data) {
            mergeData(newData, data);
          }
          func = newData[0];
          bitmask = newData[1];
          thisArg = newData[2];
          partials = newData[3];
          holders = newData[4];
          arity = newData[9] = newData[9] === undefined2 ? isBindKey ? 0 : func.length : nativeMax(newData[9] - length, 0);
          if (!arity && bitmask & (WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG)) {
            bitmask &= -25;
          }
          if (!bitmask || bitmask == WRAP_BIND_FLAG) {
            var result2 = createBind(func, bitmask, thisArg);
          } else if (bitmask == WRAP_CURRY_FLAG || bitmask == WRAP_CURRY_RIGHT_FLAG) {
            result2 = createCurry(func, bitmask, arity);
          } else if ((bitmask == WRAP_PARTIAL_FLAG || bitmask == (WRAP_BIND_FLAG | WRAP_PARTIAL_FLAG)) && !holders.length) {
            result2 = createPartial(func, bitmask, thisArg, partials);
          } else {
            result2 = createHybrid.apply(undefined2, newData);
          }
          var setter = data ? baseSetData : setData;
          return setWrapToString(setter(result2, newData), func, bitmask);
        }
        function customDefaultsAssignIn(objValue, srcValue, key, object) {
          if (objValue === undefined2 || eq(objValue, objectProto[key]) && !hasOwnProperty.call(object, key)) {
            return srcValue;
          }
          return objValue;
        }
        function customDefaultsMerge(objValue, srcValue, key, object, source, stack) {
          if (isObject(objValue) && isObject(srcValue)) {
            stack.set(srcValue, objValue);
            baseMerge(objValue, srcValue, undefined2, customDefaultsMerge, stack);
            stack["delete"](srcValue);
          }
          return objValue;
        }
        function customOmitClone(value) {
          return isPlainObject(value) ? undefined2 : value;
        }
        function equalArrays(array, other, bitmask, customizer, equalFunc, stack) {
          var isPartial = bitmask & COMPARE_PARTIAL_FLAG, arrLength = array.length, othLength = other.length;
          if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
            return false;
          }
          var arrStacked = stack.get(array);
          var othStacked = stack.get(other);
          if (arrStacked && othStacked) {
            return arrStacked == other && othStacked == array;
          }
          var index = -1, result2 = true, seen = bitmask & COMPARE_UNORDERED_FLAG ? new SetCache() : undefined2;
          stack.set(array, other);
          stack.set(other, array);
          while (++index < arrLength) {
            var arrValue = array[index], othValue = other[index];
            if (customizer) {
              var compared = isPartial ? customizer(othValue, arrValue, index, other, array, stack) : customizer(arrValue, othValue, index, array, other, stack);
            }
            if (compared !== undefined2) {
              if (compared) {
                continue;
              }
              result2 = false;
              break;
            }
            if (seen) {
              if (!arraySome(other, function(othValue2, othIndex) {
                if (!cacheHas(seen, othIndex) && (arrValue === othValue2 || equalFunc(arrValue, othValue2, bitmask, customizer, stack))) {
                  return seen.push(othIndex);
                }
              })) {
                result2 = false;
                break;
              }
            } else if (!(arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
              result2 = false;
              break;
            }
          }
          stack["delete"](array);
          stack["delete"](other);
          return result2;
        }
        function equalByTag(object, other, tag, bitmask, customizer, equalFunc, stack) {
          switch (tag) {
            case dataViewTag:
              if (object.byteLength != other.byteLength || object.byteOffset != other.byteOffset) {
                return false;
              }
              object = object.buffer;
              other = other.buffer;
            case arrayBufferTag:
              if (object.byteLength != other.byteLength || !equalFunc(new Uint8Array2(object), new Uint8Array2(other))) {
                return false;
              }
              return true;
            case boolTag:
            case dateTag:
            case numberTag:
              return eq(+object, +other);
            case errorTag:
              return object.name == other.name && object.message == other.message;
            case regexpTag:
            case stringTag:
              return object == other + "";
            case mapTag:
              var convert = mapToArray;
            case setTag:
              var isPartial = bitmask & COMPARE_PARTIAL_FLAG;
              convert || (convert = setToArray);
              if (object.size != other.size && !isPartial) {
                return false;
              }
              var stacked = stack.get(object);
              if (stacked) {
                return stacked == other;
              }
              bitmask |= COMPARE_UNORDERED_FLAG;
              stack.set(object, other);
              var result2 = equalArrays(convert(object), convert(other), bitmask, customizer, equalFunc, stack);
              stack["delete"](object);
              return result2;
            case symbolTag:
              if (symbolValueOf) {
                return symbolValueOf.call(object) == symbolValueOf.call(other);
              }
          }
          return false;
        }
        function equalObjects(object, other, bitmask, customizer, equalFunc, stack) {
          var isPartial = bitmask & COMPARE_PARTIAL_FLAG, objProps = getAllKeys(object), objLength = objProps.length, othProps = getAllKeys(other), othLength = othProps.length;
          if (objLength != othLength && !isPartial) {
            return false;
          }
          var index = objLength;
          while (index--) {
            var key = objProps[index];
            if (!(isPartial ? key in other : hasOwnProperty.call(other, key))) {
              return false;
            }
          }
          var objStacked = stack.get(object);
          var othStacked = stack.get(other);
          if (objStacked && othStacked) {
            return objStacked == other && othStacked == object;
          }
          var result2 = true;
          stack.set(object, other);
          stack.set(other, object);
          var skipCtor = isPartial;
          while (++index < objLength) {
            key = objProps[index];
            var objValue = object[key], othValue = other[key];
            if (customizer) {
              var compared = isPartial ? customizer(othValue, objValue, key, other, object, stack) : customizer(objValue, othValue, key, object, other, stack);
            }
            if (!(compared === undefined2 ? objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack) : compared)) {
              result2 = false;
              break;
            }
            skipCtor || (skipCtor = key == "constructor");
          }
          if (result2 && !skipCtor) {
            var objCtor = object.constructor, othCtor = other.constructor;
            if (objCtor != othCtor && ("constructor" in object && "constructor" in other) && !(typeof objCtor == "function" && objCtor instanceof objCtor && typeof othCtor == "function" && othCtor instanceof othCtor)) {
              result2 = false;
            }
          }
          stack["delete"](object);
          stack["delete"](other);
          return result2;
        }
        function flatRest(func) {
          return setToString(overRest(func, undefined2, flatten), func + "");
        }
        function getAllKeys(object) {
          return baseGetAllKeys(object, keys, getSymbols);
        }
        function getAllKeysIn(object) {
          return baseGetAllKeys(object, keysIn, getSymbolsIn);
        }
        var getData = !metaMap ? noop2 : function(func) {
          return metaMap.get(func);
        };
        function getFuncName(func) {
          var result2 = func.name + "", array = realNames[result2], length = hasOwnProperty.call(realNames, result2) ? array.length : 0;
          while (length--) {
            var data = array[length], otherFunc = data.func;
            if (otherFunc == null || otherFunc == func) {
              return data.name;
            }
          }
          return result2;
        }
        function getHolder(func) {
          var object = hasOwnProperty.call(lodash, "placeholder") ? lodash : func;
          return object.placeholder;
        }
        function getIteratee() {
          var result2 = lodash.iteratee || iteratee;
          result2 = result2 === iteratee ? baseIteratee : result2;
          return arguments.length ? result2(arguments[0], arguments[1]) : result2;
        }
        function getMapData(map2, key) {
          var data = map2.__data__;
          return isKeyable(key) ? data[typeof key == "string" ? "string" : "hash"] : data.map;
        }
        function getMatchData(object) {
          var result2 = keys(object), length = result2.length;
          while (length--) {
            var key = result2[length], value = object[key];
            result2[length] = [key, value, isStrictComparable(value)];
          }
          return result2;
        }
        function getNative(object, key) {
          var value = getValue(object, key);
          return baseIsNative(value) ? value : undefined2;
        }
        function getRawTag(value) {
          var isOwn = hasOwnProperty.call(value, symToStringTag), tag = value[symToStringTag];
          try {
            value[symToStringTag] = undefined2;
            var unmasked = true;
          } catch (e) {
          }
          var result2 = nativeObjectToString.call(value);
          if (unmasked) {
            if (isOwn) {
              value[symToStringTag] = tag;
            } else {
              delete value[symToStringTag];
            }
          }
          return result2;
        }
        var getSymbols = !nativeGetSymbols ? stubArray : function(object) {
          if (object == null) {
            return [];
          }
          object = Object2(object);
          return arrayFilter(nativeGetSymbols(object), function(symbol) {
            return propertyIsEnumerable.call(object, symbol);
          });
        };
        var getSymbolsIn = !nativeGetSymbols ? stubArray : function(object) {
          var result2 = [];
          while (object) {
            arrayPush(result2, getSymbols(object));
            object = getPrototype(object);
          }
          return result2;
        };
        var getTag = baseGetTag;
        if (DataView && getTag(new DataView(new ArrayBuffer(1))) != dataViewTag || Map2 && getTag(new Map2()) != mapTag || Promise2 && getTag(Promise2.resolve()) != promiseTag || Set && getTag(new Set()) != setTag || WeakMap && getTag(new WeakMap()) != weakMapTag) {
          getTag = function(value) {
            var result2 = baseGetTag(value), Ctor = result2 == objectTag ? value.constructor : undefined2, ctorString = Ctor ? toSource(Ctor) : "";
            if (ctorString) {
              switch (ctorString) {
                case dataViewCtorString:
                  return dataViewTag;
                case mapCtorString:
                  return mapTag;
                case promiseCtorString:
                  return promiseTag;
                case setCtorString:
                  return setTag;
                case weakMapCtorString:
                  return weakMapTag;
              }
            }
            return result2;
          };
        }
        function getView(start, end, transforms) {
          var index = -1, length = transforms.length;
          while (++index < length) {
            var data = transforms[index], size2 = data.size;
            switch (data.type) {
              case "drop":
                start += size2;
                break;
              case "dropRight":
                end -= size2;
                break;
              case "take":
                end = nativeMin(end, start + size2);
                break;
              case "takeRight":
                start = nativeMax(start, end - size2);
                break;
            }
          }
          return { "start": start, "end": end };
        }
        function getWrapDetails(source) {
          var match = source.match(reWrapDetails);
          return match ? match[1].split(reSplitDetails) : [];
        }
        function hasPath(object, path, hasFunc) {
          path = castPath(path, object);
          var index = -1, length = path.length, result2 = false;
          while (++index < length) {
            var key = toKey(path[index]);
            if (!(result2 = object != null && hasFunc(object, key))) {
              break;
            }
            object = object[key];
          }
          if (result2 || ++index != length) {
            return result2;
          }
          length = object == null ? 0 : object.length;
          return !!length && isLength(length) && isIndex(key, length) && (isArray(object) || isArguments(object));
        }
        function initCloneArray(array) {
          var length = array.length, result2 = new array.constructor(length);
          if (length && typeof array[0] == "string" && hasOwnProperty.call(array, "index")) {
            result2.index = array.index;
            result2.input = array.input;
          }
          return result2;
        }
        function initCloneObject(object) {
          return typeof object.constructor == "function" && !isPrototype(object) ? baseCreate(getPrototype(object)) : {};
        }
        function initCloneByTag(object, tag, isDeep) {
          var Ctor = object.constructor;
          switch (tag) {
            case arrayBufferTag:
              return cloneArrayBuffer(object);
            case boolTag:
            case dateTag:
              return new Ctor(+object);
            case dataViewTag:
              return cloneDataView(object, isDeep);
            case float32Tag:
            case float64Tag:
            case int8Tag:
            case int16Tag:
            case int32Tag:
            case uint8Tag:
            case uint8ClampedTag:
            case uint16Tag:
            case uint32Tag:
              return cloneTypedArray(object, isDeep);
            case mapTag:
              return new Ctor();
            case numberTag:
            case stringTag:
              return new Ctor(object);
            case regexpTag:
              return cloneRegExp(object);
            case setTag:
              return new Ctor();
            case symbolTag:
              return cloneSymbol(object);
          }
        }
        function insertWrapDetails(source, details) {
          var length = details.length;
          if (!length) {
            return source;
          }
          var lastIndex = length - 1;
          details[lastIndex] = (length > 1 ? "& " : "") + details[lastIndex];
          details = details.join(length > 2 ? ", " : " ");
          return source.replace(reWrapComment, "{\n/* [wrapped with " + details + "] */\n");
        }
        function isFlattenable(value) {
          return isArray(value) || isArguments(value) || !!(spreadableSymbol && value && value[spreadableSymbol]);
        }
        function isIndex(value, length) {
          var type = typeof value;
          length = length == null ? MAX_SAFE_INTEGER : length;
          return !!length && (type == "number" || type != "symbol" && reIsUint.test(value)) && (value > -1 && value % 1 == 0 && value < length);
        }
        function isIterateeCall(value, index, object) {
          if (!isObject(object)) {
            return false;
          }
          var type = typeof index;
          if (type == "number" ? isArrayLike(object) && isIndex(index, object.length) : type == "string" && index in object) {
            return eq(object[index], value);
          }
          return false;
        }
        function isKey(value, object) {
          if (isArray(value)) {
            return false;
          }
          var type = typeof value;
          if (type == "number" || type == "symbol" || type == "boolean" || value == null || isSymbol(value)) {
            return true;
          }
          return reIsPlainProp.test(value) || !reIsDeepProp.test(value) || object != null && value in Object2(object);
        }
        function isKeyable(value) {
          var type = typeof value;
          return type == "string" || type == "number" || type == "symbol" || type == "boolean" ? value !== "__proto__" : value === null;
        }
        function isLaziable(func) {
          var funcName = getFuncName(func), other = lodash[funcName];
          if (typeof other != "function" || !(funcName in LazyWrapper.prototype)) {
            return false;
          }
          if (func === other) {
            return true;
          }
          var data = getData(other);
          return !!data && func === data[0];
        }
        function isMasked(func) {
          return !!maskSrcKey && maskSrcKey in func;
        }
        var isMaskable = coreJsData ? isFunction : stubFalse;
        function isPrototype(value) {
          var Ctor = value && value.constructor, proto = typeof Ctor == "function" && Ctor.prototype || objectProto;
          return value === proto;
        }
        function isStrictComparable(value) {
          return value === value && !isObject(value);
        }
        function matchesStrictComparable(key, srcValue) {
          return function(object) {
            if (object == null) {
              return false;
            }
            return object[key] === srcValue && (srcValue !== undefined2 || key in Object2(object));
          };
        }
        function memoizeCapped(func) {
          var result2 = memoize(func, function(key) {
            if (cache.size === MAX_MEMOIZE_SIZE) {
              cache.clear();
            }
            return key;
          });
          var cache = result2.cache;
          return result2;
        }
        function mergeData(data, source) {
          var bitmask = data[1], srcBitmask = source[1], newBitmask = bitmask | srcBitmask, isCommon = newBitmask < (WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG | WRAP_ARY_FLAG);
          var isCombo = srcBitmask == WRAP_ARY_FLAG && bitmask == WRAP_CURRY_FLAG || srcBitmask == WRAP_ARY_FLAG && bitmask == WRAP_REARG_FLAG && data[7].length <= source[8] || srcBitmask == (WRAP_ARY_FLAG | WRAP_REARG_FLAG) && source[7].length <= source[8] && bitmask == WRAP_CURRY_FLAG;
          if (!(isCommon || isCombo)) {
            return data;
          }
          if (srcBitmask & WRAP_BIND_FLAG) {
            data[2] = source[2];
            newBitmask |= bitmask & WRAP_BIND_FLAG ? 0 : WRAP_CURRY_BOUND_FLAG;
          }
          var value = source[3];
          if (value) {
            var partials = data[3];
            data[3] = partials ? composeArgs(partials, value, source[4]) : value;
            data[4] = partials ? replaceHolders(data[3], PLACEHOLDER) : source[4];
          }
          value = source[5];
          if (value) {
            partials = data[5];
            data[5] = partials ? composeArgsRight(partials, value, source[6]) : value;
            data[6] = partials ? replaceHolders(data[5], PLACEHOLDER) : source[6];
          }
          value = source[7];
          if (value) {
            data[7] = value;
          }
          if (srcBitmask & WRAP_ARY_FLAG) {
            data[8] = data[8] == null ? source[8] : nativeMin(data[8], source[8]);
          }
          if (data[9] == null) {
            data[9] = source[9];
          }
          data[0] = source[0];
          data[1] = newBitmask;
          return data;
        }
        function nativeKeysIn(object) {
          var result2 = [];
          if (object != null) {
            for (var key in Object2(object)) {
              result2.push(key);
            }
          }
          return result2;
        }
        function objectToString(value) {
          return nativeObjectToString.call(value);
        }
        function overRest(func, start, transform2) {
          start = nativeMax(start === undefined2 ? func.length - 1 : start, 0);
          return function() {
            var args = arguments, index = -1, length = nativeMax(args.length - start, 0), array = Array2(length);
            while (++index < length) {
              array[index] = args[start + index];
            }
            index = -1;
            var otherArgs = Array2(start + 1);
            while (++index < start) {
              otherArgs[index] = args[index];
            }
            otherArgs[start] = transform2(array);
            return apply(func, this, otherArgs);
          };
        }
        function parent(object, path) {
          return path.length < 2 ? object : baseGet(object, baseSlice(path, 0, -1));
        }
        function reorder(array, indexes) {
          var arrLength = array.length, length = nativeMin(indexes.length, arrLength), oldArray = copyArray(array);
          while (length--) {
            var index = indexes[length];
            array[length] = isIndex(index, arrLength) ? oldArray[index] : undefined2;
          }
          return array;
        }
        function safeGet(object, key) {
          if (key === "constructor" && typeof object[key] === "function") {
            return;
          }
          if (key == "__proto__") {
            return;
          }
          return object[key];
        }
        var setData = shortOut(baseSetData);
        var setTimeout = ctxSetTimeout || function(func, wait) {
          return root.setTimeout(func, wait);
        };
        var setToString = shortOut(baseSetToString);
        function setWrapToString(wrapper, reference, bitmask) {
          var source = reference + "";
          return setToString(wrapper, insertWrapDetails(source, updateWrapDetails(getWrapDetails(source), bitmask)));
        }
        function shortOut(func) {
          var count = 0, lastCalled = 0;
          return function() {
            var stamp = nativeNow(), remaining = HOT_SPAN - (stamp - lastCalled);
            lastCalled = stamp;
            if (remaining > 0) {
              if (++count >= HOT_COUNT) {
                return arguments[0];
              }
            } else {
              count = 0;
            }
            return func.apply(undefined2, arguments);
          };
        }
        function shuffleSelf(array, size2) {
          var index = -1, length = array.length, lastIndex = length - 1;
          size2 = size2 === undefined2 ? length : size2;
          while (++index < size2) {
            var rand = baseRandom(index, lastIndex), value = array[rand];
            array[rand] = array[index];
            array[index] = value;
          }
          array.length = size2;
          return array;
        }
        var stringToPath = memoizeCapped(function(string) {
          var result2 = [];
          if (string.charCodeAt(0) === 46) {
            result2.push("");
          }
          string.replace(rePropName, function(match, number, quote, subString) {
            result2.push(quote ? subString.replace(reEscapeChar, "$1") : number || match);
          });
          return result2;
        });
        function toKey(value) {
          if (typeof value == "string" || isSymbol(value)) {
            return value;
          }
          var result2 = value + "";
          return result2 == "0" && 1 / value == -Infinity ? "-0" : result2;
        }
        function toSource(func) {
          if (func != null) {
            try {
              return funcToString.call(func);
            } catch (e) {
            }
            try {
              return func + "";
            } catch (e) {
            }
          }
          return "";
        }
        function updateWrapDetails(details, bitmask) {
          arrayEach(wrapFlags, function(pair) {
            var value = "_." + pair[0];
            if (bitmask & pair[1] && !arrayIncludes(details, value)) {
              details.push(value);
            }
          });
          return details.sort();
        }
        function wrapperClone(wrapper) {
          if (wrapper instanceof LazyWrapper) {
            return wrapper.clone();
          }
          var result2 = new LodashWrapper(wrapper.__wrapped__, wrapper.__chain__);
          result2.__actions__ = copyArray(wrapper.__actions__);
          result2.__index__ = wrapper.__index__;
          result2.__values__ = wrapper.__values__;
          return result2;
        }
        function chunk(array, size2, guard) {
          if (guard ? isIterateeCall(array, size2, guard) : size2 === undefined2) {
            size2 = 1;
          } else {
            size2 = nativeMax(toInteger(size2), 0);
          }
          var length = array == null ? 0 : array.length;
          if (!length || size2 < 1) {
            return [];
          }
          var index = 0, resIndex = 0, result2 = Array2(nativeCeil(length / size2));
          while (index < length) {
            result2[resIndex++] = baseSlice(array, index, index += size2);
          }
          return result2;
        }
        function compact(array) {
          var index = -1, length = array == null ? 0 : array.length, resIndex = 0, result2 = [];
          while (++index < length) {
            var value = array[index];
            if (value) {
              result2[resIndex++] = value;
            }
          }
          return result2;
        }
        function concat() {
          var length = arguments.length;
          if (!length) {
            return [];
          }
          var args = Array2(length - 1), array = arguments[0], index = length;
          while (index--) {
            args[index - 1] = arguments[index];
          }
          return arrayPush(isArray(array) ? copyArray(array) : [array], baseFlatten(args, 1));
        }
        var difference = baseRest(function(array, values2) {
          return isArrayLikeObject(array) ? baseDifference(array, baseFlatten(values2, 1, isArrayLikeObject, true)) : [];
        });
        var differenceBy = baseRest(function(array, values2) {
          var iteratee2 = last(values2);
          if (isArrayLikeObject(iteratee2)) {
            iteratee2 = undefined2;
          }
          return isArrayLikeObject(array) ? baseDifference(array, baseFlatten(values2, 1, isArrayLikeObject, true), getIteratee(iteratee2, 2)) : [];
        });
        var differenceWith = baseRest(function(array, values2) {
          var comparator = last(values2);
          if (isArrayLikeObject(comparator)) {
            comparator = undefined2;
          }
          return isArrayLikeObject(array) ? baseDifference(array, baseFlatten(values2, 1, isArrayLikeObject, true), undefined2, comparator) : [];
        });
        function drop(array, n, guard) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return [];
          }
          n = guard || n === undefined2 ? 1 : toInteger(n);
          return baseSlice(array, n < 0 ? 0 : n, length);
        }
        function dropRight(array, n, guard) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return [];
          }
          n = guard || n === undefined2 ? 1 : toInteger(n);
          n = length - n;
          return baseSlice(array, 0, n < 0 ? 0 : n);
        }
        function dropRightWhile(array, predicate) {
          return array && array.length ? baseWhile(array, getIteratee(predicate, 3), true, true) : [];
        }
        function dropWhile(array, predicate) {
          return array && array.length ? baseWhile(array, getIteratee(predicate, 3), true) : [];
        }
        function fill(array, value, start, end) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return [];
          }
          if (start && typeof start != "number" && isIterateeCall(array, value, start)) {
            start = 0;
            end = length;
          }
          return baseFill(array, value, start, end);
        }
        function findIndex(array, predicate, fromIndex) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return -1;
          }
          var index = fromIndex == null ? 0 : toInteger(fromIndex);
          if (index < 0) {
            index = nativeMax(length + index, 0);
          }
          return baseFindIndex(array, getIteratee(predicate, 3), index);
        }
        function findLastIndex(array, predicate, fromIndex) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return -1;
          }
          var index = length - 1;
          if (fromIndex !== undefined2) {
            index = toInteger(fromIndex);
            index = fromIndex < 0 ? nativeMax(length + index, 0) : nativeMin(index, length - 1);
          }
          return baseFindIndex(array, getIteratee(predicate, 3), index, true);
        }
        function flatten(array) {
          var length = array == null ? 0 : array.length;
          return length ? baseFlatten(array, 1) : [];
        }
        function flattenDeep(array) {
          var length = array == null ? 0 : array.length;
          return length ? baseFlatten(array, INFINITY) : [];
        }
        function flattenDepth(array, depth) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return [];
          }
          depth = depth === undefined2 ? 1 : toInteger(depth);
          return baseFlatten(array, depth);
        }
        function fromPairs(pairs) {
          var index = -1, length = pairs == null ? 0 : pairs.length, result2 = {};
          while (++index < length) {
            var pair = pairs[index];
            result2[pair[0]] = pair[1];
          }
          return result2;
        }
        function head(array) {
          return array && array.length ? array[0] : undefined2;
        }
        function indexOf(array, value, fromIndex) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return -1;
          }
          var index = fromIndex == null ? 0 : toInteger(fromIndex);
          if (index < 0) {
            index = nativeMax(length + index, 0);
          }
          return baseIndexOf(array, value, index);
        }
        function initial(array) {
          var length = array == null ? 0 : array.length;
          return length ? baseSlice(array, 0, -1) : [];
        }
        var intersection = baseRest(function(arrays) {
          var mapped = arrayMap(arrays, castArrayLikeObject);
          return mapped.length && mapped[0] === arrays[0] ? baseIntersection(mapped) : [];
        });
        var intersectionBy = baseRest(function(arrays) {
          var iteratee2 = last(arrays), mapped = arrayMap(arrays, castArrayLikeObject);
          if (iteratee2 === last(mapped)) {
            iteratee2 = undefined2;
          } else {
            mapped.pop();
          }
          return mapped.length && mapped[0] === arrays[0] ? baseIntersection(mapped, getIteratee(iteratee2, 2)) : [];
        });
        var intersectionWith = baseRest(function(arrays) {
          var comparator = last(arrays), mapped = arrayMap(arrays, castArrayLikeObject);
          comparator = typeof comparator == "function" ? comparator : undefined2;
          if (comparator) {
            mapped.pop();
          }
          return mapped.length && mapped[0] === arrays[0] ? baseIntersection(mapped, undefined2, comparator) : [];
        });
        function join(array, separator) {
          return array == null ? "" : nativeJoin.call(array, separator);
        }
        function last(array) {
          var length = array == null ? 0 : array.length;
          return length ? array[length - 1] : undefined2;
        }
        function lastIndexOf(array, value, fromIndex) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return -1;
          }
          var index = length;
          if (fromIndex !== undefined2) {
            index = toInteger(fromIndex);
            index = index < 0 ? nativeMax(length + index, 0) : nativeMin(index, length - 1);
          }
          return value === value ? strictLastIndexOf(array, value, index) : baseFindIndex(array, baseIsNaN, index, true);
        }
        function nth(array, n) {
          return array && array.length ? baseNth(array, toInteger(n)) : undefined2;
        }
        var pull = baseRest(pullAll);
        function pullAll(array, values2) {
          return array && array.length && values2 && values2.length ? basePullAll(array, values2) : array;
        }
        function pullAllBy(array, values2, iteratee2) {
          return array && array.length && values2 && values2.length ? basePullAll(array, values2, getIteratee(iteratee2, 2)) : array;
        }
        function pullAllWith(array, values2, comparator) {
          return array && array.length && values2 && values2.length ? basePullAll(array, values2, undefined2, comparator) : array;
        }
        var pullAt = flatRest(function(array, indexes) {
          var length = array == null ? 0 : array.length, result2 = baseAt(array, indexes);
          basePullAt(array, arrayMap(indexes, function(index) {
            return isIndex(index, length) ? +index : index;
          }).sort(compareAscending));
          return result2;
        });
        function remove(array, predicate) {
          var result2 = [];
          if (!(array && array.length)) {
            return result2;
          }
          var index = -1, indexes = [], length = array.length;
          predicate = getIteratee(predicate, 3);
          while (++index < length) {
            var value = array[index];
            if (predicate(value, index, array)) {
              result2.push(value);
              indexes.push(index);
            }
          }
          basePullAt(array, indexes);
          return result2;
        }
        function reverse(array) {
          return array == null ? array : nativeReverse.call(array);
        }
        function slice(array, start, end) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return [];
          }
          if (end && typeof end != "number" && isIterateeCall(array, start, end)) {
            start = 0;
            end = length;
          } else {
            start = start == null ? 0 : toInteger(start);
            end = end === undefined2 ? length : toInteger(end);
          }
          return baseSlice(array, start, end);
        }
        function sortedIndex(array, value) {
          return baseSortedIndex(array, value);
        }
        function sortedIndexBy(array, value, iteratee2) {
          return baseSortedIndexBy(array, value, getIteratee(iteratee2, 2));
        }
        function sortedIndexOf(array, value) {
          var length = array == null ? 0 : array.length;
          if (length) {
            var index = baseSortedIndex(array, value);
            if (index < length && eq(array[index], value)) {
              return index;
            }
          }
          return -1;
        }
        function sortedLastIndex(array, value) {
          return baseSortedIndex(array, value, true);
        }
        function sortedLastIndexBy(array, value, iteratee2) {
          return baseSortedIndexBy(array, value, getIteratee(iteratee2, 2), true);
        }
        function sortedLastIndexOf(array, value) {
          var length = array == null ? 0 : array.length;
          if (length) {
            var index = baseSortedIndex(array, value, true) - 1;
            if (eq(array[index], value)) {
              return index;
            }
          }
          return -1;
        }
        function sortedUniq(array) {
          return array && array.length ? baseSortedUniq(array) : [];
        }
        function sortedUniqBy(array, iteratee2) {
          return array && array.length ? baseSortedUniq(array, getIteratee(iteratee2, 2)) : [];
        }
        function tail(array) {
          var length = array == null ? 0 : array.length;
          return length ? baseSlice(array, 1, length) : [];
        }
        function take(array, n, guard) {
          if (!(array && array.length)) {
            return [];
          }
          n = guard || n === undefined2 ? 1 : toInteger(n);
          return baseSlice(array, 0, n < 0 ? 0 : n);
        }
        function takeRight(array, n, guard) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return [];
          }
          n = guard || n === undefined2 ? 1 : toInteger(n);
          n = length - n;
          return baseSlice(array, n < 0 ? 0 : n, length);
        }
        function takeRightWhile(array, predicate) {
          return array && array.length ? baseWhile(array, getIteratee(predicate, 3), false, true) : [];
        }
        function takeWhile(array, predicate) {
          return array && array.length ? baseWhile(array, getIteratee(predicate, 3)) : [];
        }
        var union = baseRest(function(arrays) {
          return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true));
        });
        var unionBy = baseRest(function(arrays) {
          var iteratee2 = last(arrays);
          if (isArrayLikeObject(iteratee2)) {
            iteratee2 = undefined2;
          }
          return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true), getIteratee(iteratee2, 2));
        });
        var unionWith = baseRest(function(arrays) {
          var comparator = last(arrays);
          comparator = typeof comparator == "function" ? comparator : undefined2;
          return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true), undefined2, comparator);
        });
        function uniq(array) {
          return array && array.length ? baseUniq(array) : [];
        }
        function uniqBy(array, iteratee2) {
          return array && array.length ? baseUniq(array, getIteratee(iteratee2, 2)) : [];
        }
        function uniqWith(array, comparator) {
          comparator = typeof comparator == "function" ? comparator : undefined2;
          return array && array.length ? baseUniq(array, undefined2, comparator) : [];
        }
        function unzip(array) {
          if (!(array && array.length)) {
            return [];
          }
          var length = 0;
          array = arrayFilter(array, function(group) {
            if (isArrayLikeObject(group)) {
              length = nativeMax(group.length, length);
              return true;
            }
          });
          return baseTimes(length, function(index) {
            return arrayMap(array, baseProperty(index));
          });
        }
        function unzipWith(array, iteratee2) {
          if (!(array && array.length)) {
            return [];
          }
          var result2 = unzip(array);
          if (iteratee2 == null) {
            return result2;
          }
          return arrayMap(result2, function(group) {
            return apply(iteratee2, undefined2, group);
          });
        }
        var without = baseRest(function(array, values2) {
          return isArrayLikeObject(array) ? baseDifference(array, values2) : [];
        });
        var xor = baseRest(function(arrays) {
          return baseXor(arrayFilter(arrays, isArrayLikeObject));
        });
        var xorBy = baseRest(function(arrays) {
          var iteratee2 = last(arrays);
          if (isArrayLikeObject(iteratee2)) {
            iteratee2 = undefined2;
          }
          return baseXor(arrayFilter(arrays, isArrayLikeObject), getIteratee(iteratee2, 2));
        });
        var xorWith = baseRest(function(arrays) {
          var comparator = last(arrays);
          comparator = typeof comparator == "function" ? comparator : undefined2;
          return baseXor(arrayFilter(arrays, isArrayLikeObject), undefined2, comparator);
        });
        var zip = baseRest(unzip);
        function zipObject(props, values2) {
          return baseZipObject(props || [], values2 || [], assignValue);
        }
        function zipObjectDeep(props, values2) {
          return baseZipObject(props || [], values2 || [], baseSet);
        }
        var zipWith = baseRest(function(arrays) {
          var length = arrays.length, iteratee2 = length > 1 ? arrays[length - 1] : undefined2;
          iteratee2 = typeof iteratee2 == "function" ? (arrays.pop(), iteratee2) : undefined2;
          return unzipWith(arrays, iteratee2);
        });
        function chain(value) {
          var result2 = lodash(value);
          result2.__chain__ = true;
          return result2;
        }
        function tap(value, interceptor) {
          interceptor(value);
          return value;
        }
        function thru(value, interceptor) {
          return interceptor(value);
        }
        var wrapperAt = flatRest(function(paths) {
          var length = paths.length, start = length ? paths[0] : 0, value = this.__wrapped__, interceptor = function(object) {
            return baseAt(object, paths);
          };
          if (length > 1 || this.__actions__.length || !(value instanceof LazyWrapper) || !isIndex(start)) {
            return this.thru(interceptor);
          }
          value = value.slice(start, +start + (length ? 1 : 0));
          value.__actions__.push({
            "func": thru,
            "args": [interceptor],
            "thisArg": undefined2
          });
          return new LodashWrapper(value, this.__chain__).thru(function(array) {
            if (length && !array.length) {
              array.push(undefined2);
            }
            return array;
          });
        });
        function wrapperChain() {
          return chain(this);
        }
        function wrapperCommit() {
          return new LodashWrapper(this.value(), this.__chain__);
        }
        function wrapperNext() {
          if (this.__values__ === undefined2) {
            this.__values__ = toArray(this.value());
          }
          var done = this.__index__ >= this.__values__.length, value = done ? undefined2 : this.__values__[this.__index__++];
          return { "done": done, "value": value };
        }
        function wrapperToIterator() {
          return this;
        }
        function wrapperPlant(value) {
          var result2, parent2 = this;
          while (parent2 instanceof baseLodash) {
            var clone2 = wrapperClone(parent2);
            clone2.__index__ = 0;
            clone2.__values__ = undefined2;
            if (result2) {
              previous.__wrapped__ = clone2;
            } else {
              result2 = clone2;
            }
            var previous = clone2;
            parent2 = parent2.__wrapped__;
          }
          previous.__wrapped__ = value;
          return result2;
        }
        function wrapperReverse() {
          var value = this.__wrapped__;
          if (value instanceof LazyWrapper) {
            var wrapped = value;
            if (this.__actions__.length) {
              wrapped = new LazyWrapper(this);
            }
            wrapped = wrapped.reverse();
            wrapped.__actions__.push({
              "func": thru,
              "args": [reverse],
              "thisArg": undefined2
            });
            return new LodashWrapper(wrapped, this.__chain__);
          }
          return this.thru(reverse);
        }
        function wrapperValue() {
          return baseWrapperValue(this.__wrapped__, this.__actions__);
        }
        var countBy = createAggregator(function(result2, value, key) {
          if (hasOwnProperty.call(result2, key)) {
            ++result2[key];
          } else {
            baseAssignValue(result2, key, 1);
          }
        });
        function every(collection, predicate, guard) {
          var func = isArray(collection) ? arrayEvery : baseEvery;
          if (guard && isIterateeCall(collection, predicate, guard)) {
            predicate = undefined2;
          }
          return func(collection, getIteratee(predicate, 3));
        }
        function filter(collection, predicate) {
          var func = isArray(collection) ? arrayFilter : baseFilter;
          return func(collection, getIteratee(predicate, 3));
        }
        var find = createFind(findIndex);
        var findLast = createFind(findLastIndex);
        function flatMap(collection, iteratee2) {
          return baseFlatten(map(collection, iteratee2), 1);
        }
        function flatMapDeep(collection, iteratee2) {
          return baseFlatten(map(collection, iteratee2), INFINITY);
        }
        function flatMapDepth(collection, iteratee2, depth) {
          depth = depth === undefined2 ? 1 : toInteger(depth);
          return baseFlatten(map(collection, iteratee2), depth);
        }
        function forEach(collection, iteratee2) {
          var func = isArray(collection) ? arrayEach : baseEach;
          return func(collection, getIteratee(iteratee2, 3));
        }
        function forEachRight(collection, iteratee2) {
          var func = isArray(collection) ? arrayEachRight : baseEachRight;
          return func(collection, getIteratee(iteratee2, 3));
        }
        var groupBy = createAggregator(function(result2, value, key) {
          if (hasOwnProperty.call(result2, key)) {
            result2[key].push(value);
          } else {
            baseAssignValue(result2, key, [value]);
          }
        });
        function includes(collection, value, fromIndex, guard) {
          collection = isArrayLike(collection) ? collection : values(collection);
          fromIndex = fromIndex && !guard ? toInteger(fromIndex) : 0;
          var length = collection.length;
          if (fromIndex < 0) {
            fromIndex = nativeMax(length + fromIndex, 0);
          }
          return isString(collection) ? fromIndex <= length && collection.indexOf(value, fromIndex) > -1 : !!length && baseIndexOf(collection, value, fromIndex) > -1;
        }
        var invokeMap = baseRest(function(collection, path, args) {
          var index = -1, isFunc = typeof path == "function", result2 = isArrayLike(collection) ? Array2(collection.length) : [];
          baseEach(collection, function(value) {
            result2[++index] = isFunc ? apply(path, value, args) : baseInvoke(value, path, args);
          });
          return result2;
        });
        var keyBy = createAggregator(function(result2, value, key) {
          baseAssignValue(result2, key, value);
        });
        function map(collection, iteratee2) {
          var func = isArray(collection) ? arrayMap : baseMap;
          return func(collection, getIteratee(iteratee2, 3));
        }
        function orderBy(collection, iteratees, orders, guard) {
          if (collection == null) {
            return [];
          }
          if (!isArray(iteratees)) {
            iteratees = iteratees == null ? [] : [iteratees];
          }
          orders = guard ? undefined2 : orders;
          if (!isArray(orders)) {
            orders = orders == null ? [] : [orders];
          }
          return baseOrderBy(collection, iteratees, orders);
        }
        var partition = createAggregator(function(result2, value, key) {
          result2[key ? 0 : 1].push(value);
        }, function() {
          return [[], []];
        });
        function reduce(collection, iteratee2, accumulator) {
          var func = isArray(collection) ? arrayReduce : baseReduce, initAccum = arguments.length < 3;
          return func(collection, getIteratee(iteratee2, 4), accumulator, initAccum, baseEach);
        }
        function reduceRight(collection, iteratee2, accumulator) {
          var func = isArray(collection) ? arrayReduceRight : baseReduce, initAccum = arguments.length < 3;
          return func(collection, getIteratee(iteratee2, 4), accumulator, initAccum, baseEachRight);
        }
        function reject(collection, predicate) {
          var func = isArray(collection) ? arrayFilter : baseFilter;
          return func(collection, negate(getIteratee(predicate, 3)));
        }
        function sample(collection) {
          var func = isArray(collection) ? arraySample : baseSample;
          return func(collection);
        }
        function sampleSize(collection, n, guard) {
          if (guard ? isIterateeCall(collection, n, guard) : n === undefined2) {
            n = 1;
          } else {
            n = toInteger(n);
          }
          var func = isArray(collection) ? arraySampleSize : baseSampleSize;
          return func(collection, n);
        }
        function shuffle(collection) {
          var func = isArray(collection) ? arrayShuffle : baseShuffle;
          return func(collection);
        }
        function size(collection) {
          if (collection == null) {
            return 0;
          }
          if (isArrayLike(collection)) {
            return isString(collection) ? stringSize(collection) : collection.length;
          }
          var tag = getTag(collection);
          if (tag == mapTag || tag == setTag) {
            return collection.size;
          }
          return baseKeys(collection).length;
        }
        function some(collection, predicate, guard) {
          var func = isArray(collection) ? arraySome : baseSome;
          if (guard && isIterateeCall(collection, predicate, guard)) {
            predicate = undefined2;
          }
          return func(collection, getIteratee(predicate, 3));
        }
        var sortBy = baseRest(function(collection, iteratees) {
          if (collection == null) {
            return [];
          }
          var length = iteratees.length;
          if (length > 1 && isIterateeCall(collection, iteratees[0], iteratees[1])) {
            iteratees = [];
          } else if (length > 2 && isIterateeCall(iteratees[0], iteratees[1], iteratees[2])) {
            iteratees = [iteratees[0]];
          }
          return baseOrderBy(collection, baseFlatten(iteratees, 1), []);
        });
        var now = ctxNow || function() {
          return root.Date.now();
        };
        function after(n, func) {
          if (typeof func != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          n = toInteger(n);
          return function() {
            if (--n < 1) {
              return func.apply(this, arguments);
            }
          };
        }
        function ary(func, n, guard) {
          n = guard ? undefined2 : n;
          n = func && n == null ? func.length : n;
          return createWrap(func, WRAP_ARY_FLAG, undefined2, undefined2, undefined2, undefined2, n);
        }
        function before(n, func) {
          var result2;
          if (typeof func != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          n = toInteger(n);
          return function() {
            if (--n > 0) {
              result2 = func.apply(this, arguments);
            }
            if (n <= 1) {
              func = undefined2;
            }
            return result2;
          };
        }
        var bind = baseRest(function(func, thisArg, partials) {
          var bitmask = WRAP_BIND_FLAG;
          if (partials.length) {
            var holders = replaceHolders(partials, getHolder(bind));
            bitmask |= WRAP_PARTIAL_FLAG;
          }
          return createWrap(func, bitmask, thisArg, partials, holders);
        });
        var bindKey = baseRest(function(object, key, partials) {
          var bitmask = WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG;
          if (partials.length) {
            var holders = replaceHolders(partials, getHolder(bindKey));
            bitmask |= WRAP_PARTIAL_FLAG;
          }
          return createWrap(key, bitmask, object, partials, holders);
        });
        function curry(func, arity, guard) {
          arity = guard ? undefined2 : arity;
          var result2 = createWrap(func, WRAP_CURRY_FLAG, undefined2, undefined2, undefined2, undefined2, undefined2, arity);
          result2.placeholder = curry.placeholder;
          return result2;
        }
        function curryRight(func, arity, guard) {
          arity = guard ? undefined2 : arity;
          var result2 = createWrap(func, WRAP_CURRY_RIGHT_FLAG, undefined2, undefined2, undefined2, undefined2, undefined2, arity);
          result2.placeholder = curryRight.placeholder;
          return result2;
        }
        function debounce(func, wait, options) {
          var lastArgs, lastThis, maxWait, result2, timerId, lastCallTime, lastInvokeTime = 0, leading = false, maxing = false, trailing = true;
          if (typeof func != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          wait = toNumber(wait) || 0;
          if (isObject(options)) {
            leading = !!options.leading;
            maxing = "maxWait" in options;
            maxWait = maxing ? nativeMax(toNumber(options.maxWait) || 0, wait) : maxWait;
            trailing = "trailing" in options ? !!options.trailing : trailing;
          }
          function invokeFunc(time) {
            var args = lastArgs, thisArg = lastThis;
            lastArgs = lastThis = undefined2;
            lastInvokeTime = time;
            result2 = func.apply(thisArg, args);
            return result2;
          }
          function leadingEdge(time) {
            lastInvokeTime = time;
            timerId = setTimeout(timerExpired, wait);
            return leading ? invokeFunc(time) : result2;
          }
          function remainingWait(time) {
            var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime, timeWaiting = wait - timeSinceLastCall;
            return maxing ? nativeMin(timeWaiting, maxWait - timeSinceLastInvoke) : timeWaiting;
          }
          function shouldInvoke(time) {
            var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime;
            return lastCallTime === undefined2 || timeSinceLastCall >= wait || timeSinceLastCall < 0 || maxing && timeSinceLastInvoke >= maxWait;
          }
          function timerExpired() {
            var time = now();
            if (shouldInvoke(time)) {
              return trailingEdge(time);
            }
            timerId = setTimeout(timerExpired, remainingWait(time));
          }
          function trailingEdge(time) {
            timerId = undefined2;
            if (trailing && lastArgs) {
              return invokeFunc(time);
            }
            lastArgs = lastThis = undefined2;
            return result2;
          }
          function cancel() {
            if (timerId !== undefined2) {
              clearTimeout(timerId);
            }
            lastInvokeTime = 0;
            lastArgs = lastCallTime = lastThis = timerId = undefined2;
          }
          function flush() {
            return timerId === undefined2 ? result2 : trailingEdge(now());
          }
          function debounced() {
            var time = now(), isInvoking = shouldInvoke(time);
            lastArgs = arguments;
            lastThis = this;
            lastCallTime = time;
            if (isInvoking) {
              if (timerId === undefined2) {
                return leadingEdge(lastCallTime);
              }
              if (maxing) {
                clearTimeout(timerId);
                timerId = setTimeout(timerExpired, wait);
                return invokeFunc(lastCallTime);
              }
            }
            if (timerId === undefined2) {
              timerId = setTimeout(timerExpired, wait);
            }
            return result2;
          }
          debounced.cancel = cancel;
          debounced.flush = flush;
          return debounced;
        }
        var defer = baseRest(function(func, args) {
          return baseDelay(func, 1, args);
        });
        var delay = baseRest(function(func, wait, args) {
          return baseDelay(func, toNumber(wait) || 0, args);
        });
        function flip3(func) {
          return createWrap(func, WRAP_FLIP_FLAG);
        }
        function memoize(func, resolver) {
          if (typeof func != "function" || resolver != null && typeof resolver != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          var memoized = function() {
            var args = arguments, key = resolver ? resolver.apply(this, args) : args[0], cache = memoized.cache;
            if (cache.has(key)) {
              return cache.get(key);
            }
            var result2 = func.apply(this, args);
            memoized.cache = cache.set(key, result2) || cache;
            return result2;
          };
          memoized.cache = new (memoize.Cache || MapCache)();
          return memoized;
        }
        memoize.Cache = MapCache;
        function negate(predicate) {
          if (typeof predicate != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          return function() {
            var args = arguments;
            switch (args.length) {
              case 0:
                return !predicate.call(this);
              case 1:
                return !predicate.call(this, args[0]);
              case 2:
                return !predicate.call(this, args[0], args[1]);
              case 3:
                return !predicate.call(this, args[0], args[1], args[2]);
            }
            return !predicate.apply(this, args);
          };
        }
        function once(func) {
          return before(2, func);
        }
        var overArgs = castRest(function(func, transforms) {
          transforms = transforms.length == 1 && isArray(transforms[0]) ? arrayMap(transforms[0], baseUnary(getIteratee())) : arrayMap(baseFlatten(transforms, 1), baseUnary(getIteratee()));
          var funcsLength = transforms.length;
          return baseRest(function(args) {
            var index = -1, length = nativeMin(args.length, funcsLength);
            while (++index < length) {
              args[index] = transforms[index].call(this, args[index]);
            }
            return apply(func, this, args);
          });
        });
        var partial = baseRest(function(func, partials) {
          var holders = replaceHolders(partials, getHolder(partial));
          return createWrap(func, WRAP_PARTIAL_FLAG, undefined2, partials, holders);
        });
        var partialRight = baseRest(function(func, partials) {
          var holders = replaceHolders(partials, getHolder(partialRight));
          return createWrap(func, WRAP_PARTIAL_RIGHT_FLAG, undefined2, partials, holders);
        });
        var rearg = flatRest(function(func, indexes) {
          return createWrap(func, WRAP_REARG_FLAG, undefined2, undefined2, undefined2, indexes);
        });
        function rest(func, start) {
          if (typeof func != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          start = start === undefined2 ? start : toInteger(start);
          return baseRest(func, start);
        }
        function spread(func, start) {
          if (typeof func != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          start = start == null ? 0 : nativeMax(toInteger(start), 0);
          return baseRest(function(args) {
            var array = args[start], otherArgs = castSlice(args, 0, start);
            if (array) {
              arrayPush(otherArgs, array);
            }
            return apply(func, this, otherArgs);
          });
        }
        function throttle(func, wait, options) {
          var leading = true, trailing = true;
          if (typeof func != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          if (isObject(options)) {
            leading = "leading" in options ? !!options.leading : leading;
            trailing = "trailing" in options ? !!options.trailing : trailing;
          }
          return debounce(func, wait, {
            "leading": leading,
            "maxWait": wait,
            "trailing": trailing
          });
        }
        function unary(func) {
          return ary(func, 1);
        }
        function wrap(value, wrapper) {
          return partial(castFunction(wrapper), value);
        }
        function castArray() {
          if (!arguments.length) {
            return [];
          }
          var value = arguments[0];
          return isArray(value) ? value : [value];
        }
        function clone(value) {
          return baseClone(value, CLONE_SYMBOLS_FLAG);
        }
        function cloneWith(value, customizer) {
          customizer = typeof customizer == "function" ? customizer : undefined2;
          return baseClone(value, CLONE_SYMBOLS_FLAG, customizer);
        }
        function cloneDeep(value) {
          return baseClone(value, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG);
        }
        function cloneDeepWith(value, customizer) {
          customizer = typeof customizer == "function" ? customizer : undefined2;
          return baseClone(value, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG, customizer);
        }
        function conformsTo(object, source) {
          return source == null || baseConformsTo(object, source, keys(source));
        }
        function eq(value, other) {
          return value === other || value !== value && other !== other;
        }
        var gt = createRelationalOperation(baseGt);
        var gte = createRelationalOperation(function(value, other) {
          return value >= other;
        });
        var isArguments = baseIsArguments(/* @__PURE__ */ function() {
          return arguments;
        }()) ? baseIsArguments : function(value) {
          return isObjectLike(value) && hasOwnProperty.call(value, "callee") && !propertyIsEnumerable.call(value, "callee");
        };
        var isArray = Array2.isArray;
        var isArrayBuffer = nodeIsArrayBuffer ? baseUnary(nodeIsArrayBuffer) : baseIsArrayBuffer;
        function isArrayLike(value) {
          return value != null && isLength(value.length) && !isFunction(value);
        }
        function isArrayLikeObject(value) {
          return isObjectLike(value) && isArrayLike(value);
        }
        function isBoolean(value) {
          return value === true || value === false || isObjectLike(value) && baseGetTag(value) == boolTag;
        }
        var isBuffer = nativeIsBuffer || stubFalse;
        var isDate = nodeIsDate ? baseUnary(nodeIsDate) : baseIsDate;
        function isElement(value) {
          return isObjectLike(value) && value.nodeType === 1 && !isPlainObject(value);
        }
        function isEmpty(value) {
          if (value == null) {
            return true;
          }
          if (isArrayLike(value) && (isArray(value) || typeof value == "string" || typeof value.splice == "function" || isBuffer(value) || isTypedArray(value) || isArguments(value))) {
            return !value.length;
          }
          var tag = getTag(value);
          if (tag == mapTag || tag == setTag) {
            return !value.size;
          }
          if (isPrototype(value)) {
            return !baseKeys(value).length;
          }
          for (var key in value) {
            if (hasOwnProperty.call(value, key)) {
              return false;
            }
          }
          return true;
        }
        function isEqual(value, other) {
          return baseIsEqual(value, other);
        }
        function isEqualWith(value, other, customizer) {
          customizer = typeof customizer == "function" ? customizer : undefined2;
          var result2 = customizer ? customizer(value, other) : undefined2;
          return result2 === undefined2 ? baseIsEqual(value, other, undefined2, customizer) : !!result2;
        }
        function isError(value) {
          if (!isObjectLike(value)) {
            return false;
          }
          var tag = baseGetTag(value);
          return tag == errorTag || tag == domExcTag || typeof value.message == "string" && typeof value.name == "string" && !isPlainObject(value);
        }
        function isFinite(value) {
          return typeof value == "number" && nativeIsFinite(value);
        }
        function isFunction(value) {
          if (!isObject(value)) {
            return false;
          }
          var tag = baseGetTag(value);
          return tag == funcTag || tag == genTag || tag == asyncTag || tag == proxyTag;
        }
        function isInteger(value) {
          return typeof value == "number" && value == toInteger(value);
        }
        function isLength(value) {
          return typeof value == "number" && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
        }
        function isObject(value) {
          var type = typeof value;
          return value != null && (type == "object" || type == "function");
        }
        function isObjectLike(value) {
          return value != null && typeof value == "object";
        }
        var isMap = nodeIsMap ? baseUnary(nodeIsMap) : baseIsMap;
        function isMatch(object, source) {
          return object === source || baseIsMatch(object, source, getMatchData(source));
        }
        function isMatchWith(object, source, customizer) {
          customizer = typeof customizer == "function" ? customizer : undefined2;
          return baseIsMatch(object, source, getMatchData(source), customizer);
        }
        function isNaN2(value) {
          return isNumber(value) && value != +value;
        }
        function isNative(value) {
          if (isMaskable(value)) {
            throw new Error3(CORE_ERROR_TEXT);
          }
          return baseIsNative(value);
        }
        function isNull(value) {
          return value === null;
        }
        function isNil(value) {
          return value == null;
        }
        function isNumber(value) {
          return typeof value == "number" || isObjectLike(value) && baseGetTag(value) == numberTag;
        }
        function isPlainObject(value) {
          if (!isObjectLike(value) || baseGetTag(value) != objectTag) {
            return false;
          }
          var proto = getPrototype(value);
          if (proto === null) {
            return true;
          }
          var Ctor = hasOwnProperty.call(proto, "constructor") && proto.constructor;
          return typeof Ctor == "function" && Ctor instanceof Ctor && funcToString.call(Ctor) == objectCtorString;
        }
        var isRegExp = nodeIsRegExp ? baseUnary(nodeIsRegExp) : baseIsRegExp;
        function isSafeInteger(value) {
          return isInteger(value) && value >= -9007199254740991 && value <= MAX_SAFE_INTEGER;
        }
        var isSet = nodeIsSet ? baseUnary(nodeIsSet) : baseIsSet;
        function isString(value) {
          return typeof value == "string" || !isArray(value) && isObjectLike(value) && baseGetTag(value) == stringTag;
        }
        function isSymbol(value) {
          return typeof value == "symbol" || isObjectLike(value) && baseGetTag(value) == symbolTag;
        }
        var isTypedArray = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : baseIsTypedArray;
        function isUndefined(value) {
          return value === undefined2;
        }
        function isWeakMap(value) {
          return isObjectLike(value) && getTag(value) == weakMapTag;
        }
        function isWeakSet(value) {
          return isObjectLike(value) && baseGetTag(value) == weakSetTag;
        }
        var lt = createRelationalOperation(baseLt);
        var lte = createRelationalOperation(function(value, other) {
          return value <= other;
        });
        function toArray(value) {
          if (!value) {
            return [];
          }
          if (isArrayLike(value)) {
            return isString(value) ? stringToArray(value) : copyArray(value);
          }
          if (symIterator && value[symIterator]) {
            return iteratorToArray(value[symIterator]());
          }
          var tag = getTag(value), func = tag == mapTag ? mapToArray : tag == setTag ? setToArray : values;
          return func(value);
        }
        function toFinite(value) {
          if (!value) {
            return value === 0 ? value : 0;
          }
          value = toNumber(value);
          if (value === INFINITY || value === -Infinity) {
            var sign = value < 0 ? -1 : 1;
            return sign * MAX_INTEGER;
          }
          return value === value ? value : 0;
        }
        function toInteger(value) {
          var result2 = toFinite(value), remainder = result2 % 1;
          return result2 === result2 ? remainder ? result2 - remainder : result2 : 0;
        }
        function toLength(value) {
          return value ? baseClamp(toInteger(value), 0, MAX_ARRAY_LENGTH) : 0;
        }
        function toNumber(value) {
          if (typeof value == "number") {
            return value;
          }
          if (isSymbol(value)) {
            return NAN;
          }
          if (isObject(value)) {
            var other = typeof value.valueOf == "function" ? value.valueOf() : value;
            value = isObject(other) ? other + "" : other;
          }
          if (typeof value != "string") {
            return value === 0 ? value : +value;
          }
          value = baseTrim(value);
          var isBinary = reIsBinary.test(value);
          return isBinary || reIsOctal.test(value) ? freeParseInt(value.slice(2), isBinary ? 2 : 8) : reIsBadHex.test(value) ? NAN : +value;
        }
        function toPlainObject(value) {
          return copyObject(value, keysIn(value));
        }
        function toSafeInteger(value) {
          return value ? baseClamp(toInteger(value), -9007199254740991, MAX_SAFE_INTEGER) : value === 0 ? value : 0;
        }
        function toString(value) {
          return value == null ? "" : baseToString(value);
        }
        var assign = createAssigner(function(object, source) {
          if (isPrototype(source) || isArrayLike(source)) {
            copyObject(source, keys(source), object);
            return;
          }
          for (var key in source) {
            if (hasOwnProperty.call(source, key)) {
              assignValue(object, key, source[key]);
            }
          }
        });
        var assignIn = createAssigner(function(object, source) {
          copyObject(source, keysIn(source), object);
        });
        var assignInWith = createAssigner(function(object, source, srcIndex, customizer) {
          copyObject(source, keysIn(source), object, customizer);
        });
        var assignWith = createAssigner(function(object, source, srcIndex, customizer) {
          copyObject(source, keys(source), object, customizer);
        });
        var at = flatRest(baseAt);
        function create(prototype, properties) {
          var result2 = baseCreate(prototype);
          return properties == null ? result2 : baseAssign(result2, properties);
        }
        var defaults = baseRest(function(object, sources) {
          object = Object2(object);
          var index = -1;
          var length = sources.length;
          var guard = length > 2 ? sources[2] : undefined2;
          if (guard && isIterateeCall(sources[0], sources[1], guard)) {
            length = 1;
          }
          while (++index < length) {
            var source = sources[index];
            var props = keysIn(source);
            var propsIndex = -1;
            var propsLength = props.length;
            while (++propsIndex < propsLength) {
              var key = props[propsIndex];
              var value = object[key];
              if (value === undefined2 || eq(value, objectProto[key]) && !hasOwnProperty.call(object, key)) {
                object[key] = source[key];
              }
            }
          }
          return object;
        });
        var defaultsDeep = baseRest(function(args) {
          args.push(undefined2, customDefaultsMerge);
          return apply(mergeWith, undefined2, args);
        });
        function findKey(object, predicate) {
          return baseFindKey(object, getIteratee(predicate, 3), baseForOwn);
        }
        function findLastKey(object, predicate) {
          return baseFindKey(object, getIteratee(predicate, 3), baseForOwnRight);
        }
        function forIn(object, iteratee2) {
          return object == null ? object : baseFor(object, getIteratee(iteratee2, 3), keysIn);
        }
        function forInRight(object, iteratee2) {
          return object == null ? object : baseForRight(object, getIteratee(iteratee2, 3), keysIn);
        }
        function forOwn(object, iteratee2) {
          return object && baseForOwn(object, getIteratee(iteratee2, 3));
        }
        function forOwnRight(object, iteratee2) {
          return object && baseForOwnRight(object, getIteratee(iteratee2, 3));
        }
        function functions(object) {
          return object == null ? [] : baseFunctions(object, keys(object));
        }
        function functionsIn(object) {
          return object == null ? [] : baseFunctions(object, keysIn(object));
        }
        function get(object, path, defaultValue) {
          var result2 = object == null ? undefined2 : baseGet(object, path);
          return result2 === undefined2 ? defaultValue : result2;
        }
        function has(object, path) {
          return object != null && hasPath(object, path, baseHas);
        }
        function hasIn(object, path) {
          return object != null && hasPath(object, path, baseHasIn);
        }
        var invert = createInverter(function(result2, value, key) {
          if (value != null && typeof value.toString != "function") {
            value = nativeObjectToString.call(value);
          }
          result2[value] = key;
        }, constant(identity));
        var invertBy = createInverter(function(result2, value, key) {
          if (value != null && typeof value.toString != "function") {
            value = nativeObjectToString.call(value);
          }
          if (hasOwnProperty.call(result2, value)) {
            result2[value].push(key);
          } else {
            result2[value] = [key];
          }
        }, getIteratee);
        var invoke = baseRest(baseInvoke);
        function keys(object) {
          return isArrayLike(object) ? arrayLikeKeys(object) : baseKeys(object);
        }
        function keysIn(object) {
          return isArrayLike(object) ? arrayLikeKeys(object, true) : baseKeysIn(object);
        }
        function mapKeys(object, iteratee2) {
          var result2 = {};
          iteratee2 = getIteratee(iteratee2, 3);
          baseForOwn(object, function(value, key, object2) {
            baseAssignValue(result2, iteratee2(value, key, object2), value);
          });
          return result2;
        }
        function mapValues(object, iteratee2) {
          var result2 = {};
          iteratee2 = getIteratee(iteratee2, 3);
          baseForOwn(object, function(value, key, object2) {
            baseAssignValue(result2, key, iteratee2(value, key, object2));
          });
          return result2;
        }
        var merge2 = createAssigner(function(object, source, srcIndex) {
          baseMerge(object, source, srcIndex);
        });
        var mergeWith = createAssigner(function(object, source, srcIndex, customizer) {
          baseMerge(object, source, srcIndex, customizer);
        });
        var omit = flatRest(function(object, paths) {
          var result2 = {};
          if (object == null) {
            return result2;
          }
          var isDeep = false;
          paths = arrayMap(paths, function(path) {
            path = castPath(path, object);
            isDeep || (isDeep = path.length > 1);
            return path;
          });
          copyObject(object, getAllKeysIn(object), result2);
          if (isDeep) {
            result2 = baseClone(result2, CLONE_DEEP_FLAG | CLONE_FLAT_FLAG | CLONE_SYMBOLS_FLAG, customOmitClone);
          }
          var length = paths.length;
          while (length--) {
            baseUnset(result2, paths[length]);
          }
          return result2;
        });
        function omitBy(object, predicate) {
          return pickBy2(object, negate(getIteratee(predicate)));
        }
        var pick2 = flatRest(function(object, paths) {
          return object == null ? {} : basePick(object, paths);
        });
        function pickBy2(object, predicate) {
          if (object == null) {
            return {};
          }
          var props = arrayMap(getAllKeysIn(object), function(prop) {
            return [prop];
          });
          predicate = getIteratee(predicate);
          return basePickBy(object, props, function(value, path) {
            return predicate(value, path[0]);
          });
        }
        function result(object, path, defaultValue) {
          path = castPath(path, object);
          var index = -1, length = path.length;
          if (!length) {
            length = 1;
            object = undefined2;
          }
          while (++index < length) {
            var value = object == null ? undefined2 : object[toKey(path[index])];
            if (value === undefined2) {
              index = length;
              value = defaultValue;
            }
            object = isFunction(value) ? value.call(object) : value;
          }
          return object;
        }
        function set(object, path, value) {
          return object == null ? object : baseSet(object, path, value);
        }
        function setWith(object, path, value, customizer) {
          customizer = typeof customizer == "function" ? customizer : undefined2;
          return object == null ? object : baseSet(object, path, value, customizer);
        }
        var toPairs = createToPairs(keys);
        var toPairsIn = createToPairs(keysIn);
        function transform(object, iteratee2, accumulator) {
          var isArr = isArray(object), isArrLike = isArr || isBuffer(object) || isTypedArray(object);
          iteratee2 = getIteratee(iteratee2, 4);
          if (accumulator == null) {
            var Ctor = object && object.constructor;
            if (isArrLike) {
              accumulator = isArr ? new Ctor() : [];
            } else if (isObject(object)) {
              accumulator = isFunction(Ctor) ? baseCreate(getPrototype(object)) : {};
            } else {
              accumulator = {};
            }
          }
          (isArrLike ? arrayEach : baseForOwn)(object, function(value, index, object2) {
            return iteratee2(accumulator, value, index, object2);
          });
          return accumulator;
        }
        function unset(object, path) {
          return object == null ? true : baseUnset(object, path);
        }
        function update(object, path, updater) {
          return object == null ? object : baseUpdate(object, path, castFunction(updater));
        }
        function updateWith(object, path, updater, customizer) {
          customizer = typeof customizer == "function" ? customizer : undefined2;
          return object == null ? object : baseUpdate(object, path, castFunction(updater), customizer);
        }
        function values(object) {
          return object == null ? [] : baseValues(object, keys(object));
        }
        function valuesIn(object) {
          return object == null ? [] : baseValues(object, keysIn(object));
        }
        function clamp(number, lower, upper) {
          if (upper === undefined2) {
            upper = lower;
            lower = undefined2;
          }
          if (upper !== undefined2) {
            upper = toNumber(upper);
            upper = upper === upper ? upper : 0;
          }
          if (lower !== undefined2) {
            lower = toNumber(lower);
            lower = lower === lower ? lower : 0;
          }
          return baseClamp(toNumber(number), lower, upper);
        }
        function inRange(number, start, end) {
          start = toFinite(start);
          if (end === undefined2) {
            end = start;
            start = 0;
          } else {
            end = toFinite(end);
          }
          number = toNumber(number);
          return baseInRange(number, start, end);
        }
        function random(lower, upper, floating) {
          if (floating && typeof floating != "boolean" && isIterateeCall(lower, upper, floating)) {
            upper = floating = undefined2;
          }
          if (floating === undefined2) {
            if (typeof upper == "boolean") {
              floating = upper;
              upper = undefined2;
            } else if (typeof lower == "boolean") {
              floating = lower;
              lower = undefined2;
            }
          }
          if (lower === undefined2 && upper === undefined2) {
            lower = 0;
            upper = 1;
          } else {
            lower = toFinite(lower);
            if (upper === undefined2) {
              upper = lower;
              lower = 0;
            } else {
              upper = toFinite(upper);
            }
          }
          if (lower > upper) {
            var temp = lower;
            lower = upper;
            upper = temp;
          }
          if (floating || lower % 1 || upper % 1) {
            var rand = nativeRandom();
            return nativeMin(lower + rand * (upper - lower + freeParseFloat("1e-" + ((rand + "").length - 1))), upper);
          }
          return baseRandom(lower, upper);
        }
        var camelCase = createCompounder(function(result2, word, index) {
          word = word.toLowerCase();
          return result2 + (index ? capitalize(word) : word);
        });
        function capitalize(string) {
          return upperFirst(toString(string).toLowerCase());
        }
        function deburr(string) {
          string = toString(string);
          return string && string.replace(reLatin, deburrLetter).replace(reComboMark, "");
        }
        function endsWith(string, target, position) {
          string = toString(string);
          target = baseToString(target);
          var length = string.length;
          position = position === undefined2 ? length : baseClamp(toInteger(position), 0, length);
          var end = position;
          position -= target.length;
          return position >= 0 && string.slice(position, end) == target;
        }
        function escape(string) {
          string = toString(string);
          return string && reHasUnescapedHtml.test(string) ? string.replace(reUnescapedHtml, escapeHtmlChar) : string;
        }
        function escapeRegExp(string) {
          string = toString(string);
          return string && reHasRegExpChar.test(string) ? string.replace(reRegExpChar, "\\$&") : string;
        }
        var kebabCase = createCompounder(function(result2, word, index) {
          return result2 + (index ? "-" : "") + word.toLowerCase();
        });
        var lowerCase = createCompounder(function(result2, word, index) {
          return result2 + (index ? " " : "") + word.toLowerCase();
        });
        var lowerFirst = createCaseFirst("toLowerCase");
        function pad(string, length, chars) {
          string = toString(string);
          length = toInteger(length);
          var strLength = length ? stringSize(string) : 0;
          if (!length || strLength >= length) {
            return string;
          }
          var mid = (length - strLength) / 2;
          return createPadding(nativeFloor(mid), chars) + string + createPadding(nativeCeil(mid), chars);
        }
        function padEnd(string, length, chars) {
          string = toString(string);
          length = toInteger(length);
          var strLength = length ? stringSize(string) : 0;
          return length && strLength < length ? string + createPadding(length - strLength, chars) : string;
        }
        function padStart(string, length, chars) {
          string = toString(string);
          length = toInteger(length);
          var strLength = length ? stringSize(string) : 0;
          return length && strLength < length ? createPadding(length - strLength, chars) + string : string;
        }
        function parseInt2(string, radix, guard) {
          if (guard || radix == null) {
            radix = 0;
          } else if (radix) {
            radix = +radix;
          }
          return nativeParseInt(toString(string).replace(reTrimStart, ""), radix || 0);
        }
        function repeat(string, n, guard) {
          if (guard ? isIterateeCall(string, n, guard) : n === undefined2) {
            n = 1;
          } else {
            n = toInteger(n);
          }
          return baseRepeat(toString(string), n);
        }
        function replace() {
          var args = arguments, string = toString(args[0]);
          return args.length < 3 ? string : string.replace(args[1], args[2]);
        }
        var snakeCase = createCompounder(function(result2, word, index) {
          return result2 + (index ? "_" : "") + word.toLowerCase();
        });
        function split(string, separator, limit) {
          if (limit && typeof limit != "number" && isIterateeCall(string, separator, limit)) {
            separator = limit = undefined2;
          }
          limit = limit === undefined2 ? MAX_ARRAY_LENGTH : limit >>> 0;
          if (!limit) {
            return [];
          }
          string = toString(string);
          if (string && (typeof separator == "string" || separator != null && !isRegExp(separator))) {
            separator = baseToString(separator);
            if (!separator && hasUnicode(string)) {
              return castSlice(stringToArray(string), 0, limit);
            }
          }
          return string.split(separator, limit);
        }
        var startCase = createCompounder(function(result2, word, index) {
          return result2 + (index ? " " : "") + upperFirst(word);
        });
        function startsWith(string, target, position) {
          string = toString(string);
          position = position == null ? 0 : baseClamp(toInteger(position), 0, string.length);
          target = baseToString(target);
          return string.slice(position, position + target.length) == target;
        }
        function template(string, options, guard) {
          var settings = lodash.templateSettings;
          if (guard && isIterateeCall(string, options, guard)) {
            options = undefined2;
          }
          string = toString(string);
          options = assignInWith({}, options, settings, customDefaultsAssignIn);
          var imports = assignInWith({}, options.imports, settings.imports, customDefaultsAssignIn), importsKeys = keys(imports), importsValues = baseValues(imports, importsKeys);
          var isEscaping, isEvaluating, index = 0, interpolate = options.interpolate || reNoMatch, source = "__p += '";
          var reDelimiters = RegExp2(
            (options.escape || reNoMatch).source + "|" + interpolate.source + "|" + (interpolate === reInterpolate ? reEsTemplate : reNoMatch).source + "|" + (options.evaluate || reNoMatch).source + "|$",
            "g"
          );
          var sourceURL = "//# sourceURL=" + (hasOwnProperty.call(options, "sourceURL") ? (options.sourceURL + "").replace(/\s/g, " ") : "lodash.templateSources[" + ++templateCounter + "]") + "\n";
          string.replace(reDelimiters, function(match, escapeValue, interpolateValue, esTemplateValue, evaluateValue, offset3) {
            interpolateValue || (interpolateValue = esTemplateValue);
            source += string.slice(index, offset3).replace(reUnescapedString, escapeStringChar);
            if (escapeValue) {
              isEscaping = true;
              source += "' +\n__e(" + escapeValue + ") +\n'";
            }
            if (evaluateValue) {
              isEvaluating = true;
              source += "';\n" + evaluateValue + ";\n__p += '";
            }
            if (interpolateValue) {
              source += "' +\n((__t = (" + interpolateValue + ")) == null ? '' : __t) +\n'";
            }
            index = offset3 + match.length;
            return match;
          });
          source += "';\n";
          var variable = hasOwnProperty.call(options, "variable") && options.variable;
          if (!variable) {
            source = "with (obj) {\n" + source + "\n}\n";
          } else if (reForbiddenIdentifierChars.test(variable)) {
            throw new Error3(INVALID_TEMPL_VAR_ERROR_TEXT);
          }
          source = (isEvaluating ? source.replace(reEmptyStringLeading, "") : source).replace(reEmptyStringMiddle, "$1").replace(reEmptyStringTrailing, "$1;");
          source = "function(" + (variable || "obj") + ") {\n" + (variable ? "" : "obj || (obj = {});\n") + "var __t, __p = ''" + (isEscaping ? ", __e = _.escape" : "") + (isEvaluating ? ", __j = Array.prototype.join;\nfunction print() { __p += __j.call(arguments, '') }\n" : ";\n") + source + "return __p\n}";
          var result2 = attempt(function() {
            return Function2(importsKeys, sourceURL + "return " + source).apply(undefined2, importsValues);
          });
          result2.source = source;
          if (isError(result2)) {
            throw result2;
          }
          return result2;
        }
        function toLower(value) {
          return toString(value).toLowerCase();
        }
        function toUpper(value) {
          return toString(value).toUpperCase();
        }
        function trim(string, chars, guard) {
          string = toString(string);
          if (string && (guard || chars === undefined2)) {
            return baseTrim(string);
          }
          if (!string || !(chars = baseToString(chars))) {
            return string;
          }
          var strSymbols = stringToArray(string), chrSymbols = stringToArray(chars), start = charsStartIndex(strSymbols, chrSymbols), end = charsEndIndex(strSymbols, chrSymbols) + 1;
          return castSlice(strSymbols, start, end).join("");
        }
        function trimEnd(string, chars, guard) {
          string = toString(string);
          if (string && (guard || chars === undefined2)) {
            return string.slice(0, trimmedEndIndex(string) + 1);
          }
          if (!string || !(chars = baseToString(chars))) {
            return string;
          }
          var strSymbols = stringToArray(string), end = charsEndIndex(strSymbols, stringToArray(chars)) + 1;
          return castSlice(strSymbols, 0, end).join("");
        }
        function trimStart(string, chars, guard) {
          string = toString(string);
          if (string && (guard || chars === undefined2)) {
            return string.replace(reTrimStart, "");
          }
          if (!string || !(chars = baseToString(chars))) {
            return string;
          }
          var strSymbols = stringToArray(string), start = charsStartIndex(strSymbols, stringToArray(chars));
          return castSlice(strSymbols, start).join("");
        }
        function truncate(string, options) {
          var length = DEFAULT_TRUNC_LENGTH, omission = DEFAULT_TRUNC_OMISSION;
          if (isObject(options)) {
            var separator = "separator" in options ? options.separator : separator;
            length = "length" in options ? toInteger(options.length) : length;
            omission = "omission" in options ? baseToString(options.omission) : omission;
          }
          string = toString(string);
          var strLength = string.length;
          if (hasUnicode(string)) {
            var strSymbols = stringToArray(string);
            strLength = strSymbols.length;
          }
          if (length >= strLength) {
            return string;
          }
          var end = length - stringSize(omission);
          if (end < 1) {
            return omission;
          }
          var result2 = strSymbols ? castSlice(strSymbols, 0, end).join("") : string.slice(0, end);
          if (separator === undefined2) {
            return result2 + omission;
          }
          if (strSymbols) {
            end += result2.length - end;
          }
          if (isRegExp(separator)) {
            if (string.slice(end).search(separator)) {
              var match, substring = result2;
              if (!separator.global) {
                separator = RegExp2(separator.source, toString(reFlags.exec(separator)) + "g");
              }
              separator.lastIndex = 0;
              while (match = separator.exec(substring)) {
                var newEnd = match.index;
              }
              result2 = result2.slice(0, newEnd === undefined2 ? end : newEnd);
            }
          } else if (string.indexOf(baseToString(separator), end) != end) {
            var index = result2.lastIndexOf(separator);
            if (index > -1) {
              result2 = result2.slice(0, index);
            }
          }
          return result2 + omission;
        }
        function unescape(string) {
          string = toString(string);
          return string && reHasEscapedHtml.test(string) ? string.replace(reEscapedHtml, unescapeHtmlChar) : string;
        }
        var upperCase = createCompounder(function(result2, word, index) {
          return result2 + (index ? " " : "") + word.toUpperCase();
        });
        var upperFirst = createCaseFirst("toUpperCase");
        function words(string, pattern, guard) {
          string = toString(string);
          pattern = guard ? undefined2 : pattern;
          if (pattern === undefined2) {
            return hasUnicodeWord(string) ? unicodeWords(string) : asciiWords(string);
          }
          return string.match(pattern) || [];
        }
        var attempt = baseRest(function(func, args) {
          try {
            return apply(func, undefined2, args);
          } catch (e) {
            return isError(e) ? e : new Error3(e);
          }
        });
        var bindAll = flatRest(function(object, methodNames) {
          arrayEach(methodNames, function(key) {
            key = toKey(key);
            baseAssignValue(object, key, bind(object[key], object));
          });
          return object;
        });
        function cond(pairs) {
          var length = pairs == null ? 0 : pairs.length, toIteratee = getIteratee();
          pairs = !length ? [] : arrayMap(pairs, function(pair) {
            if (typeof pair[1] != "function") {
              throw new TypeError2(FUNC_ERROR_TEXT);
            }
            return [toIteratee(pair[0]), pair[1]];
          });
          return baseRest(function(args) {
            var index = -1;
            while (++index < length) {
              var pair = pairs[index];
              if (apply(pair[0], this, args)) {
                return apply(pair[1], this, args);
              }
            }
          });
        }
        function conforms(source) {
          return baseConforms(baseClone(source, CLONE_DEEP_FLAG));
        }
        function constant(value) {
          return function() {
            return value;
          };
        }
        function defaultTo(value, defaultValue) {
          return value == null || value !== value ? defaultValue : value;
        }
        var flow = createFlow();
        var flowRight = createFlow(true);
        function identity(value) {
          return value;
        }
        function iteratee(func) {
          return baseIteratee(typeof func == "function" ? func : baseClone(func, CLONE_DEEP_FLAG));
        }
        function matches(source) {
          return baseMatches(baseClone(source, CLONE_DEEP_FLAG));
        }
        function matchesProperty(path, srcValue) {
          return baseMatchesProperty(path, baseClone(srcValue, CLONE_DEEP_FLAG));
        }
        var method = baseRest(function(path, args) {
          return function(object) {
            return baseInvoke(object, path, args);
          };
        });
        var methodOf = baseRest(function(object, args) {
          return function(path) {
            return baseInvoke(object, path, args);
          };
        });
        function mixin(object, source, options) {
          var props = keys(source), methodNames = baseFunctions(source, props);
          if (options == null && !(isObject(source) && (methodNames.length || !props.length))) {
            options = source;
            source = object;
            object = this;
            methodNames = baseFunctions(source, keys(source));
          }
          var chain2 = !(isObject(options) && "chain" in options) || !!options.chain, isFunc = isFunction(object);
          arrayEach(methodNames, function(methodName) {
            var func = source[methodName];
            object[methodName] = func;
            if (isFunc) {
              object.prototype[methodName] = function() {
                var chainAll = this.__chain__;
                if (chain2 || chainAll) {
                  var result2 = object(this.__wrapped__), actions = result2.__actions__ = copyArray(this.__actions__);
                  actions.push({ "func": func, "args": arguments, "thisArg": object });
                  result2.__chain__ = chainAll;
                  return result2;
                }
                return func.apply(object, arrayPush([this.value()], arguments));
              };
            }
          });
          return object;
        }
        function noConflict() {
          if (root._ === this) {
            root._ = oldDash;
          }
          return this;
        }
        function noop2() {
        }
        function nthArg(n) {
          n = toInteger(n);
          return baseRest(function(args) {
            return baseNth(args, n);
          });
        }
        var over = createOver(arrayMap);
        var overEvery = createOver(arrayEvery);
        var overSome = createOver(arraySome);
        function property(path) {
          return isKey(path) ? baseProperty(toKey(path)) : basePropertyDeep(path);
        }
        function propertyOf(object) {
          return function(path) {
            return object == null ? undefined2 : baseGet(object, path);
          };
        }
        var range = createRange();
        var rangeRight = createRange(true);
        function stubArray() {
          return [];
        }
        function stubFalse() {
          return false;
        }
        function stubObject() {
          return {};
        }
        function stubString() {
          return "";
        }
        function stubTrue() {
          return true;
        }
        function times(n, iteratee2) {
          n = toInteger(n);
          if (n < 1 || n > MAX_SAFE_INTEGER) {
            return [];
          }
          var index = MAX_ARRAY_LENGTH, length = nativeMin(n, MAX_ARRAY_LENGTH);
          iteratee2 = getIteratee(iteratee2);
          n -= MAX_ARRAY_LENGTH;
          var result2 = baseTimes(length, iteratee2);
          while (++index < n) {
            iteratee2(index);
          }
          return result2;
        }
        function toPath(value) {
          if (isArray(value)) {
            return arrayMap(value, toKey);
          }
          return isSymbol(value) ? [value] : copyArray(stringToPath(toString(value)));
        }
        function uniqueId(prefix) {
          var id = ++idCounter;
          return toString(prefix) + id;
        }
        var add = createMathOperation(function(augend, addend) {
          return augend + addend;
        }, 0);
        var ceil = createRound("ceil");
        var divide = createMathOperation(function(dividend, divisor) {
          return dividend / divisor;
        }, 1);
        var floor = createRound("floor");
        function max(array) {
          return array && array.length ? baseExtremum(array, identity, baseGt) : undefined2;
        }
        function maxBy(array, iteratee2) {
          return array && array.length ? baseExtremum(array, getIteratee(iteratee2, 2), baseGt) : undefined2;
        }
        function mean(array) {
          return baseMean(array, identity);
        }
        function meanBy(array, iteratee2) {
          return baseMean(array, getIteratee(iteratee2, 2));
        }
        function min(array) {
          return array && array.length ? baseExtremum(array, identity, baseLt) : undefined2;
        }
        function minBy(array, iteratee2) {
          return array && array.length ? baseExtremum(array, getIteratee(iteratee2, 2), baseLt) : undefined2;
        }
        var multiply = createMathOperation(function(multiplier, multiplicand) {
          return multiplier * multiplicand;
        }, 1);
        var round = createRound("round");
        var subtract = createMathOperation(function(minuend, subtrahend) {
          return minuend - subtrahend;
        }, 0);
        function sum(array) {
          return array && array.length ? baseSum(array, identity) : 0;
        }
        function sumBy(array, iteratee2) {
          return array && array.length ? baseSum(array, getIteratee(iteratee2, 2)) : 0;
        }
        lodash.after = after;
        lodash.ary = ary;
        lodash.assign = assign;
        lodash.assignIn = assignIn;
        lodash.assignInWith = assignInWith;
        lodash.assignWith = assignWith;
        lodash.at = at;
        lodash.before = before;
        lodash.bind = bind;
        lodash.bindAll = bindAll;
        lodash.bindKey = bindKey;
        lodash.castArray = castArray;
        lodash.chain = chain;
        lodash.chunk = chunk;
        lodash.compact = compact;
        lodash.concat = concat;
        lodash.cond = cond;
        lodash.conforms = conforms;
        lodash.constant = constant;
        lodash.countBy = countBy;
        lodash.create = create;
        lodash.curry = curry;
        lodash.curryRight = curryRight;
        lodash.debounce = debounce;
        lodash.defaults = defaults;
        lodash.defaultsDeep = defaultsDeep;
        lodash.defer = defer;
        lodash.delay = delay;
        lodash.difference = difference;
        lodash.differenceBy = differenceBy;
        lodash.differenceWith = differenceWith;
        lodash.drop = drop;
        lodash.dropRight = dropRight;
        lodash.dropRightWhile = dropRightWhile;
        lodash.dropWhile = dropWhile;
        lodash.fill = fill;
        lodash.filter = filter;
        lodash.flatMap = flatMap;
        lodash.flatMapDeep = flatMapDeep;
        lodash.flatMapDepth = flatMapDepth;
        lodash.flatten = flatten;
        lodash.flattenDeep = flattenDeep;
        lodash.flattenDepth = flattenDepth;
        lodash.flip = flip3;
        lodash.flow = flow;
        lodash.flowRight = flowRight;
        lodash.fromPairs = fromPairs;
        lodash.functions = functions;
        lodash.functionsIn = functionsIn;
        lodash.groupBy = groupBy;
        lodash.initial = initial;
        lodash.intersection = intersection;
        lodash.intersectionBy = intersectionBy;
        lodash.intersectionWith = intersectionWith;
        lodash.invert = invert;
        lodash.invertBy = invertBy;
        lodash.invokeMap = invokeMap;
        lodash.iteratee = iteratee;
        lodash.keyBy = keyBy;
        lodash.keys = keys;
        lodash.keysIn = keysIn;
        lodash.map = map;
        lodash.mapKeys = mapKeys;
        lodash.mapValues = mapValues;
        lodash.matches = matches;
        lodash.matchesProperty = matchesProperty;
        lodash.memoize = memoize;
        lodash.merge = merge2;
        lodash.mergeWith = mergeWith;
        lodash.method = method;
        lodash.methodOf = methodOf;
        lodash.mixin = mixin;
        lodash.negate = negate;
        lodash.nthArg = nthArg;
        lodash.omit = omit;
        lodash.omitBy = omitBy;
        lodash.once = once;
        lodash.orderBy = orderBy;
        lodash.over = over;
        lodash.overArgs = overArgs;
        lodash.overEvery = overEvery;
        lodash.overSome = overSome;
        lodash.partial = partial;
        lodash.partialRight = partialRight;
        lodash.partition = partition;
        lodash.pick = pick2;
        lodash.pickBy = pickBy2;
        lodash.property = property;
        lodash.propertyOf = propertyOf;
        lodash.pull = pull;
        lodash.pullAll = pullAll;
        lodash.pullAllBy = pullAllBy;
        lodash.pullAllWith = pullAllWith;
        lodash.pullAt = pullAt;
        lodash.range = range;
        lodash.rangeRight = rangeRight;
        lodash.rearg = rearg;
        lodash.reject = reject;
        lodash.remove = remove;
        lodash.rest = rest;
        lodash.reverse = reverse;
        lodash.sampleSize = sampleSize;
        lodash.set = set;
        lodash.setWith = setWith;
        lodash.shuffle = shuffle;
        lodash.slice = slice;
        lodash.sortBy = sortBy;
        lodash.sortedUniq = sortedUniq;
        lodash.sortedUniqBy = sortedUniqBy;
        lodash.split = split;
        lodash.spread = spread;
        lodash.tail = tail;
        lodash.take = take;
        lodash.takeRight = takeRight;
        lodash.takeRightWhile = takeRightWhile;
        lodash.takeWhile = takeWhile;
        lodash.tap = tap;
        lodash.throttle = throttle;
        lodash.thru = thru;
        lodash.toArray = toArray;
        lodash.toPairs = toPairs;
        lodash.toPairsIn = toPairsIn;
        lodash.toPath = toPath;
        lodash.toPlainObject = toPlainObject;
        lodash.transform = transform;
        lodash.unary = unary;
        lodash.union = union;
        lodash.unionBy = unionBy;
        lodash.unionWith = unionWith;
        lodash.uniq = uniq;
        lodash.uniqBy = uniqBy;
        lodash.uniqWith = uniqWith;
        lodash.unset = unset;
        lodash.unzip = unzip;
        lodash.unzipWith = unzipWith;
        lodash.update = update;
        lodash.updateWith = updateWith;
        lodash.values = values;
        lodash.valuesIn = valuesIn;
        lodash.without = without;
        lodash.words = words;
        lodash.wrap = wrap;
        lodash.xor = xor;
        lodash.xorBy = xorBy;
        lodash.xorWith = xorWith;
        lodash.zip = zip;
        lodash.zipObject = zipObject;
        lodash.zipObjectDeep = zipObjectDeep;
        lodash.zipWith = zipWith;
        lodash.entries = toPairs;
        lodash.entriesIn = toPairsIn;
        lodash.extend = assignIn;
        lodash.extendWith = assignInWith;
        mixin(lodash, lodash);
        lodash.add = add;
        lodash.attempt = attempt;
        lodash.camelCase = camelCase;
        lodash.capitalize = capitalize;
        lodash.ceil = ceil;
        lodash.clamp = clamp;
        lodash.clone = clone;
        lodash.cloneDeep = cloneDeep;
        lodash.cloneDeepWith = cloneDeepWith;
        lodash.cloneWith = cloneWith;
        lodash.conformsTo = conformsTo;
        lodash.deburr = deburr;
        lodash.defaultTo = defaultTo;
        lodash.divide = divide;
        lodash.endsWith = endsWith;
        lodash.eq = eq;
        lodash.escape = escape;
        lodash.escapeRegExp = escapeRegExp;
        lodash.every = every;
        lodash.find = find;
        lodash.findIndex = findIndex;
        lodash.findKey = findKey;
        lodash.findLast = findLast;
        lodash.findLastIndex = findLastIndex;
        lodash.findLastKey = findLastKey;
        lodash.floor = floor;
        lodash.forEach = forEach;
        lodash.forEachRight = forEachRight;
        lodash.forIn = forIn;
        lodash.forInRight = forInRight;
        lodash.forOwn = forOwn;
        lodash.forOwnRight = forOwnRight;
        lodash.get = get;
        lodash.gt = gt;
        lodash.gte = gte;
        lodash.has = has;
        lodash.hasIn = hasIn;
        lodash.head = head;
        lodash.identity = identity;
        lodash.includes = includes;
        lodash.indexOf = indexOf;
        lodash.inRange = inRange;
        lodash.invoke = invoke;
        lodash.isArguments = isArguments;
        lodash.isArray = isArray;
        lodash.isArrayBuffer = isArrayBuffer;
        lodash.isArrayLike = isArrayLike;
        lodash.isArrayLikeObject = isArrayLikeObject;
        lodash.isBoolean = isBoolean;
        lodash.isBuffer = isBuffer;
        lodash.isDate = isDate;
        lodash.isElement = isElement;
        lodash.isEmpty = isEmpty;
        lodash.isEqual = isEqual;
        lodash.isEqualWith = isEqualWith;
        lodash.isError = isError;
        lodash.isFinite = isFinite;
        lodash.isFunction = isFunction;
        lodash.isInteger = isInteger;
        lodash.isLength = isLength;
        lodash.isMap = isMap;
        lodash.isMatch = isMatch;
        lodash.isMatchWith = isMatchWith;
        lodash.isNaN = isNaN2;
        lodash.isNative = isNative;
        lodash.isNil = isNil;
        lodash.isNull = isNull;
        lodash.isNumber = isNumber;
        lodash.isObject = isObject;
        lodash.isObjectLike = isObjectLike;
        lodash.isPlainObject = isPlainObject;
        lodash.isRegExp = isRegExp;
        lodash.isSafeInteger = isSafeInteger;
        lodash.isSet = isSet;
        lodash.isString = isString;
        lodash.isSymbol = isSymbol;
        lodash.isTypedArray = isTypedArray;
        lodash.isUndefined = isUndefined;
        lodash.isWeakMap = isWeakMap;
        lodash.isWeakSet = isWeakSet;
        lodash.join = join;
        lodash.kebabCase = kebabCase;
        lodash.last = last;
        lodash.lastIndexOf = lastIndexOf;
        lodash.lowerCase = lowerCase;
        lodash.lowerFirst = lowerFirst;
        lodash.lt = lt;
        lodash.lte = lte;
        lodash.max = max;
        lodash.maxBy = maxBy;
        lodash.mean = mean;
        lodash.meanBy = meanBy;
        lodash.min = min;
        lodash.minBy = minBy;
        lodash.stubArray = stubArray;
        lodash.stubFalse = stubFalse;
        lodash.stubObject = stubObject;
        lodash.stubString = stubString;
        lodash.stubTrue = stubTrue;
        lodash.multiply = multiply;
        lodash.nth = nth;
        lodash.noConflict = noConflict;
        lodash.noop = noop2;
        lodash.now = now;
        lodash.pad = pad;
        lodash.padEnd = padEnd;
        lodash.padStart = padStart;
        lodash.parseInt = parseInt2;
        lodash.random = random;
        lodash.reduce = reduce;
        lodash.reduceRight = reduceRight;
        lodash.repeat = repeat;
        lodash.replace = replace;
        lodash.result = result;
        lodash.round = round;
        lodash.runInContext = runInContext2;
        lodash.sample = sample;
        lodash.size = size;
        lodash.snakeCase = snakeCase;
        lodash.some = some;
        lodash.sortedIndex = sortedIndex;
        lodash.sortedIndexBy = sortedIndexBy;
        lodash.sortedIndexOf = sortedIndexOf;
        lodash.sortedLastIndex = sortedLastIndex;
        lodash.sortedLastIndexBy = sortedLastIndexBy;
        lodash.sortedLastIndexOf = sortedLastIndexOf;
        lodash.startCase = startCase;
        lodash.startsWith = startsWith;
        lodash.subtract = subtract;
        lodash.sum = sum;
        lodash.sumBy = sumBy;
        lodash.template = template;
        lodash.times = times;
        lodash.toFinite = toFinite;
        lodash.toInteger = toInteger;
        lodash.toLength = toLength;
        lodash.toLower = toLower;
        lodash.toNumber = toNumber;
        lodash.toSafeInteger = toSafeInteger;
        lodash.toString = toString;
        lodash.toUpper = toUpper;
        lodash.trim = trim;
        lodash.trimEnd = trimEnd;
        lodash.trimStart = trimStart;
        lodash.truncate = truncate;
        lodash.unescape = unescape;
        lodash.uniqueId = uniqueId;
        lodash.upperCase = upperCase;
        lodash.upperFirst = upperFirst;
        lodash.each = forEach;
        lodash.eachRight = forEachRight;
        lodash.first = head;
        mixin(lodash, function() {
          var source = {};
          baseForOwn(lodash, function(func, methodName) {
            if (!hasOwnProperty.call(lodash.prototype, methodName)) {
              source[methodName] = func;
            }
          });
          return source;
        }(), { "chain": false });
        lodash.VERSION = VERSION;
        arrayEach(["bind", "bindKey", "curry", "curryRight", "partial", "partialRight"], function(methodName) {
          lodash[methodName].placeholder = lodash;
        });
        arrayEach(["drop", "take"], function(methodName, index) {
          LazyWrapper.prototype[methodName] = function(n) {
            n = n === undefined2 ? 1 : nativeMax(toInteger(n), 0);
            var result2 = this.__filtered__ && !index ? new LazyWrapper(this) : this.clone();
            if (result2.__filtered__) {
              result2.__takeCount__ = nativeMin(n, result2.__takeCount__);
            } else {
              result2.__views__.push({
                "size": nativeMin(n, MAX_ARRAY_LENGTH),
                "type": methodName + (result2.__dir__ < 0 ? "Right" : "")
              });
            }
            return result2;
          };
          LazyWrapper.prototype[methodName + "Right"] = function(n) {
            return this.reverse()[methodName](n).reverse();
          };
        });
        arrayEach(["filter", "map", "takeWhile"], function(methodName, index) {
          var type = index + 1, isFilter = type == LAZY_FILTER_FLAG || type == LAZY_WHILE_FLAG;
          LazyWrapper.prototype[methodName] = function(iteratee2) {
            var result2 = this.clone();
            result2.__iteratees__.push({
              "iteratee": getIteratee(iteratee2, 3),
              "type": type
            });
            result2.__filtered__ = result2.__filtered__ || isFilter;
            return result2;
          };
        });
        arrayEach(["head", "last"], function(methodName, index) {
          var takeName = "take" + (index ? "Right" : "");
          LazyWrapper.prototype[methodName] = function() {
            return this[takeName](1).value()[0];
          };
        });
        arrayEach(["initial", "tail"], function(methodName, index) {
          var dropName = "drop" + (index ? "" : "Right");
          LazyWrapper.prototype[methodName] = function() {
            return this.__filtered__ ? new LazyWrapper(this) : this[dropName](1);
          };
        });
        LazyWrapper.prototype.compact = function() {
          return this.filter(identity);
        };
        LazyWrapper.prototype.find = function(predicate) {
          return this.filter(predicate).head();
        };
        LazyWrapper.prototype.findLast = function(predicate) {
          return this.reverse().find(predicate);
        };
        LazyWrapper.prototype.invokeMap = baseRest(function(path, args) {
          if (typeof path == "function") {
            return new LazyWrapper(this);
          }
          return this.map(function(value) {
            return baseInvoke(value, path, args);
          });
        });
        LazyWrapper.prototype.reject = function(predicate) {
          return this.filter(negate(getIteratee(predicate)));
        };
        LazyWrapper.prototype.slice = function(start, end) {
          start = toInteger(start);
          var result2 = this;
          if (result2.__filtered__ && (start > 0 || end < 0)) {
            return new LazyWrapper(result2);
          }
          if (start < 0) {
            result2 = result2.takeRight(-start);
          } else if (start) {
            result2 = result2.drop(start);
          }
          if (end !== undefined2) {
            end = toInteger(end);
            result2 = end < 0 ? result2.dropRight(-end) : result2.take(end - start);
          }
          return result2;
        };
        LazyWrapper.prototype.takeRightWhile = function(predicate) {
          return this.reverse().takeWhile(predicate).reverse();
        };
        LazyWrapper.prototype.toArray = function() {
          return this.take(MAX_ARRAY_LENGTH);
        };
        baseForOwn(LazyWrapper.prototype, function(func, methodName) {
          var checkIteratee = /^(?:filter|find|map|reject)|While$/.test(methodName), isTaker = /^(?:head|last)$/.test(methodName), lodashFunc = lodash[isTaker ? "take" + (methodName == "last" ? "Right" : "") : methodName], retUnwrapped = isTaker || /^find/.test(methodName);
          if (!lodashFunc) {
            return;
          }
          lodash.prototype[methodName] = function() {
            var value = this.__wrapped__, args = isTaker ? [1] : arguments, isLazy = value instanceof LazyWrapper, iteratee2 = args[0], useLazy = isLazy || isArray(value);
            var interceptor = function(value2) {
              var result3 = lodashFunc.apply(lodash, arrayPush([value2], args));
              return isTaker && chainAll ? result3[0] : result3;
            };
            if (useLazy && checkIteratee && typeof iteratee2 == "function" && iteratee2.length != 1) {
              isLazy = useLazy = false;
            }
            var chainAll = this.__chain__, isHybrid = !!this.__actions__.length, isUnwrapped = retUnwrapped && !chainAll, onlyLazy = isLazy && !isHybrid;
            if (!retUnwrapped && useLazy) {
              value = onlyLazy ? value : new LazyWrapper(this);
              var result2 = func.apply(value, args);
              result2.__actions__.push({ "func": thru, "args": [interceptor], "thisArg": undefined2 });
              return new LodashWrapper(result2, chainAll);
            }
            if (isUnwrapped && onlyLazy) {
              return func.apply(this, args);
            }
            result2 = this.thru(interceptor);
            return isUnwrapped ? isTaker ? result2.value()[0] : result2.value() : result2;
          };
        });
        arrayEach(["pop", "push", "shift", "sort", "splice", "unshift"], function(methodName) {
          var func = arrayProto[methodName], chainName = /^(?:push|sort|unshift)$/.test(methodName) ? "tap" : "thru", retUnwrapped = /^(?:pop|shift)$/.test(methodName);
          lodash.prototype[methodName] = function() {
            var args = arguments;
            if (retUnwrapped && !this.__chain__) {
              var value = this.value();
              return func.apply(isArray(value) ? value : [], args);
            }
            return this[chainName](function(value2) {
              return func.apply(isArray(value2) ? value2 : [], args);
            });
          };
        });
        baseForOwn(LazyWrapper.prototype, function(func, methodName) {
          var lodashFunc = lodash[methodName];
          if (lodashFunc) {
            var key = lodashFunc.name + "";
            if (!hasOwnProperty.call(realNames, key)) {
              realNames[key] = [];
            }
            realNames[key].push({ "name": methodName, "func": lodashFunc });
          }
        });
        realNames[createHybrid(undefined2, WRAP_BIND_KEY_FLAG).name] = [{
          "name": "wrapper",
          "func": undefined2
        }];
        LazyWrapper.prototype.clone = lazyClone;
        LazyWrapper.prototype.reverse = lazyReverse;
        LazyWrapper.prototype.value = lazyValue;
        lodash.prototype.at = wrapperAt;
        lodash.prototype.chain = wrapperChain;
        lodash.prototype.commit = wrapperCommit;
        lodash.prototype.next = wrapperNext;
        lodash.prototype.plant = wrapperPlant;
        lodash.prototype.reverse = wrapperReverse;
        lodash.prototype.toJSON = lodash.prototype.valueOf = lodash.prototype.value = wrapperValue;
        lodash.prototype.first = lodash.prototype.head;
        if (symIterator) {
          lodash.prototype[symIterator] = wrapperToIterator;
        }
        return lodash;
      };
      var _ = runInContext();
      if (typeof define == "function" && typeof define.amd == "object" && define.amd) {
        root._ = _;
        define(function() {
          return _;
        });
      } else if (freeModule) {
        (freeModule.exports = _)._ = _;
        freeExports._ = _;
      } else {
        root._ = _;
      }
    }).call(exports);
  }
});
cva(
  [
    "bg-background-secondary",
    "shadow-md",
    "w-fit",
    "border",
    "rounded-md",
    "flex",
    "flex-col",
    "gap-1",
    "p-1"
  ],
  {
    variants: {
      open: { true: "block", false: "hidden" },
      placement: {
        top: ["!mb-1"],
        bottom: ["mt-1"]
      }
    }
  }
);
var selectOptionClasses = cva(
  [
    // focusable,
    "focus-visible:outline-2",
    "focus-visible:outline-primary",
    // focusable
    "transition-colors",
    "font-normal",
    "relative",
    "cursor-pointer",
    "select-none",
    "rounded",
    "group",
    "w-full",
    "flex",
    "items-center",
    "px-2"
  ],
  {
    variants: {
      selected: {
        true: [
          // ...selected,
          "micro-interactions"
        ],
        false: [
          // ...triggers.outlined,
          "bg-primary",
          "border-0"
        ]
      },
      // size: {
      //   sm: [size.sm.fontSize, size.sm.height],
      //   md: [size.md.fontSize, size.md.height],
      //   lg: [size.lg.fontSize, size.lg.height],
      // },
      disabled: { true: "opacity-75 pointer-events-none" },
      multiple: { true: ["flex", "gap-2"] },
      truncate: {
        true: ["truncate", "whitespace-nowrap"]
      }
    }
  }
);
var groupPositionClasses = {
  first: ["rounded-l-md", "border-0", "!border-x", "z-10"],
  middle: ["-ml-px", "border-0", "!border-r"],
  last: ["rounded-r-md", "border-0", "!border-r"]
};
var disabled = [
  "cursor-not-allowed",
  "pointer-events-none",
  "opacity-50"
];
var triggerVariants = {
  variant: {
    contained: [
      // Optical border, implemented as the button background to avoid corner artifacts
      "text-[var(--trigger-color-contrast)]",
      "bg-[var(--trigger-color)]",
      "data-active:bg-[var(--trigger-color)]/[85%]",
      "data-hover:bg-[var(--trigger-color)]/90"
    ],
    outlined: [
      // Base
      "border",
      "!border-[var(--trigger-color)]",
      "text-[var(--trigger-color)]",
      "bg-transparent",
      "data-active:bg-[var(--trigger-color)]/20",
      "data-hover:bg-[var(--trigger-color)]/10",
      // Dark mode
      "dark:data-active:bg-[var(--trigger-color)]/30",
      "dark:data-hover:bg-[var(--trigger-color)]/25"
    ],
    text: [
      // Base
      "border-transparent",
      "text-[var(--trigger-color)]",
      "bg-transparent",
      "data-active:bg-[var(--trigger-color)]/20",
      "data-hover:bg-[var(--trigger-color)]/10",
      // Dark mode
      "dark:data-active:bg-[var(--trigger-color)]/30",
      "dark:data-hover:bg-[var(--trigger-color)]/25"
    ]
  },
  color: {
    primary: [
      "[--trigger-color:theme(colors.primary)]",
      "[--trigger-color-contrast:theme(colors.white)]"
    ],
    success: [
      "[--trigger-color:theme(colors.success)]",
      "[--trigger-color-contrast:theme(colors.white)]"
    ],
    warning: [
      "[--trigger-color:theme(colors.warning)]",
      "[--trigger-color-contrast:theme(colors.black)]"
    ],
    error: [
      "[--trigger-color:theme(colors.error)]",
      "[--trigger-color-contrast:theme(colors.white)]"
    ],
    mono: [
      //
      "[--trigger-color:theme(colors.black)]",
      "[--trigger-color-contrast:theme(colors.white)]",
      "dark:[--trigger-color:theme(colors.white)]",
      "dark:[--trigger-color-contrast:theme(colors.black)]"
    ],
    unstyled: []
  }
};

// src/utils/normalize-dropdown-options.ts
var getFlatOptions = (options) => {
  switch (Array.isArray(options)) {
    case true:
      return options.map((option) => option.label);
    case false:
      return [options.label];
    default:
      return [];
  }
};

// src/autocomplete/constants.ts
var AUTOCOMPLETE_MARGIN = 6;
var AutocompleteContext = createContext(null);
var useAutocomplete = () => {
  const context = useContext(AutocompleteContext);
  if (!context) {
    throw new Error(
      "useAutocomplete must be used within an AutocompleteProvider"
    );
  }
  return context;
};

// src/autocomplete/utils/is-equal-to-value.ts
var _isOptionEqualToValue = (option, value) => {
  if (value === undefined || value === null) {
    return false;
  }
  if (Array.isArray(value)) {
    return value.some((v) => _isOptionEqualToValue(option, v));
  } else {
    return option === value;
  }
};

// src/autocomplete/utils/utils.ts
var stripDiacritics = (text) => {
  return typeof text.normalize !== "undefined" ? text.normalize("NFD").replace(/[\u0300-\u036f]/g, "") : text;
};
function createFilterOptions(config) {
  const {
    ignoreAccents = true,
    ignoreCase = true,
    limit,
    matchFrom = "any",
    stringify,
    trim = false
  } = {};
  return (options, { query = "", getOptionLabel }) => {
    let input = trim ? query.trim() : query;
    if (ignoreCase) {
      input = input == null ? undefined : input.toLowerCase();
    }
    if (ignoreAccents) {
      input = stripDiacritics(input);
    }
    const filteredOptions = !input ? options : options.filter((option) => {
      let candidate = (stringify || getOptionLabel)(option);
      if (ignoreCase) {
        candidate = candidate.toLowerCase();
      }
      if (ignoreAccents) {
        candidate = stripDiacritics(candidate);
      }
      return matchFrom === "start" ? candidate.indexOf(input) === 0 : candidate.indexOf(input) > -1;
    });
    return typeof limit === "number" ? filteredOptions.slice(0, limit) : filteredOptions;
  };
}
var renderOptionInternalContainer = (option, index) => {
  const { renderOption = _renderOption, getOptionProps } = useAutocomplete();
  const props = getOptionProps(option, index);
  return renderOption == null ? undefined : renderOption(props, option);
};
var _renderOption = (props, option) => {
  const { getOptionLabel, autoHighlight } = useAutocomplete();
  const label = getOptionLabel(option);
  return /* @__PURE__ */ jsx("li", __spreadProps(__spreadValues({}, props), { children: autoHighlight ? /* @__PURE__ */ jsx(Highlighter, { searchWords: [props.query], textToHighlight: label }) : label }));
};
var MultipleSelections = () => {
  const {
    limit = 0,
    selected = [],
    renderTags,
    getLimitTagsText,
    handleRemoveSelected
  } = useAutocomplete();
  if (!Array.isArray(selected) || !selected.length) {
    return null;
  }
  const limitedOptions = selected == null ? undefined : selected.slice(0, limit);
  const more = (selected == null ? undefined : selected.length) - limit;
  return /* @__PURE__ */ jsxs(Fragment, { children: [
    renderTags == null ? undefined : renderTags(limitedOptions, handleRemoveSelected),
    /* @__PURE__ */ jsx(Show, { when: more > 0, children: /* @__PURE__ */ jsx("span", { children: getLimitTagsText(more) }) })
  ] });
};
var AutocompleteView = () => {
  const _a = useAutocomplete(), {
    propsInput: propsInput,
    multiple,
    selected,
    renderSelection,
    options = [],
    textNotFound,
    floatingContext,
    open,
    propsList: _b
  } = _a, _c = _b, propsList = __objRest(_c, ["key"]), {
    onCreate,
    textCreate,
    query,
    allowCreate
  } = _a;
  const customRenderValue = !!renderSelection && !multiple && selected != undefined;
  const hasOptions = options.length > 0;
  const handleCreate = useCallback(() => {
    if (!onCreate || !query) return;
    onCreate(query);
  }, [query, onCreate]);
  return /* @__PURE__ */ jsxs("div", { className: clsx13("relative h-auto py-1"), children: [
    /* @__PURE__ */ jsx("div", { className: clsx13("flex flex-col gap-1"), children: /* @__PURE__ */ jsxs("div", { className: "inline-flex gap-2 items-center flex-wrap h-fit", children: [
      /* @__PURE__ */ jsx(Show, { when: multiple, children: /* @__PURE__ */ jsx(MultipleSelections, {}) }),
      !customRenderValue ? /* @__PURE__ */ jsx(
        "input",
        __spreadProps(__spreadValues({}, propsInput), {
          className: clsx13("reset-input", "h-fit", propsInput.className)
        })
      ) : renderSelection == null ? undefined : renderSelection(selected)
    ] }) }),
    /* @__PURE__ */ jsx(Show, { when: open, children: /* @__PURE__ */ jsx(FloatingPortal, { children: /* @__PURE__ */ jsx(
      FloatingFocusManager,
      {
        initialFocus: -1,
        context: floatingContext,
        visuallyHiddenDismiss: true,
        children: /* @__PURE__ */ jsx(DropdownMenu, __spreadProps(__spreadValues({}, propsList), { open, children: /* @__PURE__ */ jsxs(Fragment, { children: [
          /* @__PURE__ */ jsx(Show, { when: hasOptions, children: options == null ? undefined : options.map(renderOptionInternalContainer) }),
          /* @__PURE__ */ jsx(Show, { when: !hasOptions, children: /* @__PURE__ */ jsx(
            "li",
            {
              className: clsx13(
                "py-2 px-3 w-full",
                allowCreate ? "cursor-pointer" : "text-center"
              ),
              children: /* @__PURE__ */ jsxs(Fragment, { children: [
                /* @__PURE__ */ jsx(Show, { when: !allowCreate, children: textNotFound }),
                /* @__PURE__ */ jsx(Show, { when: !!allowCreate, children: /* @__PURE__ */ jsxs("span", { onClick: handleCreate, children: [
                  textCreate,
                  ' "',
                  query,
                  '"'
                ] }) })
              ] })
            }
          ) })
        ] }) }))
      }
    ) }) })
  ] });
};
function Autocomplete(props) {
  const {
    textLoading = "Loading...",
    textEmpty = "No options",
    textNotFound = "No results found",
    textCreate = "Create",
    multiple = false,
    limit,
    maxHeight,
    variant,
    zIndex,
    cx,
    value,
    options = [],
    filterSelectedOptions = false,
    defaultTagProps = {
      variant: "outlined",
      color: "mono"
    },
    autoHighlight = false,
    onChange,
    filterOptions = createFilterOptions(),
    getLimitTagsText = (more) => `+${more}`,
    renderOption,
    renderSelection,
    getOptionLabel: getOptionLabelProp = (option) => typeof option === "string" ? option : option.label,
    isOptionEqualToValue = _isOptionEqualToValue,
    getOptionDisabled = (option) => option.disabled
  } = props;
  let getOptionLabel = getOptionLabelProp;
  getOptionLabel = (option) => {
    const optionLabel = getOptionLabelProp(option);
    if (typeof optionLabel !== "string") {
      if (process.env.NODE_ENV !== "production") {
        const erroneousReturn = optionLabel === undefined ? "undefined" : `${typeof optionLabel} (${optionLabel})`;
        console.error(
          `CUI: The \`getOptionLabel\` method of [Autocomplete] returned ${erroneousReturn} instead of a string for ${JSON.stringify(
            option
          )}.`
        );
      }
      return String(optionLabel);
    }
    return optionLabel;
  };
  const _renderTags = (selected, handleRemoveSelected2) => {
    return selected == null ? undefined : selected.map((option) => {
      const label = getOptionLabel(option);
      const onDelete = () => handleRemoveSelected2(option);
      return /* @__PURE__ */ createElement(
        Chip,
        __spreadProps(__spreadValues({}, defaultTagProps), {
          key: label,
          label,
          onDelete
        })
      );
    });
  };
  const { renderTags = _renderTags } = props;
  const [open, setOpen] = useState(false);
  const [query, setQuery] = useState("");
  const [activeIndex, setActiveIdx] = useState(null);
  const [width, setWidth] = useState(undefined);
  const isQuery = !!(query == null ? undefined : query.trim());
  const isEmpty = value === null || Array.isArray(value) && value.length === 0;
  const interactionsDisabled = props.disabled || props.readOnly;
  const clearable = props.clearable && (!isEmpty || isQuery);
  const listRef = useRef([]);
  const clearSearch = () => setQuery("");
  const clearableCallback = () => {
    var _a;
    switch (multiple) {
      case true:
        onChange == null ? undefined : onChange([]);
        break;
      case false:
        onChange == null ? undefined : onChange(null);
        break;
    }
    (_a = props.onInputChange) == null ? undefined : _a.call(props, { target: { value: "" } });
    clearSearch();
  };
  const createCallback = () => {
    var _a;
    (_a = props.onCreate) == null ? undefined : _a.call(props, query);
    clearSearch();
  };
  const { refs, context, floatingStyles } = useFloating({
    placement: "bottom",
    whileElementsMounted: autoUpdate,
    onOpenChange: (open2) => {
      if (interactionsDisabled) return;
      setOpen(open2);
    },
    open,
    middleware: [
      flip({ padding: AUTOCOMPLETE_MARGIN }),
      offset(5),
      size({
        apply({ rects, availableHeight, elements }) {
          var _a;
          const height = getDropdownHeight(maxHeight, availableHeight);
          setWidth(Number((_a = rects.reference.width) == null ? undefined : _a.toFixed(0)));
          Object.assign(elements.floating.style, {
            width: `${rects.reference.width}px`,
            maxHeight: height,
            overflowY: "auto"
          });
        },
        padding: AUTOCOMPLETE_MARGIN
      })
    ]
  });
  const role = useRole(context, { role: "listbox" });
  const dismiss = useDismiss(context);
  const listNav = useListNavigation(context, {
    listRef,
    activeIndex,
    onNavigate: setActiveIdx,
    virtual: true,
    loop: true
  });
  const { getReferenceProps, getFloatingProps, getItemProps } = useInteractions(
    [role, dismiss, listNav]
  );
  function onInputChange(event) {
    var _a;
    if (interactionsDisabled) return;
    const {
      target: { value: value2 }
    } = event;
    const text = value2;
    setQuery(text);
    (_a = props.onInputChange) == null ? undefined : _a.call(props, event);
    if (text) {
      setOpen(true);
      setActiveIdx(0);
    } else {
      setOpen(false);
    }
  }
  const initiallyFiltered = filterSelectedOptions ? options.filter((option) => {
    if ((multiple ? value : [value]).some(
      (v) => isOptionEqualToValue(option, v)
    )) {
      return false;
    }
    return true;
  }) : options;
  const filteredOptions = open ? filterOptions(initiallyFiltered, { query, getOptionLabel }) : [];
  const toggleOpen = () => setOpen(!open);
  const handleSelect = (option) => {
    switch (multiple) {
      case true: {
        clearSearch();
        const newValue = (isEmpty ? [] : value).concat(option);
        onChange == null ? undefined : onChange(newValue);
        break;
      }
      case false: {
        onChange == null ? undefined : onChange(option);
        setActiveIdx(null);
        setOpen(false);
        setQuery(getOptionLabel == null ? undefined : getOptionLabel(option));
        break;
      }
    }
  };
  const handleRemoveSelected = (option) => {
    if (multiple) {
      const newValue = value == null ? undefined : value.filter((o) => o.id !== option.id);
      onChange == null ? undefined : onChange(!multiple ? getFlatOptions(newValue) : newValue);
    }
  };
  const containerProps = getReferenceProps({
    ref: refs.setReference
  });
  const retainInputValue = () => {
    if (value && !multiple) {
      const label = (getOptionLabel == null ? undefined : getOptionLabel(value)) || "";
      if (typeof label !== "string" || typeof query !== "string") {
        clearSearch();
      }
      if (!open && label !== query) {
        setQuery(label);
      }
    }
  };
  useEffect(() => {
    retainInputValue();
  }, []);
  const inputProps = {
    onChange: onInputChange,
    value: query,
    "aria-autocomplete": "list",
    onClick() {
      setOpen(true);
    },
    onBlur() {
      retainInputValue();
    },
    onKeyDown(event) {
      switch (event.key) {
        case "Enter":
          if (activeIndex != null && filteredOptions[activeIndex]) {
            handleSelect(filteredOptions[activeIndex]);
          } else {
            createCallback();
          }
          break;
        case "Escape":
          setOpen(false);
          break;
        case "ArrowDown":
          setOpen(true);
          break;
      }
    }
  };
  const getOptionProps = (option, index) => {
    const active = activeIndex === index;
    const selected = isOptionEqualToValue(option, value);
    const disabled2 = getOptionDisabled(option);
    const label = getOptionLabel == null ? undefined : getOptionLabel(option);
    const truncate = typeof renderOption !== "function";
    const itemProps = getItemProps({
      ref: (node) => {
        listRef.current[index] = node;
      },
      onKeyDown(e) {
        var _a, _b, _c;
        if (disabled2) return;
        const code = Keyboard.getCode(e);
        const isEnter = code === Keyboard.Enter;
        const isSpace = code === Keyboard.Spacebar;
        if (isEnter || isSpace) {
          e.preventDefault();
          const wasSelected = ((_b = (_a = e.target).getAttribute) == null ? undefined : _b.call(_a, "aria-selected")) === "true";
          if (selected && multiple) {
            handleRemoveSelected(option);
          }
          if (!wasSelected) {
            handleSelect(option);
          }
          (_c = refs.domReference.current) == null ? undefined : _c.focus();
        }
      },
      onClick(e) {
        var _a, _b, _c;
        if (disabled2) return;
        const wasSelected = ((_b = (_a = e.target).getAttribute) == null ? undefined : _b.call(_a, "aria-selected")) === "true";
        if (selected && multiple) {
          handleRemoveSelected(option);
        }
        if (!wasSelected) {
          handleSelect(option);
        }
        (_c = refs.domReference.current) == null ? undefined : _c.focus();
      },
      style: __spreadValues({}, truncate ? { maxWidth: width } : {})
    });
    return __spreadProps(__spreadValues({}, itemProps), {
      key: label,
      multiple,
      selected,
      className: selectOptionClasses({
        selected,
        disabled: disabled2,
        truncate
      }),
      index,
      query,
      active,
      tabIndex: active ? 0 : -1,
      "aria-label": label,
      "aria-selected": selected,
      "aria-disabled": disabled2,
      role: "option"
    });
  };
  const listProps = __spreadValues({
    ref: refs.setFloating,
    placement: context.placement,
    style: __spreadProps(__spreadValues({}, floatingStyles), {
      zIndex: zIndex == null ? undefined : zIndex.list
    })
  }, getFloatingProps());
  const handleChevronClick = (e) => {
    e.stopPropagation();
    if (interactionsDisabled) return;
    toggleOpen();
  };
  return /* @__PURE__ */ jsx(Fragment, { children: /* @__PURE__ */ jsx(
    InputBase,
    __spreadProps(__spreadValues({
      variant,
      endAdornment: /* @__PURE__ */ jsx(DropdownChevron, { open, onClick: handleChevronClick }),
      clearable,
      onClear: clearableCallback,
      cx
    }, containerProps), {
      children: /* @__PURE__ */ jsx(
        AutocompleteContext.Provider,
        {
          value: {
            renderTags,
            handleRemoveSelected,
            setOpen,
            multiple,
            autoHighlight,
            clearable,
            floatingContext: context,
            options: filteredOptions,
            activeIndex,
            limit,
            selected: value,
            propsList: listProps,
            propsInput: inputProps,
            textEmpty,
            textLoading,
            textNotFound,
            open,
            defaultTagProps,
            renderOption,
            renderSelection,
            getOptionLabel,
            getOptionProps,
            getLimitTagsText,
            onCreate: createCallback,
            allowCreate: !!props.onCreate,
            textCreate,
            query
          },
          children: /* @__PURE__ */ jsx(AutocompleteView, {})
        }
      )
    })
  ) });
}

// src/utils/props-guard.ts
var import_lodash = __toESM(require_lodash());
function propsGuard(propsList, props) {
  if (!props) return {};
  const keys = Object.keys(props);
  const definedProps = keys.filter((key) => propsList.includes(key));
  const sanitizedProps = definedProps.reduce((acc, key) => {
    const value = props[key];
    const isFalse = typeof value === "boolean" && value === false;
    const isDefined = value != null;
    if (isFalse) return acc;
    if (isDefined) {
      return __spreadProps(__spreadValues({}, acc), { [key]: props[key] });
    }
  }, {});
  const naturalProps = (0, import_lodash.pickBy)(props, (_, key) => !propsList.includes(key));
  const result = (0, import_lodash.merge)(naturalProps, sanitizedProps);
  return result;
}

// src/utils/get-width-classes.ts
var getWidthClasses = (classes4) => (
  // pick only tailwind width classes
  classes4 == null ? undefined : classes4.filter((c) => /^w-[\w-[\]]+$/.test(c))
);
var twix = (...classes4) => (className) => twMerge(classes4, className);

// src/utils/pick.ts
var pick = (obj, keys) => keys.reduce(
  (acc, key) => {
    if (obj == null ? undefined : obj.hasOwnProperty(key)) {
      acc[key] = obj[key];
    }
    return acc;
  },
  {}
);

// src/utils/functions.ts
var noop = () => {
};
var passThrough = (...args) => args;
function on(obj, ...args) {
  if (obj && obj.addEventListener) {
    obj.addEventListener(
      ...args
    );
  }
}
function off(obj, ...args) {
  if (obj && obj.removeEventListener) {
    obj.removeEventListener(
      ...args
    );
  }
}
var isBrowser = typeof window !== "undefined";
var isNavigator = typeof navigator !== "undefined";
var avatarStyles = {
  img: cva(["inline-block", "ring-2", "ring-white", "!object-cover"], {
    variants: {
      variant: {
        circle: ["rounded-full"],
        rounded: ["rounded-md"],
        square: ["rounded-none"]
      },
      container: {
        true: [
          //
          "relative",
          "w-fit",
          "!inline-flex",
          "flex-col",
          "items-center",
          "justify-center",
          "text-white",
          "bg-gray-500",
          "dark:bg-gray-700"
        ]
      }
    },
    defaultVariants: {
      variant: "circle"
    }
  }),
  container: ["relative", "w-fit"]
};

// src/avatar/constants.ts
var AVATAR_CONTAINER_PROPS = [
  "background",
  "backgroundColor",
  "opacity",
  "border",
  "borderRadius",
  "boxShadow",
  "margin",
  "padding"
];
var AVATAR_GROUP_OFFSET = -3.5;
var Avatar = forwardRef((props, ref) => {
  const _a = props, { variant = "circle", children, className, size = 40 } = _a, rest = __objRest(_a, ["variant", "children", "className", "size"]);
  const style = useMemo(() => {
    const containerStyle = pick(props.style, AVATAR_CONTAINER_PROPS);
    return __spreadValues({
      //
      width: Number(size),
      height: Number(size)
    }, containerStyle);
  }, [size, props.style]);
  return /* @__PURE__ */ jsx(
    "div",
    {
      ref,
      className: avatarStyles.img({ variant, container: true, className }),
      style,
      children: !children ? /* @__PURE__ */ jsx(
        "img",
        __spreadProps(__spreadValues({}, rest), {
          className: avatarStyles.img({ variant }),
          style: { width: style.width, height: style.height }
        })
      ) : children
    }
  );
});
var _renderAvatarGroupSurplus = (count) => `+${count}`;
var getDetails = (children, limit, total, offset3) => {
  const count = Children.count(children);
  const surplus = total ? total - count : limit ? count - limit : total - count;
  return {
    surplusCount: Number(surplus),
    offset: {
      marginLeft: `${offset3}%`
    }
  };
};
var AvatarGroup = ({
  total = 0,
  limit,
  renderSurplus = _renderAvatarGroupSurplus,
  children,
  className,
  surplusClassName,
  stackingOffsetPercent = AVATAR_GROUP_OFFSET,
  size = 40,
  variant
}) => {
  const { surplusCount, offset: offset3 } = getDetails(
    children,
    limit,
    total,
    stackingOffsetPercent
  );
  return /* @__PURE__ */ jsxs("div", { className: clsx13("flex", className), children: [
    Children.map(children, (child, index) => {
      if (limit && index >= limit) return null;
      if (isValidElement(child)) {
        return /* @__PURE__ */ jsx("div", { style: offset3, children: cloneElement(child, { size, variant }) });
      }
      return null;
    }),
    surplusCount > 0 && /* @__PURE__ */ jsx("div", { style: offset3, children: /* @__PURE__ */ jsx(Avatar, { size, className: surplusClassName, variant, children: /* @__PURE__ */ jsx("span", { children: renderSurplus == null ? undefined : renderSurplus(surplusCount) }) }) })
  ] });
};

// src/avatar/types.ts
var AVATAR_VARIANTS = ["circle", "rounded", "square"];
var Link = forwardRef(function Link2(props, ref) {
  return /* @__PURE__ */ jsx(Headless11.DataInteractive, { children: /* @__PURE__ */ jsx("a", __spreadProps(__spreadValues({}, props), { ref })) });
});
var loaderClasses = clsx13(
  "flex",
  "justify-center",
  "items-center",
  "select-none"
);
var loaderIconClasses = cva(
  [
    "animate-spin",
    "text-info/25",
    "size-[var(--ui-icon-height)]"
  ],
  {
    variants: {
      color: {
        error: "fill-error",
        primary: "fill-primary",
        success: "fill-success",
        warning: "fill-warning",
        white: "fill-white",
        black: "fill-black"
      }
    },
    defaultVariants: {
      color: "primary"
    }
  }
);
var Loader = (props) => {
  const { color = "primary", cx } = props;
  const isDefinedColor = [
    "error",
    "primary",
    "success",
    "warning",
    "white",
    "black"
  ].includes(color);
  return /* @__PURE__ */ jsx("span", { className: twMerge(loaderClasses, cx == null ? undefined : cx.outer), children: /* @__PURE__ */ jsxs(
    "svg",
    {
      "aria-hidden": "true",
      className: loaderIconClasses({
        // @ts-expect-error
        color: isDefinedColor ? color : undefined,
        className: [cx == null ? undefined : cx.inner, isDefinedColor ? "" : color]
      }),
      viewBox: "0 0 100 100",
      fill: "none",
      xmlns: "http://www.w3.org/2000/svg",
      children: [
        /* @__PURE__ */ jsx(
          "path",
          {
            d: "M100 50.5908C100 78.2051 77.6142 100.591 50 100.591C22.3858 100.591 0 78.2051 0 50.5908C0 22.9766 22.3858 0.59082 50 0.59082C77.6142 0.59082 100 22.9766 100 50.5908ZM9.08144 50.5908C9.08144 73.1895 27.4013 91.5094 50 91.5094C72.5987 91.5094 90.9186 73.1895 90.9186 50.5908C90.9186 27.9921 72.5987 9.67226 50 9.67226C27.4013 9.67226 9.08144 27.9921 9.08144 50.5908Z",
            fill: "currentColor"
          }
        ),
        /* @__PURE__ */ jsx(
          "path",
          {
            d: "M93.9676 39.0409C96.393 38.4038 97.8624 35.9116 97.0079 33.5539C95.2932 28.8227 92.871 24.3692 89.8167 20.348C85.8452 15.1192 80.8826 10.7238 75.2124 7.41289C69.5422 4.10194 63.2754 1.94025 56.7698 1.05124C51.7666 0.367541 46.6976 0.446843 41.7345 1.27873C39.2613 1.69328 37.813 4.19778 38.4501 6.62326C39.0873 9.04874 41.5694 10.4717 44.0505 10.1071C47.8511 9.54855 51.7191 9.52689 55.5402 10.0491C60.8642 10.7766 65.9928 12.5457 70.6331 15.2552C75.2735 17.9648 79.3347 21.5619 82.5849 25.841C84.9175 28.9121 86.7997 32.2913 88.1811 35.8758C89.083 38.2158 91.5421 39.6781 93.9676 39.0409Z",
            fill: "currentFill"
          }
        )
      ]
    }
  ) });
};
var styles = cva(
  [
    //
    "absolute",
    "left-1/2",
    "top-1/2",
    "size-[max(100%,2.75rem)]",
    "-translate-x-1/2",
    "-translate-y-1/2",
    "[@media(pointer:fine)]:hidden"
  ],
  {
    variants: {
      disabled: {
        true: "cursor-not-allowed",
        false: "cursor-pointer"
      }
    }
  }
);
function TouchTarget({ children, disabled: disabled2 }) {
  return /* @__PURE__ */ jsxs(Fragment, { children: [
    /* @__PURE__ */ jsx("span", { className: styles({ disabled: disabled2 }), "aria-hidden": "true" }),
    children
  ] });
}
var styles2 = cva(
  [
    // Base
    "relative",
    "micro-interactions",
    "isolate",
    "inline-flex",
    "items-center",
    "justify-center",
    "gap-x-2",
    "rounded-md",
    "font-medium",
    // Sizing
    "px-[calc(theme(spacing[3.5])-1px)]",
    "py-[calc(theme(spacing[2.5])-1px)]",
    "sm:px-[calc(theme(spacing.3)-1px)]",
    "sm:py-[calc(theme(spacing[1.5])-1px)]",
    // Focus
    "focus:outline-none",
    "data-focus:outline",
    "data-focus:outline-2",
    "data-focus:outline-offset-2",
    "data-focus:outline-primary",
    // Disabled
    "data-disabled:opacity-50",
    "data-disabled:pointer-events-none",
    "data-active:scale-95",
    "h-[var(--ui-height)]"
  ],
  {
    variants: __spreadValues({
      disabled: {
        true: "pointer-events-none opacity-50"
      },
      uppercase: {
        true: "uppercase"
      },
      fullWidth: {
        true: "w-full"
      }
    }, triggerVariants),
    defaultVariants: {
      color: "primary",
      variant: "outlined"
    }
  }
);
var Button2 = forwardRef(function(_a, ref) {
  var _b = _a, {
    color,
    variant,
    className,
    children,
    loading,
    fullWidth,
    disabled: disabled2,
    startAdornment,
    endAdornment,
    uppercase,
    spinnerPosition = "left",
    loaderColor
  } = _b, props = __objRest(_b, [
    "color",
    "variant",
    "className",
    "children",
    "loading",
    "fullWidth",
    "disabled",
    "startAdornment",
    "endAdornment",
    "uppercase",
    "spinnerPosition",
    "loaderColor"
  ]);
  const isDisabled = Boolean(disabled2 || loading);
  const classes4 = styles2({
    color,
    variant,
    className,
    uppercase,
    fullWidth,
    disabled: isDisabled
  });
  const spinner = /* @__PURE__ */ jsx(Loader, { color: loaderColor != null ? loaderColor : color });
  const leftSpinner = Boolean(loading && spinnerPosition === "left");
  const rightSpinner = Boolean(loading && spinnerPosition === "right");
  const inner = /* @__PURE__ */ jsxs(TouchTarget, { disabled: isDisabled, children: [
    leftSpinner && spinner,
    startAdornment,
    children,
    endAdornment,
    rightSpinner && spinner
  ] });
  return "href" in props ? /* @__PURE__ */ jsx(
    Link,
    __spreadProps(__spreadValues({}, props), {
      className: classes4,
      ref,
      children: inner
    })
  ) : /* @__PURE__ */ jsx(Headless11.Button, __spreadProps(__spreadValues({}, props), { className: classes4, ref, children: inner }));
});
var iconPathMap = {
  chevron_right: ["M9 6L15 12L9 18"],
  chevron_left: ["M15 6L9 12L15 18"],
  chevron_down: ["M6 9L12 15L18 9"],
  close: [
    "M6.75827 17.2426L12.0009 12M17.2435 6.75736L12.0009 12M12.0009 12L6.75827 6.75736M12.0009 12L17.2435 17.2426"
  ],
  check: ["M5 13L9 17L19 7"],
  // straight: [''],
  // readonly: [''],
  slash: ["M15 4L8 20"],
  home: [
    "M10 18V15C10 13.8954 10.8954 13 12 13V13C13.1046 13 14 13.8954 14 15V18",
    "M2 8L11.7317 3.13416C11.9006 3.04971 12.0994 3.0497 12.2683 3.13416L22 8",
    "M20 11V19C20 20.1046 19.1046 21 18 21H6C4.89543 21 4 20.1046 4 19V11"
  ],
  plus: ["M6 12H12M18 12H12M12 12V6M12 12V18"],
  minus: ["M6 12H18"]
};
var styles3 = cva(
  [
    "micro-interactions",
    "size-[var(--ui-icon-height)]",
    "stroke-current",
    "hover:stroke-primary",
    "flex-shrink-0"
  ],
  {
    variants: {
      interactive: {
        true: ["cursor-pointer"]
      }
    }
  }
);
var Icon = (_a) => {
  var _b = _a, { icon, title, className } = _b, props = __objRest(_b, ["icon", "title", "className"]);
  const interactive = !!props.onClick;
  return /* @__PURE__ */ jsxs(
    "svg",
    __spreadProps(__spreadValues({
      xmlns: "http://www.w3.org/2000/svg",
      viewBox: "0 0 24 24",
      stroke: "currentColor",
      strokeWidth: "2",
      strokeLinecap: "round",
      strokeLinejoin: "round",
      fill: "none",
      className: twMerge(styles3({ interactive }), className)
    }, props), {
      children: [
        /* @__PURE__ */ jsx("title", { children: title }),
        iconPathMap[icon].map((path) => /* @__PURE__ */ jsx("path", { d: path }, path))
      ]
    })
  );
};

// src/icon/types.ts
var icons = [
  "check",
  "chevron_down",
  "chevron_left",
  "chevron_right",
  "close",
  // 'dot',
  "home",
  // 'readonly',
  "slash",
  // 'straight',
  "plus",
  "minus"
];
var calendarHeaderClasses = cva(["font-semibold", "mb-4"], {
  variants: {
    offsetMonth: {
      0: [],
      1: ["lg:block", "hidden"]
    }
  }
});
var calendarContainerClasses = cva(
  [
    "relative",
    "bg-background-primary",
    "border",
    "border-border",
    "p-4",
    "rounded-md"
  ],
  {
    variants: {
      hasSecondView: {
        true: ["!min-w-fit"],
        false: []
      }
    }
  }
);
var calendarDayCellClasses = cva(
  [
    //
    "micro-interactions",
    // focusable,
    "focus-visible:outline-2",
    "focus-visible:outline-primary",
    // focusable
    "cursor-pointer",
    "select-none",
    "justify-self-center",
    "flex",
    "items-center",
    "justify-center",
    "text-center",
    "relative",
    "rounded-md",
    "border-transparent",
    "size-(--ui-height)"
  ],
  {
    variants: {
      isToday: {
        true: ["font-bold"]
      },
      isInRange: {
        true: [
          "rounded-none",
          "first:rounded-l-md",
          "last:rounded-r-md",
          "bg-primary/80",
          "hover:bg-primary/100",
          "text-white"
        ]
      },
      isSelected: {
        true: ["bg-primary/80", "hover:bg-primary/100", "text-white"],
        false: ["bg-primary/0", "hover:bg-primary/10"]
      },
      isStart: {
        true: ["rounded-l-md"]
      },
      isEnd: {
        true: ["rounded-r-md"]
      },
      isCurrentMonth: {
        true: [],
        false: ["text-opacity-75"]
      },
      isWeekend: {
        true: ["text-error"],
        false: []
      }
    },
    defaultVariants: {
      isSelected: false,
      isToday: false,
      isCurrentMonth: true,
      isWeekend: true
    }
  }
);
var dayRowClasses = "grid grid-cols-7 w-[calc(var(--ui-height)*7)] shrink max-h-fit whitespace-nowrap";
var calendarDaysViewTitleClasses = {
  day: cva(["select-none", "items-center"], {
    variants: {
      isWeekend: {
        true: "text-error",
        false: ""
      }
    }
  }),
  row: cva([dayRowClasses, "text-xs", "font-semibold", "capitalize"], {
    variants: {
      offsetMonth: {
        0: [],
        1: ["lg:grid", "hidden"]
      }
    }
  })
};
var CalendarContext = createContext({});
var useCalendar = () => {
  const context = useContext(CalendarContext);
  if (!context) {
    throw new Error(`"CalendarProvider" must be present in React DOM tree`);
  }
  return context;
};

// src/calendar/utils.ts
var getFirstDayOfWeek = (date, weekStartsOn) => {
  const day = new Date(date).getDay();
  const daysToShift = (7 + day - weekStartsOn + 1) % 7;
  return new Date(
    date.getFullYear(),
    date.getMonth(),
    date.getDate() - daysToShift
  );
};
var changeCalendarView = (date, view, direction) => {
  const sign = direction === "next" ? 1 : -1;
  const month = new Date(date);
  switch (view) {
    case "days":
      month.setMonth(date.getMonth() + sign * 1);
      break;
    case "months":
      month.setFullYear(date.getFullYear() + sign * 1);
      break;
    case "years":
      month.setFullYear(date.getFullYear() + sign * 12);
      break;
  }
  return month;
};
var getCalendarInitialValue = (value) => {
  var _a, _b;
  if (!value) return [null, null];
  if (Array.isArray(value)) {
    return [(_a = value[0]) != null ? _a : null, (_b = value[1]) != null ? _b : null];
  }
  return [value, null];
};
var isDateInDisplayedMonth = (date, viewedMonth) => date.getMonth() === viewedMonth.getMonth();
var isWeekendIdx = (i) => [5, 6].includes(i);
var CalendarDaysNames = ({
  offsetMonth
}) => {
  const { locale, weekStartsOn } = useCalendar();
  const firstDayOfWeek = getFirstDayOfWeek(/* @__PURE__ */ new Date(), weekStartsOn);
  const dayNames = Array.from(
    { length: 7 },
    (_, i) => new Intl.DateTimeFormat(locale, { weekday: "short" }).format(
      new Date(firstDayOfWeek.setDate(firstDayOfWeek.getDate() + 1))
    )
  );
  return /* @__PURE__ */ jsx("div", { className: calendarDaysViewTitleClasses.row({ offsetMonth }), children: dayNames.map((dayName, i) => /* @__PURE__ */ jsx(
    "div",
    {
      className: calendarDaysViewTitleClasses.day({
        isWeekend: isWeekendIdx(i)
      }),
      children: dayName
    },
    dayName
  )) });
};
var CalendarDaysView = ({
  offsetMonth = 0,
  multipleCalendars = false
}) => {
  const {
    viewDate: originalViewDate,
    selectedDates,
    setSelectedDates,
    mode,
    weekStartsOn
  } = useCalendar();
  const viewDate = new Date(originalViewDate);
  viewDate.setMonth(originalViewDate.getMonth() + offsetMonth);
  const month = viewDate.getMonth();
  const year = viewDate.getFullYear();
  const monthStart = new Date(year, month, 1);
  const monthEnd = new Date(year, month + 1, 0);
  const startDate = new Date(
    monthStart.setDate(
      monthStart.getDate() - (7 + monthStart.getDay() - weekStartsOn) % 7
    )
  );
  const endDate = new Date(
    monthEnd.setDate(monthEnd.getDate() + (6 - monthEnd.getDay()))
  );
  const isDateSelected = useCallback(
    (date2) => {
      var _a, _b;
      const first = (_a = selectedDates == null ? undefined : selectedDates[0]) == null ? undefined : _a.toDateString();
      const second = (_b = selectedDates == null ? undefined : selectedDates[1]) == null ? undefined : _b.toDateString();
      const dateString = date2.toDateString();
      return first === dateString || second === dateString;
    },
    [selectedDates]
  );
  const isDateInRange = (date2) => {
    if (mode === "range" && selectedDates[0] && selectedDates[1]) {
      return date2 >= selectedDates[0] && date2 <= selectedDates[1];
    }
    return false;
  };
  const isDateFirstOrLast = (date2) => {
    var _a, _b;
    const first = (_a = selectedDates == null ? undefined : selectedDates[0]) == null ? undefined : _a.toDateString();
    const second = (_b = selectedDates == null ? undefined : selectedDates[1]) == null ? undefined : _b.toDateString();
    const dateString = date2.toDateString();
    return first === dateString ? 0 : second === dateString ? 1 : -1;
  };
  const handleRowClick = (e) => {
    const day = e.target.closest("button");
    if (!day) return;
    const date2 = day.getAttribute("data-date");
    if (!date2) return;
    const clickedDate = new Date(date2);
    setSelectedDates(clickedDate);
  };
  let date = startDate;
  const rows = [];
  while (date <= endDate) {
    const days = [];
    for (let i = 0; i < 7; i++) {
      const cellDate = date.toDateString();
      const isToday = (/* @__PURE__ */ new Date()).toDateString() === cellDate;
      const isCurrentMonth = date.getMonth() === (viewDate == null ? undefined : viewDate.getMonth());
      const isSelected = isDateSelected(date);
      const isInRange = isDateInRange(date);
      const isWeekend = isWeekendIdx(i);
      const idx = isDateFirstOrLast(date);
      const isInRenderedMonth = isDateInDisplayedMonth(date, viewDate);
      const shouldSkipRender = multipleCalendars && !isInRenderedMonth;
      days.push(
        /* @__PURE__ */ jsx(
          "button",
          {
            "data-date": cellDate,
            className: !shouldSkipRender ? calendarDayCellClasses({
              isCurrentMonth,
              isSelected,
              isToday,
              isWeekend,
              isInRange,
              isStart: idx === 0,
              isEnd: idx === 1
            }) : undefined,
            children: !shouldSkipRender ? date.getDate().toString() : null
          },
          `${days.length}-${i}`
        )
      );
      date.setDate(date.getDate() + 1);
    }
    rows.push(
      /* @__PURE__ */ jsx("div", { className: dayRowClasses, children: days }, `week-${days[0]}`)
    );
  }
  return /* @__PURE__ */ jsx(
    "div",
    {
      className: "grid grid-rows-6 w-full gap-1 w-[245px] h-[230px] max-h-fit",
      onClick: handleRowClick,
      children: rows
    }
  );
};
var PeriodButton = (_a) => {
  var _b = _a, {
    period,
    current,
    className
  } = _b, props = __objRest(_b, [
    "period",
    "current",
    "className"
  ]);
  return /* @__PURE__ */ jsx(Button2, __spreadProps(__spreadValues({ variant: "text", className }, props), { children: period }));
};
var CalendarGridView = ({
  currentValue,
  onClick,
  entries
}) => {
  return /* @__PURE__ */ jsx("div", { className: "grid grid-cols-4 grid-rows-3 place-items-center w-full h-full place-self-center", children: /* @__PURE__ */ jsx(For, { each: entries, children: (period) => /* @__PURE__ */ jsx(
    PeriodButton,
    {
      period,
      current: currentValue === period,
      onClick: onClick.bind(null, period)
    },
    period
  ) }) });
};
var CalendarMonthsView = () => {
  const {
    viewDate: currentDate,
    setViewDate: setCurrentDate,
    setView,
    locale
  } = useCalendar();
  const months = Array.from(
    { length: 12 },
    (_, i) => new Intl.DateTimeFormat(locale, { month: "short" }).format(
      new Date(2e3, i)
    )
  );
  const handleMonthClick = (month) => {
    setCurrentDate(
      new Date(currentDate.getFullYear(), months.indexOf(month))
    );
    setView("days");
  };
  const currentMonth = currentDate.getMonth();
  return /* @__PURE__ */ jsx(
    CalendarGridView,
    {
      entries: months,
      currentValue: currentMonth,
      onClick: handleMonthClick
    }
  );
};
var CalendarYearsView = () => {
  const {
    viewDate: currentDate,
    setViewDate: setCurrentDate,
    setView
  } = useCalendar();
  const startYear = Math.floor(currentDate.getFullYear() / 10) * 10 - 1;
  const years = Array.from({ length: 12 }, (_, i) => startYear + i);
  const handleYearClick = (year) => {
    setCurrentDate(new Date(Number(year), currentDate.getMonth()));
    setView("months");
  };
  const currentYear = currentDate.getFullYear();
  return /* @__PURE__ */ jsx(
    CalendarGridView,
    {
      entries: years,
      currentValue: currentYear,
      onClick: handleYearClick
    }
  );
};
var MonthYearTitle = ({
  offsetMonth = 0
}) => {
  const { viewDate: originalViewDate, setView, view } = useCalendar();
  const adjustedViewDate = new Date(originalViewDate);
  adjustedViewDate.setMonth(originalViewDate.getMonth() + offsetMonth);
  const isMonthName = useMemo(() => view === "days", [view]);
  const isYearName = useMemo(() => ["months", "days"].includes(view), [view]);
  return /* @__PURE__ */ jsxs(
    Flex,
    {
      gapX: 1,
      items: "center",
      className: calendarHeaderClasses({ offsetMonth }),
      children: [
        isMonthName && /* @__PURE__ */ jsx(Fragment, { children: /* @__PURE__ */ jsxs("button", { onClick: setView.bind(null, "months"), className: "capitalize", children: [
          adjustedViewDate.toLocaleDateString(undefined, { month: "long" }),
          "\xA0"
        ] }) }),
        isYearName && /* @__PURE__ */ jsx(Fragment, { children: /* @__PURE__ */ jsx("button", { onClick: setView.bind(null, "years"), children: adjustedViewDate.getFullYear() }) })
      ]
    }
  );
};
var CalendarView = ({
  viewIs,
  className,
  hasSecondView,
  showTodaySelector,
  isTodaySelected,
  todayText,
  onPrevClick,
  onNextClick,
  onTodayClick,
  id
}) => {
  return /* @__PURE__ */ jsx("div", { className, children: /* @__PURE__ */ jsxs("div", { className: calendarContainerClasses({ hasSecondView }), id, children: [
    /* @__PURE__ */ jsx(
      "button",
      {
        onClick: onPrevClick == null ? undefined : onPrevClick.bind(null),
        className: "!absolute top-0 left-0 mt-4 mx-2 text-xs cursor-pointer hover:text-primary micro-interactions",
        children: /* @__PURE__ */ jsx(Icon, { icon: "chevron_left" })
      }
    ),
    /* @__PURE__ */ jsx(
      "button",
      {
        onClick: onNextClick == null ? undefined : onNextClick.bind(null),
        className: "!absolute top-0 right-0 mt-4 mx-2 text-xs cursor-pointer hover:text-primary micro-interactions",
        children: /* @__PURE__ */ jsx(Icon, { icon: "chevron_right" })
      }
    ),
    /* @__PURE__ */ jsxs("div", { className: "grid lg:grid-flow-col gap-5", children: [
      /* @__PURE__ */ jsxs("div", { className: "grid grid-flow-row justify-items-center gap-2", children: [
        /* @__PURE__ */ jsx(MonthYearTitle, { offsetMonth: 0 }),
        viewIs("days") && [
          /* @__PURE__ */ jsx(CalendarDaysNames, {}),
          /* @__PURE__ */ jsx(CalendarDaysView, { multipleCalendars: hasSecondView })
        ],
        viewIs("months") && /* @__PURE__ */ jsx(CalendarMonthsView, {}),
        " ",
        viewIs("years") && /* @__PURE__ */ jsx(CalendarYearsView, {})
      ] }),
      viewIs("days") && hasSecondView && /* @__PURE__ */ jsxs("div", { className: "grid grid-flow-row justify-items-center gap-2", children: [
        /* @__PURE__ */ jsx(MonthYearTitle, { offsetMonth: 1 }),
        /* @__PURE__ */ jsx(CalendarDaysNames, { offsetMonth: 1 }),
        /* @__PURE__ */ jsx(CalendarDaysView, { offsetMonth: 1, multipleCalendars: true })
      ] })
    ] }),
    showTodaySelector && /* @__PURE__ */ jsxs(Fragment, { children: [
      "\xA0",
      /* @__PURE__ */ jsx(
        "button",
        {
          onClick: onTodayClick,
          disabled: isTodaySelected,
          className: "text-xs cursor-pointer hover:text-primary micro-interactions",
          children: todayText
        }
      )
    ] })
  ] }) });
};
var Calendar = (props) => {
  const {
    className,
    onChange,
    weekStartsOn = 1,
    numberOfMonths = 1,
    mode = "date",
    value,
    todayText = "Today",
    startOn,
    showTodaySelector = true
  } = props;
  const [view, setView] = useState("days");
  const [viewDate, setViewDate] = useState(startOn != null ? startOn : /* @__PURE__ */ new Date());
  const [selectedDates, setSelectedDates] = useState([null, null]);
  useEffect(() => {
    setSelectedDates(getCalendarInitialValue(value));
  }, []);
  const handleDayClick = (date) => {
    if (mode === "range") {
      if (!selectedDates[0] || selectedDates[0] && selectedDates[1]) {
        setSelectedDates([date, null]);
      } else if (selectedDates[0] && !selectedDates[1]) {
        if (date && selectedDates[0] && date < selectedDates[0]) {
          setSelectedDates([date, selectedDates[0]]);
          onChange == null ? undefined : onChange([date, selectedDates[0]]);
        } else {
          setSelectedDates([selectedDates[0], date]);
          onChange == null ? undefined : onChange([selectedDates[0], date]);
        }
      }
    } else {
      setSelectedDates([date, null]);
      onChange == null ? undefined : onChange(date);
    }
  };
  const onNextClick = () => {
    const date = changeCalendarView(viewDate, view, "next");
    setViewDate(date);
  };
  const onPrevClick = () => {
    const date = changeCalendarView(viewDate, view, "prev");
    setViewDate(date);
  };
  const onTodayClick = () => {
    const today = /* @__PURE__ */ new Date();
    today.setHours(0, 0, 0, 0);
    setViewDate(today);
    handleDayClick(today);
    setView("days");
  };
  const isTodaySelected = useMemo(() => {
    var _a, _b;
    if (mode === "range") return false;
    const first = (_a = selectedDates == null ? undefined : selectedDates[0]) == null ? undefined : _a.toDateString();
    const second = (_b = selectedDates == null ? undefined : selectedDates[1]) == null ? undefined : _b.toDateString();
    const today = (/* @__PURE__ */ new Date()).toDateString();
    return first === today || second === today;
  }, [selectedDates]);
  const context = useMemo(
    () => {
      var _a;
      return {
        locale: ((_a = props.locale) != null ? _a : typeof navigator !== "undefined") ? navigator.language : "en",
        setSelectedDates: handleDayClick,
        setViewDate,
        setView,
        view,
        currentDate: viewDate,
        selectedDates,
        weekStartsOn,
        viewDate,
        mode,
        numberOfMonths
      };
    },
    [viewDate, selectedDates, weekStartsOn]
  );
  const hasSecondView = useMemo(() => numberOfMonths === 2, [numberOfMonths]);
  const viewIs = useCallback(
    (viewType) => view === viewType,
    [view]
  );
  return /* @__PURE__ */ jsx(CalendarContext.Provider, { value: context, children: /* @__PURE__ */ jsx(
    CalendarView,
    {
      className,
      hasSecondView,
      showTodaySelector,
      isTodaySelected,
      todayText,
      onPrevClick,
      onNextClick,
      onTodayClick,
      viewIs
    }
  ) });
};
var Calendar_default = Calendar;
var titleClasses = twix("leading-none tracking-tight text-lg font-medium");
var CardTitle = forwardRef((_a, ref) => {
  var _b = _a, { className } = _b, props = __objRest(_b, ["className"]);
  return /* @__PURE__ */ jsx("h3", __spreadValues({ ref, className: titleClasses(className) }, props));
});
var cardClasses = twix(
  "border",
  "rounded-lg",
  "p-5",
  "text-text-primary",
  "bg-background-primary",
  "border-border"
);
var Card = forwardRef(
  (_a, ref) => {
    var _b = _a, { className, href, children } = _b, props = __objRest(_b, ["className", "href", "children"]);
    return /* @__PURE__ */ jsx("div", __spreadProps(__spreadValues({ ref, className: cardClasses(className) }, props), { children: href ? /* @__PURE__ */ jsx("a", { href, className: "block", children }) : children }));
  }
);
var CardContent = forwardRef((_a, ref) => {
  var _b = _a, { className } = _b, props = __objRest(_b, ["className"]);
  return /* @__PURE__ */ jsx("div", __spreadValues({ ref, className: clsx13(className) }, props));
});
var cardDescriptionClasses = twix("text-sm text-text-secondary");
var CardDescription = forwardRef((_a, ref) => {
  var _b = _a, { className } = _b, props = __objRest(_b, ["className"]);
  return /* @__PURE__ */ jsx("p", __spreadValues({ ref, className: cardDescriptionClasses(className) }, props));
});
var cardFooterClasses = twix("flex items-center gap-2");
var CardFooter = forwardRef((_a, ref) => {
  var _b = _a, { className } = _b, props = __objRest(_b, ["className"]);
  return /* @__PURE__ */ jsx("div", __spreadValues({ ref, className: cardFooterClasses(className) }, props));
});
var cardHeaderClasses = twix("w-full");
var CardHeader = forwardRef((_a, ref) => {
  var _b = _a, { className } = _b, props = __objRest(_b, ["className"]);
  return /* @__PURE__ */ jsx("div", __spreadValues({ ref, className: cardHeaderClasses(className) }, props));
});
var cardStatsClasses = twix(
  "text-2xl",
  "sm:text-xl",
  "md:text-2xl",
  "lg:text-3xl",
  "xl:text-4xl",
  "font-bold",
  "my-1.5"
);
var CardStats = forwardRef((_a, ref) => {
  var _b = _a, { className } = _b, props = __objRest(_b, ["className"]);
  return /* @__PURE__ */ jsx("div", __spreadValues({ ref, className: cardStatsClasses(className) }, props));
});
var CardStyles = cva([], { variants: {} });
var checkboxStyles = cva(
  [
    // Basic layout
    "micro-interaction",
    "relative",
    "isolate",
    "flex",
    "size-5",
    "items-center",
    "justify-center",
    "rounded-[0.2rem]",
    "sm:size-4",
    // Background color + shadow applied to inset pseudo element, so shadow blends with border in light mode
    "before:absolute",
    "before:inset-0",
    "before:-z-10",
    "before:rounded-[calc(0.2rem-1px)]",
    "before:bg-white",
    "before:shadow-sm",
    // Background color when checked
    "group-data-checked:before:bg-[var(--checkbox-checked-bg)]",
    // Background color is moved to control and shadow is removed in dark mode so hide `before` pseudo
    "dark:before:hidden",
    // Background color applied to control in dark mode
    "dark:bg-white/5",
    "dark:group-data-checked:bg-[var(--checkbox-checked-bg)]",
    // Border
    "border",
    "border-neutral-950/15",
    "group-data-checked:border-transparent",
    "group-data-hover:group-data-checked:border-transparent",
    "group-data-hover:border-neutral-950/30",
    "group-data-checked:bg-[var(--checkbox-checked-border)]",
    "dark:border-white/15",
    "dark:group-data-checked:border-white/5",
    "dark:group-data-hover:group-data-checked:border-white/5",
    "dark:group-data-hover:border-white/30",
    // Inner highlight shadow
    "after:absolute",
    "after:inset-0",
    "after:rounded-[calc(0.2rem-1px)]",
    "after:shadow-[inset_0_1px_--theme(--color-white/15%)]",
    "dark:after:-inset-px",
    "dark:after:hidden",
    "dark:after:rounded-[0.2rem]",
    "dark:group-data-checked:after:block",
    // Focus ring
    "group-data-focus:outline",
    "group-data-focus:outline-2",
    "group-data-focus:outline-offset-2",
    "group-data-focus:outline-primary",
    // 'group-data-disabled:before:bg-transparent',
    "dark:group-data-checked:group-data-disabled:after:hidden",
    // Forced colors mode
    "forced-colors:[--checkbox-check:HighlightText]",
    "forced-colors:[--checkbox-checked-bg:Highlight]",
    "forced-colors:group-data-disabled:[--checkbox-check:Highlight]",
    "dark:forced-colors:[--checkbox-check:HighlightText]",
    "dark:forced-colors:[--checkbox-checked-bg:Highlight]",
    "dark:forced-colors:group-data-disabled:[--checkbox-check:Highlight]",
    "[--checkbox-check:var(--color-white)]",
    "[--checkbox-checked-bg:var(--color-primary)]"
  ],
  {
    variants: {
      readOnly: {
        true: ["cursor-not-allowed"],
        false: [
          // Disabled state
          "group-data-disabled:opacity-50"
        ]
      }
    }
  }
);
var Checkbox2 = (_a) => {
  var _b = _a, {
    className,
    disabled: disabled2,
    loading,
    readOnly
  } = _b, props = __objRest(_b, [
    "className",
    "disabled",
    "loading",
    "readOnly"
  ]);
  const isDisabled = loading || disabled2 || readOnly;
  return /* @__PURE__ */ jsx(
    Headless11.Checkbox,
    __spreadProps(__spreadValues({
      "data-slot": "control",
      disabled: isDisabled
    }, props), {
      className: twMerge(className, "group inline-flex focus:outline-hidden"),
      children: /* @__PURE__ */ jsx("span", { className: checkboxStyles({ className, readOnly }), children: /* @__PURE__ */ jsxs(
        "svg",
        {
          className: clsx13(
            //
            "size-4",
            "stroke-[var(--checkbox-check)]",
            "opacity-0",
            "group-data-checked:opacity-100",
            "micro-interaction",
            "sm:h-3.5",
            "sm:w-3.5"
          ),
          viewBox: "0 0 14 14",
          fill: "none",
          children: [
            /* @__PURE__ */ jsx(
              "path",
              {
                className: "opacity-100 group-data-indeterminate:opacity-0 micro-interaction",
                d: "M3 8L6 11L11 3.5",
                strokeWidth: 2,
                strokeLinecap: "round",
                strokeLinejoin: "round"
              }
            ),
            /* @__PURE__ */ jsx(
              "path",
              {
                className: "opacity-0 group-data-indeterminate:opacity-100 micro-interaction",
                d: "M3 7H11",
                strokeWidth: 2,
                strokeLinecap: "round",
                strokeLinejoin: "round"
              }
            )
          ]
        }
      ) })
    })
  );
};
var classes = cva([
  "hover:fill-error",
  "dark:hover:fill-error",
  "cursor-pointer",
  "select-none"
]);
var ClearButton = forwardRef(
  (_a, ref) => {
    var _b = _a, { onClick, className } = _b, props = __objRest(_b, ["onClick", "className"]);
    return /* @__PURE__ */ jsx(
      Icon,
      __spreadValues({
        ref,
        icon: "close",
        onClick,
        className: twMerge(classes(), className),
        "aria-hidden": "true"
      }, props)
    );
  }
);
var chipClasses = cva(
  [
    "micro-interactions",
    "isolate",
    "inline-flex",
    "leading-5",
    "rounded-full",
    "font-medium",
    "w-fit",
    "select-none",
    "justify-center",
    "items-center",
    "flex-row",
    "gap-1",
    "py-0.5",
    "px-2"
  ],
  {
    variants: __spreadProps(__spreadValues({}, triggerVariants), {
      uppercase: { true: "uppercase" },
      interactive: {
        true: ["pointer-events-auto", "cursor-pointer"],
        false: ["pointer-events-none", "cursor-default"]
      }
    }),
    defaultVariants: {
      variant: "contained",
      uppercase: false,
      interactive: false
    }
  }
);
var Chip = (props) => {
  var _a, _b;
  const {
    //
    label,
    color = "primary",
    variant = "contained",
    onDelete,
    onClick,
    startAdornment = null,
    endAdornment = null,
    uppercase,
    cx,
    style
  } = props;
  const removable = !!onDelete;
  const interactive = !!onClick || removable;
  return /* @__PURE__ */ jsxs(
    "div",
    {
      style,
      className: chipClasses({
        color: style ? "unstyled" : color,
        variant,
        uppercase,
        interactive,
        className: [(_a = cx == null ? undefined : cx.container) == null ? undefined : _a.outer]
      }),
      onClick,
      children: [
        !!startAdornment && startAdornment,
        /* @__PURE__ */ jsx("span", { className: (_b = cx == null ? undefined : cx.container) == null ? undefined : _b.inner, children: label }),
        !!endAdornment && endAdornment,
        removable && /* @__PURE__ */ jsx("div", { className: "rounded-full", children: /* @__PURE__ */ jsx(ClearButton, { onClick: onDelete }) })
      ]
    }
  );
};
Chip.displayName = "Chip";
function getClosestBody(el) {
  if (!el) {
    return null;
  } else if (el.tagName === "BODY") {
    return el;
  } else if (el.tagName === "IFRAME") {
    const document2 = el.contentDocument;
    return document2 ? document2.body : null;
  } else if (!el.offsetParent) {
    return null;
  }
  return getClosestBody(el.offsetParent);
}
function preventDefault(rawEvent) {
  var _a;
  const e = rawEvent || window.event;
  if (((_a = e.touches) == null ? undefined : _a.length) > 1) return true;
  if (e.preventDefault) e.preventDefault();
  return false;
}
var isIosDevice = isBrowser && window.navigator && window.navigator.platform && /iP(ad|hone|od)/.test(window.navigator.platform);
var bodies = /* @__PURE__ */ new Map();
var doc = typeof document === "object" ? document : undefined;
var documentListenerAdded = false;
var lock_scroll_default = !doc ? function useLockBodyMock(_locked = true, _elementRef) {
} : function useLockBody(locked = true, elementRef) {
  const bodyRef = useRef(doc.body);
  elementRef = elementRef || bodyRef;
  const lock = (body) => {
    const bodyInfo = bodies.get(body);
    if (!bodyInfo) {
      bodies.set(body, { counter: 1, initialOverflow: body.style.overflow });
      if (isIosDevice) {
        if (!documentListenerAdded) {
          on(document, "touchmove", preventDefault, { passive: false });
          documentListenerAdded = true;
        }
      } else {
        body.style.overflow = "hidden";
      }
    } else {
      bodies.set(body, {
        counter: bodyInfo.counter + 1,
        initialOverflow: bodyInfo.initialOverflow
      });
    }
  };
  const unlock = (body) => {
    const bodyInfo = bodies.get(body);
    if (bodyInfo) {
      if (bodyInfo.counter === 1) {
        bodies.delete(body);
        if (isIosDevice) {
          body.ontouchmove = null;
          if (documentListenerAdded) {
            off(document, "touchmove", preventDefault);
            documentListenerAdded = false;
          }
        } else {
          body.style.overflow = bodyInfo.initialOverflow;
        }
      } else {
        bodies.set(body, {
          counter: bodyInfo.counter - 1,
          initialOverflow: bodyInfo.initialOverflow
        });
      }
    }
  };
  useEffect(() => {
    const body = getClosestBody(elementRef.current);
    if (!body) {
      return;
    }
    if (locked) {
      lock(body);
    } else {
      unlock(body);
    }
  }, [locked, elementRef.current]);
  useEffect(() => {
    const body = getClosestBody(elementRef.current);
    if (!body) {
      return;
    }
    return () => {
      unlock(body);
    };
  }, []);
};
var useLocalStorage = (key, initialValue, options) => {
  if (!isBrowser) {
    return [initialValue, noop, noop];
  }
  if (!key) {
    throw new Error("useLocalStorage key may not be falsy");
  }
  const deserializer = (options == null ? undefined : options.raw) ? (value) => value : (options == null ? undefined : options.deserializer) || JSON.parse;
  const initializer = useRef((key2) => {
    try {
      const serializer = (options == null ? void 0 : options.raw) ? String : (options == null ? void 0 : options.serializer) || JSON.stringify;
      const localStorageValue = localStorage.getItem(key2);
      if (localStorageValue !== null) {
        return deserializer(localStorageValue);
      } else {
        initialValue && localStorage.setItem(key2, serializer(initialValue));
        return initialValue;
      }
    } catch (e) {
      return initialValue;
    }
  });
  const [state, setState] = useState(
    () => initializer.current(key)
  );
  useLayoutEffect(() => setState(initializer.current(key)), [key]);
  const set = useCallback(
    (valOrFunc) => {
      try {
        const newState = typeof valOrFunc === "function" ? valOrFunc(state) : valOrFunc;
        if (typeof newState === "undefined") return;
        let value;
        if (options)
          if (options.raw)
            if (typeof newState === "string") value = newState;
            else value = JSON.stringify(newState);
          else if (options.serializer) value = options.serializer(newState);
          else value = JSON.stringify(newState);
        else value = JSON.stringify(newState);
        localStorage.setItem(key, value);
        setState(deserializer(value));
      } catch (e) {
      }
    },
    [key, setState]
  );
  const remove = useCallback(() => {
    try {
      localStorage.removeItem(key);
      setState(void 0);
    } catch (e) {
    }
  }, [key, setState]);
  return [state, set, remove];
};
var use_local_storage_default = useLocalStorage;
var useMeasureDirty = (ref) => {
  const frame = useRef(0);
  const [rect, set] = useState({
    width: 0,
    height: 0,
    top: 0,
    left: 0,
    bottom: 0,
    right: 0
  });
  const [observer] = useState(
    () => new ResizeObserver((entries) => {
      const entry = entries[0];
      if (entry) {
        cancelAnimationFrame(frame.current);
        frame.current = requestAnimationFrame(() => {
          if (ref.current) {
            set(entry.contentRect);
          }
        });
      }
    })
  );
  useEffect(() => {
    observer.disconnect();
    if (ref.current) {
      observer.observe(ref.current);
    }
  }, [ref]);
  return rect;
};
var use_measure_dirty_default = useMeasureDirty;
function useDetectDarkMode() {
  const [isDarkMode, setIsDarkMode] = useState(false);
  useEffect(() => {
    if (typeof window !== "undefined" && document.body) {
      setIsDarkMode(document.body.classList.contains("dark"));
      const handleClassChange = () => {
        setIsDarkMode(document.body.classList.contains("dark"));
      };
      const observer = new MutationObserver((mutations) => {
        mutations.forEach((mutation) => {
          if (mutation.type === "attributes" && mutation.attributeName === "class") {
            handleClassChange();
          }
        });
      });
      observer.observe(document.body, {
        attributes: true,
        // Listen for attribute changes
        attributeFilter: ["class"]
        // Specifically for changes in the 'class' attribute
      });
      return () => observer.disconnect();
    }
  }, []);
  return isDarkMode;
}

// src/dark-mode-toggle/constants.ts
var darkModeToggleDefaultProperties = {
  dark: {
    circle: {
      r: 9
    },
    mask: {
      cx: "50%",
      cy: "23%"
    },
    svg: {
      transform: "rotate(40deg)"
    },
    lines: {
      opacity: 0
    }
  },
  light: {
    circle: {
      r: 5
    },
    mask: {
      cx: "100%",
      cy: "0%"
    },
    svg: {
      transform: "rotate(90deg)"
    },
    lines: {
      opacity: 1
    }
  },
  springConfig: { mass: 4, tension: 250, friction: 35 }
};

// src/dark-mode-toggle/utils.ts
var updateDocumentClasses = (theme) => theme === "dark" ? document.documentElement.classList.add("dark") : document.documentElement.classList.remove("dark");
var DarkModeToggle = (_a) => {
  var _b = _a, {
    onModeChange: onChange,
    children,
    theme,
    size = 24,
    animationProperties = darkModeToggleDefaultProperties,
    moonColor = "white",
    sunColor = "black",
    defaultTheme = "light",
    localStorageKey = "theme",
    style
  } = _b, rest = __objRest(_b, [
    "onModeChange",
    "children",
    "theme",
    "size",
    "animationProperties",
    "moonColor",
    "sunColor",
    "defaultTheme",
    "localStorageKey",
    "style"
  ]);
  const [savedTheme, setTheme, _clearLS] = use_local_storage_default(
    localStorageKey,
    defaultTheme,
    { raw: true }
  );
  const properties = useMemo(() => {
    if (animationProperties !== darkModeToggleDefaultProperties) {
      return Object.assign(darkModeToggleDefaultProperties, animationProperties);
    }
    return animationProperties;
  }, [animationProperties]);
  const isDarkTheme = savedTheme === "dark";
  const { circle, svg, lines, mask } = properties[savedTheme != null ? savedTheme : defaultTheme];
  const { springConfig } = animationProperties;
  const svgContainerProps = useSpring(__spreadProps(__spreadValues({}, svg), { config: springConfig }));
  const centerCircleProps = useSpring(__spreadProps(__spreadValues({}, circle), { config: springConfig }));
  const maskedCircleProps = useSpring(__spreadProps(__spreadValues({}, mask), { config: springConfig }));
  const linesProps = useSpring(__spreadProps(__spreadValues({}, lines), { config: springConfig }));
  const handleThemeChange = (theme2) => {
    updateDocumentClasses(theme2);
    setTheme(theme2);
    onChange == null ? undefined : onChange(theme2);
  };
  const toggle = () => handleThemeChange(isDarkTheme ? "light" : "dark");
  useEffect(() => {
    if (savedTheme === theme) {
      return;
    }
    handleThemeChange(savedTheme != null ? savedTheme : "light");
  }, []);
  const uniqueMaskId = `circle-mask-${savedTheme}`;
  const color = isDarkTheme ? moonColor : sunColor;
  return /* @__PURE__ */ jsx(Fragment, { children: /* @__PURE__ */ jsxs(
    animated.svg,
    __spreadProps(__spreadValues({
      xmlns: "http://www.w3.org/2000/svg",
      width: size,
      height: size,
      viewBox: "0 0 24 24",
      color,
      fill: "none",
      strokeWidth: "2",
      strokeLinecap: "round",
      strokeLinejoin: "round",
      stroke: "currentColor",
      onClick: toggle,
      className: "hover:opacity-75 cursor-pointer",
      style: __spreadValues(__spreadValues({
        cursor: "pointer"
      }, svgContainerProps), style)
    }, rest), {
      children: [
        /* @__PURE__ */ jsxs("mask", { id: uniqueMaskId, children: [
          /* @__PURE__ */ jsx("rect", { x: "0", y: "0", width: "100%", height: "100%", fill: "white" }),
          /* @__PURE__ */ jsx(
            animated.circle,
            {
              style: maskedCircleProps,
              r: "9",
              fill: "black"
            }
          )
        ] }),
        /* @__PURE__ */ jsx(
          animated.circle,
          {
            cx: "12",
            cy: "12",
            fill: color,
            style: centerCircleProps,
            mask: `url(#${uniqueMaskId})`
          }
        ),
        /* @__PURE__ */ jsxs(animated.g, { stroke: "currentColor", style: linesProps, children: [
          /* @__PURE__ */ jsx("line", { x1: "12", y1: "1", x2: "12", y2: "3" }),
          /* @__PURE__ */ jsx("line", { x1: "12", y1: "21", x2: "12", y2: "23" }),
          /* @__PURE__ */ jsx("line", { x1: "4.22", y1: "4.22", x2: "5.64", y2: "5.64" }),
          /* @__PURE__ */ jsx("line", { x1: "18.36", y1: "18.36", x2: "19.78", y2: "19.78" }),
          /* @__PURE__ */ jsx("line", { x1: "1", y1: "12", x2: "3", y2: "12" }),
          /* @__PURE__ */ jsx("line", { x1: "21", y1: "12", x2: "23", y2: "12" }),
          /* @__PURE__ */ jsx("line", { x1: "4.22", y1: "19.78", x2: "5.64", y2: "18.36" }),
          /* @__PURE__ */ jsx("line", { x1: "18.36", y1: "5.64", x2: "19.78", y2: "4.22" })
        ] })
      ]
    })
  ) });
};

// src/types/base.ts
var DATE_TYPES = [
  //
  "date",
  "datetime-local",
  "month",
  "time",
  "week"
];
var INPUT_TYPES = [
  "email",
  "number",
  "password",
  "search",
  "tel",
  "text",
  "url",
  "color",
  "file"
];

// src/types/ui.ts
var ELEMENT_COLOR = [
  "primary",
  "error",
  "warning",
  "success",
  "mono"
];
var ELEMENT_THEMES = ["dark", "light"];
var ELEMENT_BASE_VARIANTS = ["contained", "outlined"];
var ELEMENT_VARIANTS = [...ELEMENT_BASE_VARIANTS, "text"];
var INPUT_VARIANTS = [
  ...ELEMENT_BASE_VARIANTS,
  "underline",
  "text"
];
var ELEMENT_ORIENTATION = ["vertical", "horizontal"];
var ELEMENT_PLACEMENT_VERTICAL = ["top", "bottom"];
var ELEMENT_PLACEMENT_HORIZONTAL = ["right", "left"];
var ELEMENT_POSITION = ["top", "bottom", "right", "left"];
var TYPOGRAPHY = [
  "h1",
  "h2",
  "h3",
  "h4",
  "h5",
  "h6",
  "content",
  "description"
];
var TAILWIND_SHADES = [
  50,
  100,
  200,
  300,
  400,
  500,
  600,
  700,
  800,
  900
];
var ELEMENT_STATES = [
  "hover",
  "focus",
  "active",
  "disabled",
  "default"
];
var classes2 = cva([
  "cursor-pointer",
  "absolute",
  "-translate-y-1/2",
  "-translate-x-1/2",
  "right-0",
  "bottom-0"
]);
var EndAdornment = ({ children }) => /* @__PURE__ */ jsx(
  "span",
  {
    className: "absolute right-0 top-1/2 -translate-y-1/2 -translate-x-1/2",
    children
  }
);
var StartAdornment = ({ children }) => /* @__PURE__ */ jsx("span", { className: "absolute left-0 top-1/2 -translate-y-1/2 translate-x-1/2", children });
var InputBase = ({
  startAdornment,
  endAdornment,
  clearable,
  onClear,
  children,
  className
}) => {
  return /* @__PURE__ */ jsxs("span", { "data-slot": "control", className: twMerge("relative", className), children: [
    startAdornment && /* @__PURE__ */ jsx(StartAdornment, { children: startAdornment }),
    children,
    endAdornment && /* @__PURE__ */ jsx(EndAdornment, { children: endAdornment }),
    clearable && /* @__PURE__ */ jsx(Icon, { icon: "close", onClick: onClear, className: classes2() })
  ] });
};
var inputStyles = cva(
  [
    // Basic layout
    "relative",
    "block",
    "w-full",
    "h-[var(--ui-height)]",
    "appearance-none",
    // Typography
    "text-base/6",
    "text-neutral-950",
    "placeholder:text-neutral-500",
    "sm:text-sm/6",
    "dark:text-white",
    // Border
    "border-neutral-950/10",
    "data-hover:border-neutral-950/20",
    "dark:border-white/10",
    "dark:data-hover:border-white/20",
    // Background color
    // 'dark:bg-white/5',
    // Hide default focus styles
    "focus:outline-hidden",
    // Invalid state
    "data-invalid:border-error",
    "data-invalid:data-hover:border-error",
    "dark:data-invalid:border-error",
    "dark:data-invalid:data-hover:border-error",
    // Disabled state
    "data-disabled:border-neutral-950/20",
    "dark:data-disabled:border-white/15",
    "dark:data-disabled:bg-white/[2.5%]",
    "dark:data-hover:data-disabled:border-white/15",
    // System icons
    "dark:[color-scheme:dark]"
  ],
  {
    variants: {
      isDateType: {
        true: [
          "[&::-webkit-datetime-edit-fields-wrapper]:p-0",
          "[&::-webkit-date-and-time-value]:min-h-[1.5em]",
          "[&::-webkit-datetime-edit]:inline-flex",
          "[&::-webkit-datetime-edit]:p-0",
          "[&::-webkit-datetime-edit-year-field]:p-0",
          "[&::-webkit-datetime-edit-month-field]:p-0",
          "[&::-webkit-datetime-edit-day-field]:p-0",
          "[&::-webkit-datetime-edit-hour-field]:p-0",
          "[&::-webkit-datetime-edit-minute-field]:p-0",
          "[&::-webkit-datetime-edit-second-field]:p-0",
          "[&::-webkit-datetime-edit-millisecond-field]:p-0",
          "[&::-webkit-datetime-edit-meridiem-field]:p-0"
        ],
        false: []
      },
      adornments: {
        start: [
          "[--input-pl:calc(--spacing(3.5)-1px+var(--ui-icon-height))]",
          "[--input-pr:calc(--spacing(3.5)-1px)]"
        ],
        end: [
          "[--input-pr:calc(--spacing(3.5)-1px+var(--ui-icon-height))]",
          "[--input-pl:calc(--spacing(3.5)-1px)]"
        ],
        both: [
          "[--input-pr:calc(--spacing(3.5)-1px+var(--ui-icon-height))]",
          "[--input-pl:calc(--spacing(3.5)-1px+var(--ui-icon-height))]"
        ],
        false: [
          "[--input-pl:calc(--spacing(3.5)-1px)]",
          "[--input-pr:calc(--spacing(3.5)-1px)]"
        ]
      },
      clearable: {
        true: ["[--input-pr-clearable:var(--ui-icon-height)]"],
        false: ["[--input-pr-clearable:0px]"]
      },
      type: {
        default: [
          "py-[calc(--spacing(2.5)-1px)]",
          "pr-[calc(var(--input-pr)+var(--input-pr-clearable))]",
          "pl-[calc(var(--input-pl))]"
        ],
        file: [
          "py-[2px]",
          "pr-[calc(var(--input-pr)+var(--input-pr-clearable))]",
          "pl-[calc(var(--input-pl))]"
        ],
        color: [
          "py-[1px]",
          "[--input-pl:calc(--spacing(1.5))]",
          "[--input-pr:calc(--spacing(1.5))]",
          "[&::-webkit-color-swatch]:rounded-sm",
          "[&::-webkit-color-swatch]:border-none"
        ]
      },
      border: {
        full: ["border", "rounded-md"],
        bottom: ["border-b"],
        none: ["border-none"]
      },
      background: {
        true: ["bg-background-secondary/50", "dark:bg-background-secondary/20"],
        false: ["bg-transparent"]
      }
    },
    defaultVariants: {
      adornments: false,
      isDateType: false,
      type: "default",
      border: "full",
      background: true
    }
  }
);
var Input2 = forwardRef(function Input3(_a, ref) {
  var _b = _a, {
    onClear,
    startAdornment,
    endAdornment,
    cx,
    border,
    background
  } = _b, props = __objRest(_b, [
    "onClear",
    "startAdornment",
    "endAdornment",
    "cx",
    "border",
    "background"
  ]);
  const isDateType = Boolean(
    (props == null ? undefined : props.type) && DATE_TYPES.includes(props == null ? undefined : props.type)
  );
  const isTypeStyle = Boolean(
    (props == null ? undefined : props.type) && ["color", "file"].includes(props == null ? undefined : props.type)
  );
  const hasValue = Boolean(props == null ? undefined : props.value);
  const isDisabled = Boolean((props == null ? undefined : props.disabled) || (props == null ? undefined : props.readOnly));
  const clearable = Boolean(
    !isDisabled && typeof onClear === "function" && hasValue
  );
  const adornments = Boolean(startAdornment && endAdornment) ? "both" : !!startAdornment ? "start" : !!endAdornment ? "end" : false;
  return /* @__PURE__ */ jsx(
    InputBase,
    {
      startAdornment,
      endAdornment,
      clearable,
      onClear,
      className: cx == null ? undefined : cx.container,
      type: props.type,
      children: /* @__PURE__ */ jsx(
        Headless11.Input,
        __spreadProps(__spreadValues({
          ref
        }, props), {
          className: inputStyles({
            isDateType,
            adornments,
            clearable,
            className: cx == null ? undefined : cx.input,
            type: isTypeStyle ? props.type : "default",
            border,
            background
          })
        })
      )
    }
  );
});
function InputGroup({
  children
}) {
  return /* @__PURE__ */ jsx(
    "span",
    {
      "data-slot": "control",
      className: clsx13(
        "relative isolate block",
        "has-[[data-slot=icon]:first-child]:[&_input]:pl-10 has-[[data-slot=icon]:last-child]:[&_input]:pr-10 sm:has-[[data-slot=icon]:first-child]:[&_input]:pl-8 sm:has-[[data-slot=icon]:last-child]:[&_input]:pr-8",
        "*:data-[slot=icon]:pointer-events-none *:data-[slot=icon]:absolute *:data-[slot=icon]:top-3 *:data-[slot=icon]:z-10 *:data-[slot=icon]:size-5 sm:*:data-[slot=icon]:top-2.5 sm:*:data-[slot=icon]:size-4",
        "[&>[data-slot=icon]:first-child]:left-3 sm:[&>[data-slot=icon]:first-child]:left-2.5 [&>[data-slot=icon]:last-child]:right-3 sm:[&>[data-slot=icon]:last-child]:right-2.5",
        "*:data-[slot=icon]:text-zinc-500 dark:*:data-[slot=icon]:text-zinc-400"
      ),
      children
    }
  );
}
var PopoverContext = createContext(null);
var usePopoverContext = () => {
  const context = useContext(PopoverContext);
  if (context == null) {
    throw new Error("Popover components must be wrapped in <Popover />");
  }
  return context;
};
function usePopover({
  initialOpen = false,
  placement = "bottom",
  modal,
  open: controlledOpen,
  onOpenChange: setControlledOpen
} = {}) {
  const [uncontrolledOpen, setUncontrolledOpen] = useState(initialOpen);
  const [labelId, setLabelId] = useState();
  const [descriptionId, setDescriptionId] = useState();
  const open = controlledOpen != null ? controlledOpen : uncontrolledOpen;
  const setOpen = setControlledOpen != null ? setControlledOpen : setUncontrolledOpen;
  const data = useFloating({
    placement,
    open,
    onOpenChange: setOpen,
    whileElementsMounted: autoUpdate,
    middleware: [
      offset(5),
      flip({
        fallbackAxisSideDirection: "end",
        padding: 5
      }),
      shift({ padding: 5 })
    ]
  });
  const context = data.context;
  const click = useClick(context, {
    enabled: controlledOpen == null
  });
  const dismiss = useDismiss(context);
  const role = useRole(context);
  const interactions = useInteractions([click, dismiss, role]);
  return useMemo(
    () => __spreadProps(__spreadValues(__spreadValues({
      open,
      setOpen
    }, interactions), data), {
      modal,
      labelId,
      descriptionId,
      setLabelId,
      setDescriptionId
    }),
    [open, setOpen, interactions, data, modal, labelId, descriptionId]
  );
}
var PopoverClose = forwardRef(
  function PopoverClose2(_a, ref) {
    var _b = _a, { className } = _b, props = __objRest(_b, ["className"]);
    const { setOpen } = usePopoverContext();
    return /* @__PURE__ */ jsx(
      "button",
      __spreadProps(__spreadValues({
        type: "button",
        ref
      }, props), {
        className: clsx13(className),
        onClick: (event) => {
          var _a2;
          (_a2 = props.onClick) == null ? undefined : _a2.call(props, event);
          setOpen(false);
        }
      })
    );
  }
);
var popoverContentClasses = clsx13(
  "bg-background-primary",
  "!shadow-lg",
  "rounded-md",
  "py-2",
  "px-3",
  "border",
  "border-border",
  "z-(--ui-z-dropdowns)"
);
var popoverDescriptionClasses = clsx13(
  "text-text-primary/75",
  "text-sm",
  "leading-5"
);
var popoverHeadingClasses = clsx13("font-bold");
var popoverTriggerClasses = clsx13("cursor-pointer");
var PopoverContent = forwardRef(
  function PopoverContent2(_a, propRef) {
    var _b = _a, { className, zIndex } = _b, props = __objRest(_b, ["className", "zIndex"]);
    const _a2 = usePopoverContext(), { context: floatingContext } = _a2, ctx = __objRest(_a2, ["context"]);
    const ref = useMergeRefs([ctx.refs.setFloating, propRef]);
    if (!floatingContext.open) return null;
    const style = __spreadProps(__spreadValues(__spreadValues({}, ctx.floatingStyles), props.style), {
      zIndex
    });
    return /* @__PURE__ */ jsx(FloatingPortal, { children: /* @__PURE__ */ jsx(FloatingFocusManager, { context: floatingContext, modal: ctx.modal, children: /* @__PURE__ */ jsx(
      "div",
      __spreadProps(__spreadValues({
        ref,
        style,
        className: clsx13(popoverContentClasses, className),
        "aria-labelledby": ctx.labelId,
        "aria-describedby": ctx.descriptionId
      }, ctx.getFloatingProps(props)), {
        children: props.children
      })
    ) }) });
  }
);
var PopoverDescription = forwardRef(function PopoverDescription2(_a, ref) {
  var _b = _a, { children, size, className } = _b, props = __objRest(_b, ["children", "size", "className"]);
  const { setDescriptionId } = usePopoverContext();
  const id = useId();
  useLayoutEffect(() => {
    setDescriptionId(id);
    return () => setDescriptionId(undefined);
  }, [id, setDescriptionId]);
  return /* @__PURE__ */ jsx(
    "p",
    __spreadProps(__spreadValues({}, props), {
      ref,
      id,
      className: clsx13(popoverDescriptionClasses, className),
      children
    })
  );
});
var PopoverHeading = forwardRef(function PopoverHeading2(_a, ref) {
  var _b = _a, { children, className } = _b, props = __objRest(_b, ["children", "className"]);
  const { setLabelId } = usePopoverContext();
  const id = useId();
  useLayoutEffect(() => {
    setLabelId(id);
    return () => setLabelId(undefined);
  }, [id, setLabelId]);
  return /* @__PURE__ */ jsx(
    "h2",
    __spreadProps(__spreadValues({}, props), {
      ref,
      id,
      className: clsx13(className, popoverHeadingClasses),
      children
    })
  );
});
function Popover(_a) {
  var _b = _a, {
    children,
    modal = false,
    className
  } = _b, restOptions = __objRest(_b, [
    "children",
    "modal",
    "className"
  ]);
  const popover = usePopover(__spreadValues({ modal }, restOptions));
  return /* @__PURE__ */ jsx(PopoverContext.Provider, { value: __spreadValues({}, popover), children: /* @__PURE__ */ jsx("div", { className, children }) });
}
var PopoverTrigger = forwardRef(
  function PopoverTrigger2(_a, propRef) {
    var _b = _a, { children, asChild = false, className } = _b, props = __objRest(_b, ["children", "asChild", "className"]);
    const ctx = usePopoverContext();
    const childrenRef = children.ref;
    const ref = useMergeRefs([ctx.refs.setReference, propRef, childrenRef]);
    if (asChild && React6.isValidElement(children)) {
      return React6.cloneElement(
        children,
        ctx.getReferenceProps(__spreadProps(__spreadValues(__spreadValues({
          ref
        }, props), children.props), {
          "data-state": ctx.open ? "open" : "closed"
        }))
      );
    }
    return /* @__PURE__ */ jsx(
      "div",
      __spreadProps(__spreadValues({
        ref,
        "data-state": ctx.open ? "open" : "closed"
      }, ctx.getReferenceProps(props)), {
        className: clsx13(className, popoverTriggerClasses),
        children
      })
    );
  }
);
var DatePicker = (props) => {
  var _b;
  const _a = props, { value, onChange } = _a, inputProps = __objRest(_a, ["value", "onChange"]);
  const [popoverVisible, setPopoverVisible] = useState(false);
  const ref = useRef(null);
  const closeCalendar = () => setPopoverVisible(false);
  const handleDateSelect = (date) => {
    onChange == null ? undefined : onChange(date);
    setPopoverVisible(false);
  };
  const handleInputChange = (event) => {
    const inputValue = event.target.value;
    const parsedDate = new Date(inputValue);
    closeCalendar();
    if (!isNaN(parsedDate.valueOf())) {
      onChange == null ? undefined : onChange(parsedDate);
    } else {
      onChange == null ? undefined : onChange(null);
    }
  };
  const clearValue = () => {
    onChange == null ? undefined : onChange(null);
    closeCalendar();
  };
  const handleClick = () => setPopoverVisible(true);
  return /* @__PURE__ */ jsxs(
    Popover,
    {
      open: popoverVisible,
      onOpenChange: setPopoverVisible,
      placement: "bottom-start",
      children: [
        /* @__PURE__ */ jsx(PopoverTrigger, { children: /* @__PURE__ */ jsx(
          Input2,
          __spreadProps(__spreadValues({}, inputProps), {
            ref,
            onClear: clearValue,
            value: value ? value.toLocaleDateString() : "",
            onChange: handleInputChange,
            onClick: handleClick
          })
        ) }),
        /* @__PURE__ */ jsx(
          PopoverContent,
          {
            className: "!p-0 !bg-transparent",
            zIndex: (_b = props.zIndex) == null ? undefined : _b.popover,
            children: /* @__PURE__ */ jsx(
              Calendar_default,
              {
                onChange: handleDateSelect,
                value,
                mode: "date"
              }
            )
          }
        )
      ]
    }
  );
};
var Description2 = (_a) => {
  var _b = _a, { className } = _b, props = __objRest(_b, ["className"]);
  return /* @__PURE__ */ jsx(
    Headless11.Description,
    __spreadProps(__spreadValues({
      "data-slot": "description"
    }, props), {
      className: twMerge(
        className,
        "text-base/6 text-zinc-500 data-disabled:opacity-50 sm:text-sm/6 dark:text-zinc-400"
      )
    })
  );
};
var DescriptionStyles = cva([], { variants: {} });
var overlay = cva(
  [
    "absolute",
    "bg-black/50",
    "flex",
    "justify-center",
    "place-items-center",
    "select-none",
    "overflow-clip",
    "inset-0",
    "h-full",
    "w-full",
    "z-50",
    "z-(--ui-z-overlays)"
  ],
  {
    variants: {
      cursorWait: {
        true: ["cursor-wait"],
        false: ["cursor-default"]
      }
    }
  }
);
var Overlay = ({
  active,
  onClick,
  className,
  cursorWait,
  children
}) => {
  return /* @__PURE__ */ jsx(
    Transition,
    {
      show: !!active,
      as: Fragment$1,
      unmount: false,
      enter: "micro-interactions",
      leave: "micro-interactions",
      enterTo: "opacity-100",
      enterFrom: "opacity-0",
      leaveFrom: "opacity-100",
      leaveTo: "opacity-0",
      children: /* @__PURE__ */ jsx(
        "div",
        {
          className: twMerge(overlay({ cursorWait }), className),
          onClick,
          children
        }
      )
    }
  );
};
var drawerAnimation = {
  animation: ["micro-interactions", "transform"],
  enter: {
    top: ["-translate-y-full"],
    bottom: ["translate-y-full"],
    right: ["translate-x-full"],
    left: ["-translate-x-full"]
  },
  leave: {
    top: ["translate-y-0"],
    bottom: ["translate-y-0"],
    right: ["translate-x-0"],
    left: ["translate-x-0"]
  }
};
var drawerChildClasses = [
  "w-full",
  "overflow-hidden",
  "text-left",
  "shadow-xl",
  "bg-[varbackground-primary]"
];
var drawerStyles = cva(
  ["fixed", "overflow-hidden", "w-full", "h-full", "z-[var(--ui-z-drawers)]"],
  {
    variants: {
      position: {
        bottom: ["inset-x-0", "bottom-0"],
        top: ["inset-x-0", "top-0"],
        right: ["inset-y-0", "right-0"],
        left: ["inset-y-0", "left-0"]
      },
      defaultVariants: {
        position: "right"
      }
    }
  }
);
var Drawer = (_a) => {
  var _b = _a, {
    open,
    children,
    onOverlayClick
  } = _b, props = __objRest(_b, [
    "open",
    "children",
    "onOverlayClick"
  ]);
  var _a2, _b2, _c, _d;
  const { position = "right", onClose = () => {
  }, cx } = props;
  const verticalSize = (_a2 = cx == null ? undefined : cx.height) != null ? _a2 : "h-full";
  const horizontalSize = (_b2 = cx == null ? undefined : cx.width) != null ? _b2 : "w-1/3";
  const finalSize = {
    right: horizontalSize,
    left: horizontalSize,
    top: verticalSize,
    bottom: verticalSize
  }[position];
  return /* @__PURE__ */ jsxs(Fragment, { children: [
    /* @__PURE__ */ jsx(Overlay, { className: "!fixed", active: open, onClick: onOverlayClick }),
    /* @__PURE__ */ jsx(
      Transition,
      {
        show: open,
        as: Fragment$1,
        unmount: false,
        enter: clsx13(drawerAnimation.animation),
        leave: clsx13(drawerAnimation.animation),
        enterFrom: clsx13(drawerAnimation.enter[position]),
        enterTo: clsx13(drawerAnimation.leave[position]),
        leaveFrom: clsx13(drawerAnimation.leave[position]),
        leaveTo: clsx13(drawerAnimation.enter[position]),
        children: /* @__PURE__ */ jsx(
          Dialog,
          {
            unmount: false,
            onClose,
            className: twMerge(
              drawerStyles({
                className: [finalSize, (_c = cx == null ? undefined : cx.container) == null ? undefined : _c.outer],
                position
              })
            ),
            children: /* @__PURE__ */ jsx(
              "div",
              {
                className: clsx13(drawerChildClasses, "h-full", (_d = cx == null ? undefined : cx.container) == null ? undefined : _d.inner),
                children
              }
            )
          }
        )
      }
    )
  ] });
};
var chevron = cva(
  [
    "text-info",
    "ease-in-out",
    "duration-300",
    "hover:text-info",
    "cursor-pointer"
  ],
  {
    variants: {
      open: {
        true: ["rotate-180"]
      }
    }
  }
);
var DropdownChevron = (_a) => {
  var _b = _a, {
    open,
    className
  } = _b, props = __objRest(_b, [
    "open",
    "className"
  ]);
  return /* @__PURE__ */ jsx(
    Icon,
    __spreadValues({
      icon: "chevron_down",
      className: chevron({ open, className }),
      "aria-hidden": "true"
    }, props)
  );
};
var DropdownChevronStyles = cva([], { variants: {} });
var Error2 = (_a) => {
  var _b = _a, { className } = _b, props = __objRest(_b, ["className"]);
  return /* @__PURE__ */ jsx(
    Headless11.Description,
    __spreadProps(__spreadValues({
      "data-slot": "error"
    }, props), {
      className: twMerge(className, "text-base/6 text-red-600 data-disabled:opacity-50 sm:text-sm/6 dark:text-red-500")
    })
  );
};
var fieldStyles = cva(["f"], {
  variants: {
    layout: {
      column: [
        // Base layout
        "flex",
        "flex-col",
        "gap-1",
        // Label layout
        "*:data-[slot=label]:font-medium"
      ],
      row: [
        // Base layout
        // 'grid grid-cols-[1.125rem_1fr] items-center gap-x-2 gap-y-1 sm:grid-cols-[1rem_1fr]',
        "grid grid-cols-[auto_minmax(0,1fr)] items-center gap-x-3 gap-y-1 sm:gap-x-2",
        // Control layout
        "*:data-[slot=control]:col-start-1 *:data-[slot=control]:row-start-1 *:data-[slot=control]:justify-self-center",
        // Label layout
        "*:data-[slot=label]:col-start-2 *:data-[slot=label]:row-start-1 *:data-[slot=label]:justify-self-start",
        // Description layout
        "*:data-[slot=description]:col-start-2 *:data-[slot=description]:row-start-2",
        // Error layout
        "*:data-[slot=error]:col-start-2 *:data-[slot=error]:row-start-3",
        // With description
        "has-data-[slot=description]:**:data-[slot=label]:font-medium"
      ]
    }
  },
  defaultVariants: {
    layout: "column"
  }
});
var Field2 = (_a) => {
  var _b = _a, {
    className,
    layout = "column"
  } = _b, props = __objRest(_b, [
    "className",
    "layout"
  ]);
  return /* @__PURE__ */ jsx(Headless11.Field, __spreadProps(__spreadValues({}, props), { className: fieldStyles({ className, layout }) }));
};
var flexClasses = cva("flex", {
  variants: {
    column: {
      true: "flex-col",
      false: "flex-row"
    },
    justify: {
      start: "justify-start",
      end: "justify-end",
      center: "justify-center",
      between: "justify-between",
      around: "justify-around",
      evenly: "justify-evenly"
    },
    items: {
      start: "items-start",
      end: "items-end",
      center: "items-center",
      baseline: "items-baseline",
      stretch: "items-stretch"
    },
    self: {
      auto: "self-auto	",
      start: "self-start",
      end: "self-end	",
      center: "self-center	",
      stretch: "self-stretch",
      baseline: "self-baseline"
    },
    wrap: {
      none: "flex-nowrap",
      wrap: "flex-wrap",
      reverse: "flex-wrap-reverse"
    },
    content: {
      start: "content-start",
      end: "content-end",
      center: "content-center",
      between: "content-between",
      around: "content-around",
      evenly: "content-evenly"
    },
    gapX: {
      0: "gap-x-0",
      1: "gap-x-1",
      2: "gap-x-2",
      3: "gap-x-3",
      4: "gap-x-4",
      5: "gap-x-5",
      6: "gap-x-6",
      7: "gap-x-7",
      8: "gap-x-8",
      9: "gap-x-9",
      10: "gap-x-10",
      11: "gap-x-11",
      12: "gap-x-12",
      14: "gap-x-14",
      16: "gap-x-16",
      20: "gap-x-20",
      24: "gap-x-24",
      28: "gap-x-28",
      32: "gap-x-32",
      36: "gap-x-36",
      40: "gap-x-40",
      44: "gap-x-44",
      48: "gap-x-48",
      52: "gap-x-52",
      56: "gap-x-56",
      60: "gap-x-60",
      64: "gap-x-64",
      72: "gap-x-72",
      80: "gap-x-80",
      96: "gap-x-96"
    },
    gapY: {
      0: "gap-y-0",
      1: "gap-y-1",
      2: "gap-y-2",
      3: "gap-y-3",
      4: "gap-y-4",
      5: "gap-y-5",
      6: "gap-y-6",
      7: "gap-y-7",
      8: "gap-y-8",
      9: "gap-y-9",
      10: "gap-y-10",
      11: "gap-y-11",
      12: "gap-y-12",
      14: "gap-y-14",
      16: "gap-y-16",
      20: "gap-y-20",
      24: "gap-y-24",
      28: "gap-y-28",
      32: "gap-y-32",
      36: "gap-y-36",
      40: "gap-y-40",
      44: "gap-y-44",
      48: "gap-y-48",
      52: "gap-y-52",
      56: "gap-y-56",
      60: "gap-y-60",
      64: "gap-y-64",
      72: "gap-y-72",
      80: "gap-y-80",
      96: "gap-y-96"
    },
    grow: {
      false: "flex-grow-0",
      true: "flex-grow"
    },
    shrink: {
      false: "flex-shrink-0",
      true: "flex-shrink"
    }
  }
});
var Flex = (_a) => {
  var _b = _a, {
    children,
    className,
    title,
    onClick
  } = _b, props = __objRest(_b, [
    "children",
    "className",
    "title",
    "onClick"
  ]);
  return /* @__PURE__ */ jsx("div", __spreadProps(__spreadValues({}, { title, onClick }), { className: flexClasses(__spreadProps(__spreadValues({}, props), { className })), children }));
};
function _For({ each, children }) {
  if (!each) {
    console.error("CUI: The `each` prop of [For] is undefined");
    return null;
  }
  if (!children) {
    console.error("CUI: The `children` method of [For] is undefined");
  }
  return /* @__PURE__ */ jsx(Fragment, { children: each == null ? undefined : each.map((item, index) => children == null ? undefined : children(item, index)) });
}
var For = memo(_For);
var Highlighter = ({
  searchWords,
  textToHighlight
}) => {
  if (!searchWords || !searchWords.length) return textToHighlight;
  const regex = new RegExp(`(${searchWords.join("|")})`, "gi");
  const parts = textToHighlight.split(regex).filter(Boolean);
  return /* @__PURE__ */ jsx("span", { children: parts.map(
    (part, index) => searchWords.some((word) => word.toLowerCase() === part.toLowerCase()) ? /* @__PURE__ */ jsx("mark", { className: "highlighter", children: part }, index) : part
  ) });
};
var HighlighterStyles = cva([], { variants: {} });
var labelStyles = cva(
  [
    "text-base/6",
    "text-neutral-950",
    "select-none",
    "data-disabled:opacity-50",
    "sm:text-sm/6",
    "dark:text-white"
  ],
  {
    variants: {
      required: {
        true: ["after:content-['*']", "after:ml-0.5", "after:text-error"]
      }
    }
  }
);
var Label = (_a) => {
  var _b = _a, { className, required } = _b, props = __objRest(_b, ["className", "required"]);
  return /* @__PURE__ */ jsx(
    Label$1,
    __spreadProps(__spreadValues({
      "data-slot": "label"
    }, props), {
      className: labelStyles({ className, required })
    })
  );
};
var LoadingOverlay = (_a) => {
  var _b = _a, { cx } = _b, props = __objRest(_b, ["cx"]);
  const _a2 = props, { loaderColor = "white" } = _a2, rest = __objRest(_a2, ["loaderColor"]);
  return /* @__PURE__ */ jsx(Overlay, __spreadProps(__spreadValues({}, rest), { cursorWait: true, className: clsx13(cx == null ? undefined : cx.overlay), children: /* @__PURE__ */ jsx(Loader, { color: loaderColor, cx: cx == null ? undefined : cx.loader }) }));
};
var LoadingOverlayStyles = cva([], { variants: {} });
var Modal = (_a) => {
  var _b = _a, { className, children } = _b, props = __objRest(_b, ["className", "children"]);
  return /* @__PURE__ */ jsxs(Dialog, __spreadProps(__spreadValues({}, props), { children: [
    /* @__PURE__ */ jsx(
      DialogBackdrop,
      {
        transition: true,
        className: clsx13(
          "fixed",
          "inset-0",
          "flex",
          "w-screen",
          "justify-center",
          "overflow-y-auto",
          "transition",
          "micro-interactions",
          "focus:outline-0",
          "data-closed:opacity-0",
          "data-enter:ease-out",
          "data-leave:ease-in",
          "bg-black/50",
          "z-(--ui-z-overlays)"
        )
      }
    ),
    /* @__PURE__ */ jsx(
      "div",
      {
        className: clsx13([
          "z-(--ui-z-modals)",
          "fixed",
          "inset-0",
          "w-screen",
          "overflow-y-auto"
        ]),
        children: /* @__PURE__ */ jsx(
          "div",
          {
            className: clsx13([
              "grid",
              "min-h-full",
              "grid-rows-[1fr_auto_1fr]",
              "justify-items-center",
              "sm:grid-rows-[1fr_auto_3fr]",
              "sm:p-4"
            ]),
            children: /* @__PURE__ */ jsx(
              DialogPanel,
              {
                transition: true,
                className: clsx13(className, [
                  "row-start-2",
                  "w-full",
                  "rounded-md",
                  "ring-1",
                  "shadow-xl",
                  "ring-zinc-950/10",
                  "dark:ring-white/10",
                  "forced-colors:outline",
                  "transition",
                  "duration-100",
                  "will-change-transform",
                  "data-closed:opacity-0",
                  "data-enter:ease-out",
                  "data-closed:data-enter:scale-95",
                  "data-leave:ease-in",
                  "bg-background-primary"
                ]),
                children
              }
            )
          }
        )
      }
    )
  ] }));
};
var ModalHeader = (_a) => {
  var _b = _a, {
    className,
    border
  } = _b, props = __objRest(_b, [
    "className",
    "border"
  ]);
  return /* @__PURE__ */ jsx(
    DialogTitle,
    __spreadProps(__spreadValues({}, props), {
      className: clsx13(
        className,
        "flex items-center gap-4 py-5 px-6 ",
        border && "border-b border-border"
      )
    })
  );
};
var ModalBody = (_a) => {
  var _b = _a, {
    className
  } = _b, props = __objRest(_b, [
    "className"
  ]);
  return /* @__PURE__ */ jsx("div", __spreadProps(__spreadValues({}, props), { className: clsx13(className, "px-6") }));
};
var ModalFooter = (_a) => {
  var _b = _a, {
    className,
    border
  } = _b, props = __objRest(_b, [
    "className",
    "border"
  ]);
  return /* @__PURE__ */ jsx(
    "div",
    __spreadProps(__spreadValues({}, props), {
      className: clsx13(
        className,
        "px-6 py-3 flex flex-col-reverse items-center justify-end gap-3 *:w-full sm:mt-4 sm:flex-row sm:*:w-auto",
        border && "border-t border-border"
      )
    })
  );
};
var ModalStyles = cva([], { variants: {} });
var radioGroupStyles = cva(
  [
    // Basic groups
    "space-y-3",
    "**:data-[slot=label]:font-normal",
    // With descriptions
    "has-data-[slot=description]:space-y-6",
    "has-data-[slot=description]:**:data-[slot=label]:font-medium"
  ],
  {
    variants: {}
  }
);
var radioStyles = cva(
  [
    // Basic layout
    "relative",
    "isolate",
    "flex",
    "size-[1.1875rem]",
    "shrink-0",
    "rounded-full",
    "sm:size-[1.0625rem]",
    // Background color + shadow applied to inset pseudo element, so shadow blends with border in light mode
    "before:absolute",
    "before:inset-0",
    "before:-z-10",
    "before:rounded-full",
    "before:bg-white",
    "before:shadow-sm",
    // Background color when checked
    "group-data-checked:before:bg-(--radio-checked-bg)",
    // Background color is moved to control and shadow is removed in dark mode so hide `before` pseudo
    "dark:before:hidden",
    // Background color applied to control in dark mode
    "dark:bg-white/5",
    "dark:group-data-checked:bg-(--radio-checked-bg)",
    // Border
    "border",
    "border-neutral-950/15",
    "group-data-checked:border-transparent",
    "group-data-hover:group-data-checked:border-transparent",
    "group-data-hover:border-neutral-950/30",
    "group-data-checked:bg-(--radio-checked-border)",
    "dark:border-white/15 dark:group-data-checked:border-white/5 dark:group-data-hover:group-data-checked:border-white/5 dark:group-data-hover:border-white/30",
    // Inner highlight shadow
    "after:absolute",
    "after:inset-0",
    "after:rounded-full",
    "after:shadow-[inset_0_1px_--theme(--color-white/15%)]",
    "dark:after:-inset-px",
    "dark:after:hidden",
    "dark:after:rounded-full",
    "dark:group-data-checked:after:block",
    // Indicator color (light mode)
    "[--radio-indicator:transparent]",
    "group-data-checked:[--radio-indicator:var(--radio-checked-indicator)]",
    "group-data-hover:group-data-checked:[--radio-indicator:var(--radio-checked-indicator)]",
    "group-data-hover:[--radio-indicator:var(--color-neutral-900)]/10",
    // Indicator color (dark mode)
    "dark:group-data-hover:group-data-checked:[--radio-indicator:var(--radio-checked-indicator)]",
    "dark:group-data-hover:[--radio-indicator:var(--color-neutral-700)]",
    // Focus ring
    "group-data-focus:outline",
    "group-data-focus:outline-2",
    "group-data-focus:outline-offset-2",
    "group-data-focus:outline-blue-500",
    // Disabled state
    "group-data-disabled:opacity-50",
    "group-data-disabled:border-neutral-950/25",
    "group-data-disabled:bg-neutral-950/5",
    "group-data-disabled:[--radio-checked-indicator:var(--color-neutral-950)]/50",
    "group-data-disabled:before:bg-transparent",
    "dark:group-data-disabled:border-white/20",
    "dark:group-data-disabled:bg-white/[2.5%]",
    "dark:group-data-disabled:[--radio-checked-indicator:var(--color-white)]/50",
    "dark:group-data-checked:group-data-disabled:after:hidden",
    // Color
    "[--radio-checked-bg:var(--color-neutral-900)]",
    "[--radio-checked-border:var(--color-neutral-950)]/90",
    "[--radio-checked-indicator:var(--color-white)]",
    "dark:[--radio-checked-bg:var(--color-neutral-600)]"
  ],
  {
    variants: {}
  }
);
var Radio2 = (_a) => {
  var _b = _a, { className } = _b, props = __objRest(_b, ["className"]);
  return /* @__PURE__ */ jsx(
    Headless11.Radio,
    __spreadProps(__spreadValues({
      "data-slot": "control"
    }, props), {
      className: clsx13(className, "group inline-flex focus:outline-hidden"),
      children: /* @__PURE__ */ jsx("span", { className: radioStyles(), children: /* @__PURE__ */ jsx(
        "span",
        {
          className: clsx13(
            "size-full",
            "rounded-full",
            "border-[4.5px]",
            "border-transparent",
            "bg-(--radio-indicator)",
            "bg-clip-padding",
            // Forced colors mode
            "forced-colors:border-[Canvas]",
            "forced-colors:group-data-checked:border-[Highlight]"
          )
        }
      ) })
    })
  );
};
var RadioGroup2 = (_a) => {
  var _b = _a, { className } = _b, props = __objRest(_b, ["className"]);
  return /* @__PURE__ */ jsx(
    Headless11.RadioGroup,
    __spreadProps(__spreadValues({
      "data-slot": "control"
    }, props), {
      className: radioGroupStyles({ className })
    })
  );
};
var Select2 = forwardRef(function Select3(_a, ref) {
  var _b = _a, {
    cx,
    multiple,
    startAdornment,
    endAdornment,
    onClear
  } = _b, props = __objRest(_b, [
    "cx",
    "multiple",
    "startAdornment",
    "endAdornment",
    "onClear"
  ]);
  const hasValue = Boolean(props.value);
  const isDisabled = Boolean(props.disabled || props.readOnly);
  const clearable = Boolean(
    !isDisabled && typeof onClear === "function" && hasValue
  );
  const adornments = Boolean(startAdornment && endAdornment) ? "both" : !!startAdornment ? "start" : !!endAdornment ? "end" : false;
  return /* @__PURE__ */ jsxs(
    InputBase,
    {
      className: cx == null ? undefined : cx.container,
      endAdornment,
      startAdornment,
      onClear,
      children: [
        /* @__PURE__ */ jsx(
          Headless11.Select,
          __spreadProps(__spreadValues({
            ref,
            multiple
          }, props), {
            className: inputStyles({
              adornments,
              clearable,
              className: [
                // Basic layout
                "relative block w-full appearance-none rounded-lg py-[calc(--spacing(2.5)-1px)] sm:py-[calc(--spacing(1.5)-1px)]",
                // Horizontal padding
                multiple ? "px-[calc(--spacing(3.5)-1px)] sm:px-[calc(--spacing(3)-1px)]" : "pr-[calc(--spacing(10)-1px)] pl-[calc(--spacing(3.5)-1px)] sm:pr-[calc(--spacing(9)-1px)] sm:pl-[calc(--spacing(3)-1px)]",
                // Options (multi-select)
                "[&_optgroup]:font-semibold"
              ]
            })
          })
        ),
        !multiple && /* @__PURE__ */ jsx("span", { className: "pointer-events-none absolute inset-y-0 right-0 flex items-center pr-2", children: /* @__PURE__ */ jsxs(
          "svg",
          {
            className: "size-5 stroke-zinc-500 group-has-data-disabled:stroke-zinc-600 sm:size-4 dark:stroke-zinc-400 forced-colors:stroke-[CanvasText]",
            viewBox: "0 0 16 16",
            "aria-hidden": "true",
            fill: "none",
            children: [
              /* @__PURE__ */ jsx(
                "path",
                {
                  d: "M5.75 10.75L8 13L10.25 10.75",
                  strokeWidth: 1.5,
                  strokeLinecap: "round",
                  strokeLinejoin: "round"
                }
              ),
              /* @__PURE__ */ jsx(
                "path",
                {
                  d: "M10.25 5.25L8 3L5.75 5.25",
                  strokeWidth: 1.5,
                  strokeLinecap: "round",
                  strokeLinejoin: "round"
                }
              )
            ]
          }
        ) })
      ]
    }
  );
});

// src/shared/get-dropdown-height.ts
var asPx = (value) => `${value}px`;
var getDropdownHeight = (maxHeight = 500, availableHeight) => {
  if (typeof maxHeight === "number") {
    return maxHeight >= availableHeight ? asPx(availableHeight) : asPx(maxHeight);
  }
  return maxHeight === "available" ? asPx(availableHeight) : maxHeight;
};
var classes3 = clsx13(["text-info", "cursor-default"]);
var Placeholder = ({ children }) => /* @__PURE__ */ jsx("span", { className: classes3, children });
var dropdownMenuClasses = cva(
  [
    "bg-background-portal",
    "border-border",
    "border",
    "shadow-md",
    "w-fit",
    "rounded-md",
    "flex",
    "flex-col",
    "items-start",
    "text-left",
    "gap-1",
    "p-1",
    "z-(--ui-z-dropdowns)"
  ],
  {
    variants: {
      open: { true: "block", false: "hidden" },
      placement: {
        top: ["!mb-1"],
        bottom: ["!mt-0"]
      }
    }
  }
);
var DropdownMenu = forwardRef(
  (_a, ref) => {
    var _b = _a, { children, open, className, placement } = _b, props = __objRest(_b, ["children", "open", "className", "placement"]);
    return /* @__PURE__ */ jsx(
      "ul",
      __spreadProps(__spreadValues({
        ref
      }, props), {
        className: dropdownMenuClasses({ open, className, placement }),
        children
      })
    );
  }
);
var Show = ({ when, children, fallback = null }) => when ? /* @__PURE__ */ jsx(Fragment, { children }) : /* @__PURE__ */ jsx(Fragment, { children: fallback });
var switchDot = clsx13(
  // Basic layout
  "pointer-events-none",
  "relative",
  "inline-block",
  "size-[1.125rem]",
  "rounded-full",
  "sm:size-3.5",
  // Transition
  "translate-x-0",
  "micro-interactions",
  // Invisible border so the switch is still visible in forced-colors mode
  "border border-transparent",
  // Unchecked
  "bg-white",
  "ring-1",
  "shadow-sm",
  "ring-black/5",
  // Checked
  "group-data-checked:bg-(--switch)",
  "group-data-checked:shadow-(--switch-shadow)",
  "group-data-checked:ring-(--switch-ring)",
  "group-data-checked:translate-x-4 sm:group-data-checked:translate-x-3",
  // Disabled
  "group-data-checked:group-data-disabled:bg-white",
  "group-data-checked:group-data-disabled:shadow-sm",
  "group-data-checked:group-data-disabled:ring-black/5"
);
var switchClasses = cva(
  [
    "group",
    "relative",
    "isolate",
    "inline-flex",
    "h-6",
    "w-10",
    "cursor-default",
    "rounded-full",
    "p-[3px]",
    "sm:h-5 sm:w-8",
    "forced-colors:outline",
    "forced-colors:[--switch-bg:Highlight]",
    "dark:forced-colors:[--switch-bg:Highlight]",
    // Unchecked
    "bg-neutral-200",
    "ring-1",
    "ring-black/5",
    "ring-inset",
    "dark:bg-white/5",
    "dark:ring-white/15",
    // Checked
    "data-checked:bg-(--switch-bg)",
    "data-checked:ring-(--switch-bg-ring)",
    // Focus
    "focus:outline-hidden",
    "data-focus:outline",
    "data-focus:outline-2",
    "data-focus:outline-offset-2",
    "data-focus:outline-blue-500",
    // Hover
    "data-hover:ring-black/15",
    "data-hover:data-checked:ring-(--switch-bg-ring)",
    "dark:data-hover:ring-white/25",
    "dark:data-hover:data-checked:ring-(--switch-bg-ring)",
    // Disabled
    "data-disabled:bg-neutral-200",
    "data-disabled:opacity-50",
    "data-disabled:data-checked:bg-neutral-200",
    "data-disabled:data-checked:ring-black/5",
    "dark:data-disabled:bg-white/15",
    "dark:data-disabled:data-checked:bg-white/15",
    "dark:data-disabled:data-checked:ring-white/15",
    // Color specific styles
    "[--switch-bg-ring:theme(colors.primary)]/90",
    "[--switch-bg:theme(colors.primary)]",
    "dark:[--switch-bg-ring:transparent]",
    "[--switch:white]",
    "[--switch-ring:theme(colors.primary)]/90",
    "[--switch-shadow:theme(colors.primary)]/20"
  ],
  {
    variants: {}
  }
);
function SwitchField(_a) {
  var _b = _a, {
    className
  } = _b, props = __objRest(_b, [
    "className"
  ]);
  return /* @__PURE__ */ jsx(
    Headless11.Field,
    __spreadProps(__spreadValues({
      "data-slot": "field"
    }, props), {
      className: clsx13(
        className,
        // Base layout
        "grid grid-cols-[1fr_auto] items-center gap-x-8 gap-y-1 sm:grid-cols-[1fr_auto]",
        // Control layout
        "*:data-[slot=control]:col-start-2 *:data-[slot=control]:self-center",
        // Label layout
        "*:data-[slot=label]:col-start-1 *:data-[slot=label]:row-start-1 *:data-[slot=label]:justify-self-start",
        // Description layout
        "*:data-[slot=description]:col-start-1 *:data-[slot=description]:row-start-2",
        // With description
        "has-data-[slot=description]:**:data-[slot=label]:font-medium"
      )
    })
  );
}
function Switch2(_a) {
  var _b = _a, props = __objRest(_b, [
    "className"
  ]);
  return /* @__PURE__ */ jsx(Headless11.Switch, __spreadProps(__spreadValues({ "data-slot": "control" }, props), { className: switchClasses(), children: /* @__PURE__ */ jsx("span", { "aria-hidden": "true", className: switchDot }) }));
}
var TextareaStyles = cva([], { variants: {} });
var containerClasses = [
  // Basic layout
  "relative",
  "block",
  "w-full",
  // Background color + shadow applied to inset pseudo element, so shadow blends with border in light mode
  "before:absolute",
  "before:inset-px before:rounded-[calc(var(--radius-lg)-1px)]",
  "before:bg-white before:shadow-sm",
  // Background color is moved to control and shadow is removed in dark mode so hide `before` pseudo
  "dark:before:hidden",
  // Focus ring
  "after:pointer-events-none",
  "after:absolute",
  "after:inset-0",
  "after:rounded-lg",
  "after:ring-transparent",
  "after:ring-inset",
  "sm:focus-within:after:ring-2",
  "sm:focus-within:after:ring-primary",
  // Disabled state
  "has-data-disabled:opacity-50",
  "has-data-disabled:before:bg-zinc-950/5",
  "has-data-disabled:before:shadow-none"
];
var Textarea2 = forwardRef(function Textarea3(_a, ref) {
  var _b = _a, { className, resizable = true } = _b, props = __objRest(_b, ["className", "resizable"]);
  return /* @__PURE__ */ jsx("span", { "data-slot": "control", className: clsx13([className, containerClasses]), children: /* @__PURE__ */ jsx(
    Headless11.Textarea,
    __spreadProps(__spreadValues({
      ref
    }, props), {
      className: clsx13([
        // Basic layout
        "relative",
        "block",
        "h-full",
        "w-full",
        "appearance-none",
        "rounded-lg",
        "px-[calc(--spacing(3.5)-1px)]",
        "py-[calc(--spacing(2.5)-1px)]",
        "sm:px-[calc(--spacing(3)-1px)]",
        "sm:py-[calc(--spacing(1.5)-1px)]",
        // Typography
        "text-base/6",
        "text-neutral-950",
        "placeholder:text-neutral-500",
        "sm:text-sm/6",
        "dark:text-white",
        // Border
        "border",
        "border-neutral-950/10",
        "data-hover:border-neutral-950/20",
        "dark:border-white/10",
        "dark:data-hover:border-white/20",
        // Background color
        "bg-transparent",
        "dark:bg-white/5",
        // Hide default focus styles
        "focus:outline-hidden",
        // Invalid state
        "data-invalid:border-red-500",
        "data-invalid:data-hover:border-red-500",
        "dark:data-invalid:border-error dark:data-invalid:data-hover:border-error",
        // Disabled state
        "disabled:border-neutral-950/20",
        "dark:disabled:border-white/15",
        "dark:disabled:bg-white/[2.5%]",
        "dark:data-hover:disabled:border-white/15",
        // Resizable
        resizable ? "resize-y" : "resize-none"
      ])
    })
  ) });
});

// src/utils/get-element-position.ts
var getElementPosition = (array, index) => {
  switch (true) {
    case index === 0:
      return "first";
    case index === (array == null ? undefined : array.length) - 1:
      return "last";
    default:
      return "middle";
  }
};
var toggleGroupButtonStyles = cva(
  [
    "border-y",
    "border-border",
    "cursor-pointer",
    "focus:z-10",
    "font-medium",
    "hover:bg-primary/10",
    "flex",
    "items-center",
    "justify-center",
    "relative",
    "z-0",
    "h-(--ui-height)",
    "min-w-(--ui-height)"
  ],
  {
    variants: {
      element: groupPositionClasses,
      checked: {
        true: ["bg-primary", "hover:bg-primary/75", "text-white", "font-bold"],
        false: ["hover:bg-primary/20", "text-text-primary"]
      },
      disabled: {
        true: disabled
      }
    }
  }
);
var ToggleGroup = (_a) => {
  var _b = _a, {
    className,
    options,
    onChange,
    value,
    disabled: disabled2
  } = _b, props = __objRest(_b, [
    "className",
    "options",
    "onChange",
    "value",
    "disabled"
  ]);
  return /* @__PURE__ */ jsx(
    RadioGroup,
    __spreadProps(__spreadValues({
      "data-slot": "control"
    }, props), {
      className: twMerge(
        "relative",
        "inline-flex",
        "rounded-md",
        "h-[var(--ui-height)]",
        "max-h-[var(--ui-height)]",
        className
      ),
      disabled: disabled2,
      onChange,
      children: options == null ? undefined : options.map(
        ({ label, value: optionValue, disabled: disabled3 }, index, array) => /* @__PURE__ */ jsx(
          RadioGroup.Option,
          {
            value: optionValue,
            title: optionValue,
            disabled: disabled3,
            className: ({ checked, disabled: disabled4 }) => toggleGroupButtonStyles({
              disabled: disabled4,
              checked,
              element: getElementPosition(array, index)
            }),
            children: /* @__PURE__ */ jsx(RadioGroup.Label, { as: "span", children: label })
          },
          optionValue
        )
      )
    })
  );
};
var tooltipStyles = cva(
  [
    "micro-interactions",
    "pointer-events-none",
    "absolute",
    "whitespace-nowrap",
    "rounded",
    "opacity-0",
    "transition",
    "before:absolute",
    "before:border-4",
    "before:border-transparent",
    "before:content-['']",
    "group-hover:opacity-100",
    "border",
    "shadow-lg",
    "py-1",
    "px-2",
    "border-border",
    "bg-background-secondary",
    "z-(--ui-z-tooltips)",
    "text-sm"
  ],
  {
    variants: {
      position: {
        top: [
          "before:top-full",
          "-top-10",
          "left-1/2",
          "before:border-t-border",
          "-translate-x-1/2",
          "before:left-1/2",
          "before:-translate-x-1/2"
        ],
        bottom: [
          "top-full",
          "mt-2",
          "-translate-x-1/2",
          "left-1/2",
          "before:bottom-full",
          "before:left-1/2",
          "before:-translate-x-1/2",
          "before:border-b-border"
        ],
        left: [
          "right-full",
          "mr-2",
          "-translate-y-1/2",
          "top-1/2",
          "before:left-full",
          "before:top-1/2",
          "before:-translate-y-1/2",
          "before:border-l-border"
        ],
        right: [
          "ml-2",
          "top-1/2",
          "left-full",
          "-translate-y-1/2",
          "before:right-full",
          "before:top-1/2",
          "before:-translate-y-1/2",
          "before:border-r-border"
        ]
      }
    },
    defaultVariants: {
      position: "top"
    }
  }
);
var Tooltip = (props) => {
  const _a = props, { className, position = "top", children, content } = _a, rest = __objRest(_a, ["className", "position", "children", "content"]);
  if (!content) return children;
  return /* @__PURE__ */ jsxs("div", { className: clsx13(["relative", "max-w-fit", "group"]), children: [
    /* @__PURE__ */ jsx("span", __spreadProps(__spreadValues({}, rest), { className: tooltipStyles({ className, position }), children: content })),
    children
  ] });
};
/*! Bundled license information:

lodash/lodash.js:
  (**
   * @license
   * Lodash <https://lodash.com/>
   * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
   * Released under MIT license <https://lodash.com/license>
   * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
   * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
   *)
*/

export { AVATAR_VARIANTS, Autocomplete, AutocompleteContext, Avatar, AvatarGroup, Button2 as Button, Calendar_default as Calendar, Card, CardContent, CardDescription, CardFooter, CardHeader, CardStats, CardStyles, CardTitle, Checkbox2 as Checkbox, Chip, ClearButton, DATE_TYPES, DarkModeToggle, DatePicker, Description2 as Description, DescriptionStyles, Drawer, DropdownChevron, DropdownChevronStyles, DropdownMenu, ELEMENT_BASE_VARIANTS, ELEMENT_COLOR, ELEMENT_ORIENTATION, ELEMENT_PLACEMENT_HORIZONTAL, ELEMENT_PLACEMENT_VERTICAL, ELEMENT_POSITION, ELEMENT_STATES, ELEMENT_THEMES, ELEMENT_VARIANTS, EndAdornment, Error2 as Error, Field2 as Field, Flex, For, Highlighter, HighlighterStyles, INPUT_TYPES, INPUT_VARIANTS, Icon, Input2 as Input, InputBase, InputGroup, Label, Link, Loader, LoadingOverlay, LoadingOverlayStyles, Modal, ModalBody, ModalFooter, ModalHeader, ModalStyles, Overlay, Placeholder, Popover, PopoverClose, PopoverContent, PopoverContext, PopoverDescription, PopoverHeading, PopoverTrigger, Radio2 as Radio, RadioGroup2 as RadioGroup, Select2 as Select, Show, StartAdornment, Switch2 as Switch, SwitchField, TAILWIND_SHADES, TYPOGRAPHY, Textarea2 as Textarea, TextareaStyles, ToggleGroup, Tooltip, TouchTarget, avatarStyles, checkboxStyles, chipClasses, containerClasses, drawerAnimation, drawerChildClasses, drawerStyles, dropdownMenuClasses, fieldStyles, flexClasses, getDropdownHeight, getWidthClasses, icons, isBrowser, isNavigator, labelStyles, noop, off, on, overlay, passThrough, pick, propsGuard, radioGroupStyles, radioStyles, toggleGroupButtonStyles, twix, useAutocomplete, useDetectDarkMode, use_local_storage_default as useLocalStorage, lock_scroll_default as useLockScroll, use_measure_dirty_default as useMeasureDirty, usePopover, usePopoverContext };
//# sourceMappingURL=index.mjs.map
//# sourceMappingURL=index.mjs.map